
/*  A Bison parser, made from Gmsh.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	tDOUBLE	257
#define	tSTRING	258
#define	tBIGSTR	259
#define	tEND	260
#define	tAFFECT	261
#define	tDOTS	262
#define	tPi	263
#define	tMPI_Rank	264
#define	tMPI_Size	265
#define	tExp	266
#define	tLog	267
#define	tLog10	268
#define	tSqrt	269
#define	tSin	270
#define	tAsin	271
#define	tCos	272
#define	tAcos	273
#define	tTan	274
#define	tRand	275
#define	tAtan	276
#define	tAtan2	277
#define	tSinh	278
#define	tCosh	279
#define	tTanh	280
#define	tFabs	281
#define	tFloor	282
#define	tCeil	283
#define	tFmod	284
#define	tModulo	285
#define	tHypot	286
#define	tPrintf	287
#define	tSprintf	288
#define	tStrCat	289
#define	tStrPrefix	290
#define	tStrRelative	291
#define	tBoundingBox	292
#define	tDraw	293
#define	tToday	294
#define	tPoint	295
#define	tCircle	296
#define	tEllipse	297
#define	tLine	298
#define	tSurface	299
#define	tSpline	300
#define	tVolume	301
#define	tCharacteristic	302
#define	tLength	303
#define	tParametric	304
#define	tElliptic	305
#define	tPlane	306
#define	tRuled	307
#define	tTransfinite	308
#define	tComplex	309
#define	tPhysical	310
#define	tUsing	311
#define	tBump	312
#define	tProgression	313
#define	tPlugin	314
#define	tRotate	315
#define	tTranslate	316
#define	tSymmetry	317
#define	tDilate	318
#define	tExtrude	319
#define	tDuplicata	320
#define	tLoop	321
#define	tRecombine	322
#define	tDelete	323
#define	tCoherence	324
#define	tIntersect	325
#define	tAttractor	326
#define	tLayers	327
#define	tAlias	328
#define	tAliasWithOptions	329
#define	tText2D	330
#define	tText3D	331
#define	tInterpolationScheme	332
#define	tTime	333
#define	tCombine	334
#define	tBSpline	335
#define	tBezier	336
#define	tNurbs	337
#define	tOrder	338
#define	tWith	339
#define	tBounds	340
#define	tKnots	341
#define	tColor	342
#define	tColorTable	343
#define	tFor	344
#define	tIn	345
#define	tEndFor	346
#define	tIf	347
#define	tEndIf	348
#define	tExit	349
#define	tReturn	350
#define	tCall	351
#define	tFunction	352
#define	tTrimmed	353
#define	tShow	354
#define	tHide	355
#define	tGetValue	356
#define	tGMSH_MAJOR_VERSION	357
#define	tGMSH_MINOR_VERSION	358
#define	tGMSH_PATCH_VERSION	359
#define	tAFFECTPLUS	360
#define	tAFFECTMINUS	361
#define	tAFFECTTIMES	362
#define	tAFFECTDIVIDE	363
#define	tOR	364
#define	tAND	365
#define	tEQUAL	366
#define	tNOTEQUAL	367
#define	tAPPROXEQUAL	368
#define	tLESSOREQUAL	369
#define	tGREATEROREQUAL	370
#define	tCROSSPRODUCT	371
#define	tPLUSPLUS	372
#define	tMINUSMINUS	373
#define	UNARYPREC	374

#line 1 "Gmsh.y"

// $Id: Gmsh.tab.cpp,v 1.254 2006/01/30 00:40:19 geuzaine Exp $
//
// Copyright (C) 1997-2006 C. Geuzaine, J.-F. Remacle
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA.
// 
// Please report all bugs and problems to <gmsh@geuz.org>.

#include <stdarg.h>
#include <time.h>
#include "PluginManager.h"
#include "ParUtil.h"
#include "Gmsh.h"
#include "Numeric.h"
#include "Context.h"
#include "Geo.h"
#include "GeoUtils.h"
#include "Nurbs.h"
#include "CAD.h"
#include "Mesh.h"
#include "Draw.h"
#include "Create.h"
#include "Views.h"
#include "Options.h"
#include "Colors.h"
#include "Parser.h"
#include "OpenFile.h"
#include "CommandLine.h"
#include "FunctionManager.h"
#include "ColorTable.h"
#include "Timer.h"
#include "CreateFile.h"
#include "Visibility.h"
#include "GmshVersion.h"

Tree_T *Symbol_T = NULL;

extern Context_T CTX;
extern Mesh *THEM;

static ExtrudeParams extr;

static Post_View *View;
static List_T *ViewValueList;
static double ViewCoord[100];
static int *ViewNumList, ViewNumNodes, ViewNumComp, ViewNumListTmp;
static int ViewCoordIdx, ViewElementIdx;
static int ViewErrorFlags[VIEW_NB_ELEMENT_TYPES];

#define MAX_RECUR_LOOPS 100
static int ImbricatedLoop = 0;
static fpos_t yyposImbricatedLoopsTab[MAX_RECUR_LOOPS];
static int yylinenoImbricatedLoopsTab[MAX_RECUR_LOOPS];
static double LoopControlVariablesTab[MAX_RECUR_LOOPS][3];
static char *LoopControlVariablesNameTab[MAX_RECUR_LOOPS];

void yyerror(char *s);
void yymsg(int type, char *fmt, ...);
void skip_until(char *skip, char *until);
int PrintListOfDouble(char *format, List_T *list, char *buffer);
int CheckViewErrorFlags(Post_View *v);

#line 78 "Gmsh.y"
typedef union {
  char *c;
  int i;
  unsigned int u;
  double d;
  double v[5];
  Shape s;
  List_T *l;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		1174
#define	YYFLAG		-32768
#define	YYNTBASE	140

#define YYTRANSLATE(x) ((unsigned)(x) <= 374 ? yytranslate[x] : 203)

static const short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   126,     2,   136,     2,   124,     2,     2,   131,
   132,   122,   120,   137,   121,   135,   123,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,   116,
     2,   118,   110,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
   133,     2,   134,   130,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   138,     2,   139,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
   107,   108,   109,   111,   112,   113,   114,   115,   117,   119,
   125,   127,   128,   129
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     6,     9,    11,    13,    15,    17,    19,
    21,    23,    25,    27,    29,    31,    33,    35,    37,    43,
    51,    58,    67,    68,    71,    74,    77,    80,    83,    85,
    89,    91,    95,    96,    97,   108,   110,   114,   115,   129,
   131,   135,   136,   152,   161,   162,   169,   171,   173,   175,
   177,   179,   181,   183,   188,   196,   206,   213,   217,   224,
   231,   241,   248,   258,   264,   273,   282,   294,   301,   311,
   321,   331,   339,   348,   361,   368,   376,   384,   392,   402,
   410,   420,   438,   446,   454,   466,   475,   488,   497,   506,
   515,   528,   551,   572,   581,   590,   599,   607,   616,   622,
   634,   640,   650,   652,   654,   656,   657,   660,   667,   674,
   681,   688,   693,   700,   707,   714,   719,   726,   730,   735,
   741,   745,   749,   754,   759,   763,   771,   779,   783,   791,
   795,   798,   801,   817,   820,   827,   836,   845,   856,   858,
   861,   863,   867,   872,   874,   880,   892,   906,   907,   915,
   916,   930,   931,   947,   956,   965,   974,   987,  1000,  1013,
  1028,  1043,  1058,  1059,  1072,  1073,  1086,  1087,  1100,  1101,
  1118,  1119,  1136,  1137,  1154,  1155,  1174,  1175,  1194,  1195,
  1214,  1216,  1219,  1229,  1237,  1240,  1247,  1257,  1267,  1276,
  1286,  1295,  1304,  1311,  1316,  1319,  1322,  1324,  1328,  1331,
  1334,  1337,  1341,  1345,  1349,  1353,  1357,  1361,  1365,  1369,
  1373,  1377,  1381,  1385,  1389,  1393,  1399,  1404,  1409,  1414,
  1419,  1424,  1429,  1434,  1439,  1444,  1449,  1456,  1461,  1466,
  1471,  1476,  1481,  1486,  1493,  1500,  1507,  1512,  1517,  1522,
  1527,  1532,  1537,  1542,  1547,  1552,  1557,  1562,  1569,  1574,
  1579,  1584,  1589,  1594,  1599,  1606,  1613,  1620,  1625,  1627,
  1629,  1631,  1633,  1635,  1637,  1639,  1641,  1646,  1651,  1654,
  1660,  1664,  1671,  1676,  1684,  1691,  1693,  1696,  1699,  1703,
  1707,  1719,  1729,  1737,  1745,  1746,  1750,  1754,  1756,  1760,
  1762,  1764,  1768,  1773,  1777,  1783,  1788,  1790,  1792,  1794,
  1798,  1803,  1810,  1818,  1820,  1822,  1826,  1830,  1840,  1848,
  1850,  1856,  1860,  1867,  1869,  1873,  1875,  1877,  1884,  1889,
  1894,  1899,  1906,  1913
};

static const short yyrhs[] = {   141,
     0,     1,     6,     0,     0,   141,   142,     0,   144,     0,
   143,     0,   162,     0,   163,     0,   164,     0,   167,     0,
   168,     0,   169,     0,   170,     0,   173,     0,   188,     0,
   189,     0,   172,     0,   171,     0,    33,   131,     5,   132,
     6,     0,    33,   131,     5,   137,   198,   132,     6,     0,
     4,     5,   138,   145,   139,     6,     0,     4,     5,     4,
   192,   138,   145,   139,     6,     0,     0,   145,   148,     0,
   145,   152,     0,   145,   155,     0,   145,   157,     0,   145,
   158,     0,   190,     0,   146,   137,   190,     0,   190,     0,
   147,   137,   190,     0,     0,     0,     4,   149,   131,   146,
   132,   150,   138,   147,   139,     6,     0,   202,     0,   151,
   137,   202,     0,     0,    76,   131,   190,   137,   190,   137,
   190,   132,   153,   138,   151,   139,     6,     0,   202,     0,
   154,   137,   202,     0,     0,    77,   131,   190,   137,   190,
   137,   190,   137,   190,   132,   156,   138,   154,   139,     6,
     0,    78,   138,   195,   139,   138,   195,   139,     6,     0,
     0,    79,   159,   138,   147,   139,     6,     0,     7,     0,
   106,     0,   107,     0,   108,     0,   109,     0,   127,     0,
   128,     0,     4,   160,   190,     6,     0,     4,   133,   190,
   134,   160,   190,     6,     0,     4,   133,   138,   198,   139,
   134,   160,   196,     6,     0,     4,   133,   134,     7,   196,
     6,     0,     4,   161,     6,     0,     4,   133,   190,   134,
   161,     6,     0,     4,   135,     4,     7,   202,     6,     0,
     4,   133,   190,   134,   135,     4,     7,   202,     6,     0,
     4,   135,     4,   160,   190,     6,     0,     4,   133,   190,
   134,   135,     4,   160,   190,     6,     0,     4,   135,     4,
   161,     6,     0,     4,   133,   190,   134,   135,     4,   161,
     6,     0,     4,   135,    88,   135,     4,     7,   199,     6,
     0,     4,   133,   190,   134,   135,    88,   135,     4,     7,
   199,     6,     0,     4,   135,    89,     7,   200,     6,     0,
     4,   133,   190,   134,   135,    89,     7,   200,     6,     0,
    60,   131,     4,   132,   135,     4,     7,   190,     6,     0,
    60,   131,     4,   132,   135,     4,     7,   202,     6,     0,
    41,   131,   190,   132,     7,   192,     6,     0,    56,    41,
   131,   190,   132,     7,   196,     6,     0,    72,    41,   196,
     7,   138,   190,   137,   190,   137,   190,   139,     6,     0,
    48,    49,   196,     7,   190,     6,     0,    44,   131,   190,
   132,     7,   196,     6,     0,    46,   131,   190,   132,     7,
   196,     6,     0,    42,   131,   190,   132,     7,   196,     6,
     0,    42,   131,   190,   132,     7,   196,    52,   192,     6,
     0,    43,   131,   190,   132,     7,   196,     6,     0,    43,
   131,   190,   132,     7,   196,    52,   192,     6,     0,    50,
   131,   190,   132,     7,   138,   190,   137,   190,   137,     5,
   137,     5,   137,     5,   139,     6,     0,    81,   131,   190,
   132,     7,   196,     6,     0,    82,   131,   190,   132,     7,
   196,     6,     0,    83,   131,   190,   132,     7,   196,    87,
   196,    84,   190,     6,     0,    44,    67,   131,   190,   132,
     7,   196,     6,     0,    72,    44,   196,     7,   138,   190,
   137,   190,   137,   190,   139,     6,     0,    56,    44,   131,
   190,   132,     7,   196,     6,     0,    52,    45,   131,   190,
   132,     7,   196,     6,     0,    53,    45,   131,   190,   132,
     7,   196,     6,     0,    99,    45,   131,   190,   132,     7,
   138,   190,   137,   196,   139,     6,     0,    83,    45,    85,
    86,   131,   190,   132,     7,   194,    87,   138,   196,   137,
   196,   139,    84,   138,   190,   137,   190,   139,     6,     0,
    83,    45,   131,   190,   132,     7,   194,    87,   138,   196,
   137,   196,   139,    84,   138,   190,   137,   190,   139,     6,
     0,    45,    67,   131,   190,   132,     7,   196,     6,     0,
    56,    45,   131,   190,   132,     7,   196,     6,     0,    55,
    47,   131,   190,   132,     7,   196,     6,     0,    47,   131,
   190,   132,     7,   196,     6,     0,    56,    47,   131,   190,
   132,     7,   196,     6,     0,    62,   192,   138,   165,   139,
     0,    61,   138,   192,   137,   192,   137,   190,   139,   138,
   165,   139,     0,    63,   192,   138,   165,   139,     0,    64,
   138,   192,   137,   190,   139,   138,   165,   139,     0,   167,
     0,   166,     0,   164,     0,     0,   166,   163,     0,   166,
    41,   138,   198,   139,     6,     0,   166,    44,   138,   198,
   139,     6,     0,   166,    45,   138,   198,   139,     6,     0,
   166,    47,   138,   198,   139,     6,     0,    66,   138,   166,
   139,     0,    66,     4,   133,   190,   134,     6,     0,    74,
     4,   133,   190,   134,     6,     0,    75,     4,   133,   190,
   134,     6,     0,    69,   138,   166,   139,     0,    69,     4,
   133,   190,   134,     6,     0,    69,     4,     6,     0,    69,
     4,     4,     6,     0,    88,   199,   138,   166,   139,     0,
   100,   202,     6,     0,   101,   202,     6,     0,   100,   138,
   166,   139,     0,   101,   138,   166,   139,     0,     4,   202,
     6,     0,     4,     4,   133,   190,   134,   202,     6,     0,
     4,     4,     4,   133,   190,   134,     6,     0,     4,   190,
     6,     0,    60,   131,     4,   132,   135,     4,     6,     0,
    80,     4,     6,     0,    95,     6,     0,    38,     6,     0,
    38,   138,   190,   137,   190,   137,   190,   137,   190,   137,
   190,   137,   190,   139,     6,     0,    39,     6,     0,    90,
   131,   190,     8,   190,   132,     0,    90,   131,   190,     8,
   190,     8,   190,   132,     0,    90,     4,    91,   138,   190,
     8,   190,   139,     0,    90,     4,    91,   138,   190,     8,
   190,     8,   190,   139,     0,    92,     0,    98,     4,     0,
    96,     0,    97,     4,     6,     0,    93,   131,   190,   132,
     0,    94,     0,    65,   192,   138,   166,   139,     0,    65,
   138,   192,   137,   192,   137,   190,   139,   138,   166,   139,
     0,    65,   138,   192,   137,   192,   137,   192,   137,   190,
   139,   138,   166,   139,     0,     0,    65,   192,   138,   166,
   174,   186,   139,     0,     0,    65,   138,   192,   137,   192,
   137,   190,   139,   138,   166,   175,   186,   139,     0,     0,
    65,   138,   192,   137,   192,   137,   192,   137,   190,   139,
   138,   166,   176,   186,   139,     0,    65,    41,   138,   190,
   137,   192,   139,     6,     0,    65,    44,   138,   190,   137,
   192,   139,     6,     0,    65,    45,   138,   190,   137,   192,
   139,     6,     0,    65,    41,   138,   190,   137,   192,   137,
   192,   137,   190,   139,     6,     0,    65,    44,   138,   190,
   137,   192,   137,   192,   137,   190,   139,     6,     0,    65,
    45,   138,   190,   137,   192,   137,   192,   137,   190,   139,
     6,     0,    65,    41,   138,   190,   137,   192,   137,   192,
   137,   192,   137,   190,   139,     6,     0,    65,    44,   138,
   190,   137,   192,   137,   192,   137,   192,   137,   190,   139,
     6,     0,    65,    45,   138,   190,   137,   192,   137,   192,
   137,   192,   137,   190,   139,     6,     0,     0,    65,    41,
   138,   190,   137,   192,   139,   177,   138,   186,   139,     6,
     0,     0,    65,    44,   138,   190,   137,   192,   139,   178,
   138,   186,   139,     6,     0,     0,    65,    45,   138,   190,
   137,   192,   139,   179,   138,   186,   139,     6,     0,     0,
    65,    41,   138,   190,   137,   192,   137,   192,   137,   190,
   139,   180,   138,   186,   139,     6,     0,     0,    65,    44,
   138,   190,   137,   192,   137,   192,   137,   190,   139,   181,
   138,   186,   139,     6,     0,     0,    65,    45,   138,   190,
   137,   192,   137,   192,   137,   190,   139,   182,   138,   186,
   139,     6,     0,     0,    65,    41,   138,   190,   137,   192,
   137,   192,   137,   192,   137,   190,   139,   183,   138,   186,
   139,     6,     0,     0,    65,    44,   138,   190,   137,   192,
   137,   192,   137,   192,   137,   190,   139,   184,   138,   186,
   139,     6,     0,     0,    65,    45,   138,   190,   137,   192,
   137,   192,   137,   192,   137,   190,   139,   185,   138,   186,
   139,     6,     0,   187,     0,   186,   187,     0,    73,   138,
   196,   137,   196,   137,   196,   139,     6,     0,    73,   138,
   196,   137,   196,   139,     6,     0,    68,     6,     0,    54,
    44,   196,     7,   190,     6,     0,    54,    44,   196,     7,
   190,    57,    59,   190,     6,     0,    54,    44,   196,     7,
   190,    57,    58,   190,     6,     0,    54,    45,   138,   190,
   139,     7,   196,     6,     0,    54,    45,   138,   190,   139,
     7,   196,     4,     6,     0,    51,    45,   138,   190,   139,
     7,   196,     6,     0,    54,    47,   138,   190,   139,     7,
   196,     6,     0,    68,    45,   196,     7,   190,     6,     0,
    68,    45,   196,     6,     0,    70,     6,     0,    71,     6,
     0,   191,     0,   131,   190,   132,     0,   121,   190,     0,
   120,   190,     0,   126,   190,     0,   190,   121,   190,     0,
   190,   120,   190,     0,   190,   122,   190,     0,   190,   123,
   190,     0,   190,   124,   190,     0,   190,   130,   190,     0,
   190,   116,   190,     0,   190,   118,   190,     0,   190,   117,
   190,     0,   190,   119,   190,     0,   190,   113,   190,     0,
   190,   114,   190,     0,   190,   112,   190,     0,   190,   111,
   190,     0,   190,   110,   190,     8,   190,     0,    12,   131,
   190,   132,     0,    13,   131,   190,   132,     0,    14,   131,
   190,   132,     0,    15,   131,   190,   132,     0,    16,   131,
   190,   132,     0,    17,   131,   190,   132,     0,    18,   131,
   190,   132,     0,    19,   131,   190,   132,     0,    20,   131,
   190,   132,     0,    22,   131,   190,   132,     0,    23,   131,
   190,   137,   190,   132,     0,    24,   131,   190,   132,     0,
    25,   131,   190,   132,     0,    26,   131,   190,   132,     0,
    27,   131,   190,   132,     0,    28,   131,   190,   132,     0,
    29,   131,   190,   132,     0,    30,   131,   190,   137,   190,
   132,     0,    31,   131,   190,   137,   190,   132,     0,    32,
   131,   190,   137,   190,   132,     0,    21,   131,   190,   132,
     0,    12,   133,   190,   134,     0,    13,   133,   190,   134,
     0,    14,   133,   190,   134,     0,    15,   133,   190,   134,
     0,    16,   133,   190,   134,     0,    17,   133,   190,   134,
     0,    18,   133,   190,   134,     0,    19,   133,   190,   134,
     0,    20,   133,   190,   134,     0,    22,   133,   190,   134,
     0,    23,   133,   190,   137,   190,   134,     0,    24,   133,
   190,   134,     0,    25,   133,   190,   134,     0,    26,   133,
   190,   134,     0,    27,   133,   190,   134,     0,    28,   133,
   190,   134,     0,    29,   133,   190,   134,     0,    30,   133,
   190,   137,   190,   134,     0,    31,   133,   190,   137,   190,
   134,     0,    32,   133,   190,   137,   190,   134,     0,    21,
   133,   190,   134,     0,     3,     0,     9,     0,    10,     0,
    11,     0,   103,     0,   104,     0,   105,     0,     4,     0,
     4,   133,   190,   134,     0,   136,     4,   133,   134,     0,
     4,   161,     0,     4,   133,   190,   134,   161,     0,     4,
   135,     4,     0,     4,   133,   190,   134,   135,     4,     0,
     4,   135,     4,   161,     0,     4,   133,   190,   134,   135,
     4,   161,     0,   102,   131,     5,   137,   190,   132,     0,
   193,     0,   121,   192,     0,   120,   192,     0,   192,   121,
   192,     0,   192,   120,   192,     0,   138,   190,   137,   190,
   137,   190,   137,   190,   137,   190,   139,     0,   138,   190,
   137,   190,   137,   190,   137,   190,   139,     0,   138,   190,
   137,   190,   137,   190,   139,     0,   131,   190,   137,   190,
   137,   190,   132,     0,     0,   138,   195,   139,     0,   131,
   195,   132,     0,   196,     0,   195,   137,   196,     0,   190,
     0,   197,     0,   138,   198,   139,     0,   121,   138,   198,
   139,     0,   190,     8,   190,     0,   190,     8,   190,     8,
   190,     0,    41,   138,   190,   139,     0,   164,     0,   167,
     0,   173,     0,     4,   133,   134,     0,   121,     4,   133,
   134,     0,     4,   133,   138,   198,   139,   134,     0,   121,
     4,   133,   138,   198,   139,   134,     0,   190,     0,   197,
     0,   198,   137,   190,     0,   198,   137,   197,     0,   138,
   190,   137,   190,   137,   190,   137,   190,   139,     0,   138,
   190,   137,   190,   137,   190,   139,     0,     4,     0,     4,
   135,    88,   135,     4,     0,   138,   201,   139,     0,     4,
   133,   190,   134,   135,    89,     0,   199,     0,   201,   137,
   199,     0,     5,     0,    40,     0,    35,   131,   202,   137,
   202,   132,     0,    36,   131,   202,   132,     0,    37,   131,
   202,   132,     0,    34,   131,   202,   132,     0,    34,   131,
   202,   137,   198,   132,     0,    34,   131,     4,   135,     4,
   132,     0,    34,   131,     4,   133,   190,   134,   135,     4,
   132,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   143,   145,   150,   152,   155,   157,   158,   159,   160,   161,
   162,   163,   164,   165,   166,   167,   168,   169,   172,   178,
   195,   203,   212,   220,   221,   222,   223,   224,   227,   230,
   234,   237,   241,   432,   450,   460,   466,   473,   481,   487,
   493,   500,   508,   514,   522,   527,   534,   536,   537,   538,
   539,   542,   544,   547,   582,   621,   675,   692,   703,   722,
   736,   753,   779,   806,   820,   837,   851,   868,   888,   911,
   921,   936,   956,   972,   991,  1010,  1028,  1046,  1064,  1090,
  1108,  1134,  1154,  1178,  1202,  1228,  1245,  1263,  1282,  1301,
  1340,  1365,  1384,  1403,  1419,  1439,  1456,  1473,  1493,  1499,
  1504,  1509,  1516,  1518,  1519,  1522,  1527,  1531,  1547,  1563,
  1579,  1599,  1614,  1620,  1626,  1637,  1647,  1657,  1671,  1689,
  1703,  1712,  1718,  1729,  1742,  1787,  1802,  1813,  1832,  1842,
  1864,  1868,  1873,  1878,  1889,  1906,  1922,  1948,  1975,  2007,
  2014,  2019,  2025,  2029,  2037,  2046,  2054,  2062,  2067,  2075,
  2080,  2088,  2093,  2103,  2110,  2117,  2124,  2131,  2138,  2145,
  2152,  2159,  2166,  2171,  2178,  2183,  2190,  2195,  2202,  2207,
  2214,  2219,  2226,  2231,  2238,  2243,  2250,  2255,  2262,  2267,
  2277,  2281,  2286,  2313,  2337,  2345,  2364,  2382,  2400,  2429,
  2464,  2491,  2518,  2532,  2550,  2555,  2564,  2566,  2567,  2568,
  2569,  2570,  2571,  2572,  2573,  2580,  2581,  2582,  2583,  2584,
  2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,
  2595,  2596,  2597,  2598,  2599,  2600,  2601,  2602,  2603,  2604,
  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2613,  2614,  2615,
  2616,  2617,  2618,  2619,  2620,  2621,  2622,  2623,  2624,  2625,
  2626,  2627,  2628,  2629,  2630,  2631,  2632,  2633,  2638,  2643,
  2644,  2645,  2646,  2647,  2648,  2652,  2665,  2685,  2699,  2712,
  2735,  2753,  2771,  2789,  2807,  2814,  2819,  2823,  2827,  2831,
  2837,  2842,  2846,  2850,  2856,  2860,  2864,  2870,  2876,  2883,
  2889,  2893,  2897,  2908,  2915,  2926,  2946,  2956,  2966,  2976,
  2993,  3012,  3036,  3064,  3070,  3074,  3078,  3090,  3095,  3107,
  3114,  3135,  3140,  3154,  3160,  3166,  3171,  3179,  3187,  3201,
  3215,  3219,  3238,  3260
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","tDOUBLE",
"tSTRING","tBIGSTR","tEND","tAFFECT","tDOTS","tPi","tMPI_Rank","tMPI_Size","tExp",
"tLog","tLog10","tSqrt","tSin","tAsin","tCos","tAcos","tTan","tRand","tAtan",
"tAtan2","tSinh","tCosh","tTanh","tFabs","tFloor","tCeil","tFmod","tModulo",
"tHypot","tPrintf","tSprintf","tStrCat","tStrPrefix","tStrRelative","tBoundingBox",
"tDraw","tToday","tPoint","tCircle","tEllipse","tLine","tSurface","tSpline",
"tVolume","tCharacteristic","tLength","tParametric","tElliptic","tPlane","tRuled",
"tTransfinite","tComplex","tPhysical","tUsing","tBump","tProgression","tPlugin",
"tRotate","tTranslate","tSymmetry","tDilate","tExtrude","tDuplicata","tLoop",
"tRecombine","tDelete","tCoherence","tIntersect","tAttractor","tLayers","tAlias",
"tAliasWithOptions","tText2D","tText3D","tInterpolationScheme","tTime","tCombine",
"tBSpline","tBezier","tNurbs","tOrder","tWith","tBounds","tKnots","tColor","tColorTable",
"tFor","tIn","tEndFor","tIf","tEndIf","tExit","tReturn","tCall","tFunction",
"tTrimmed","tShow","tHide","tGetValue","tGMSH_MAJOR_VERSION","tGMSH_MINOR_VERSION",
"tGMSH_PATCH_VERSION","tAFFECTPLUS","tAFFECTMINUS","tAFFECTTIMES","tAFFECTDIVIDE",
"'?'","tOR","tAND","tEQUAL","tNOTEQUAL","tAPPROXEQUAL","'<'","tLESSOREQUAL",
"'>'","tGREATEROREQUAL","'+'","'-'","'*'","'/'","'%'","tCROSSPRODUCT","'!'",
"tPLUSPLUS","tMINUSMINUS","UNARYPREC","'^'","'('","')'","'['","']'","'.'","'#'",
"','","'{'","'}'","All","GeoFormatItems","GeoFormatItem","Printf","View","Views",
"ElementCoords","ElementValues","Element","@1","@2","Text2DValues","Text2D",
"@3","Text3DValues","Text3D","@4","InterpolationMatrix","Time","@5","NumericAffectation",
"NumericIncrement","Affectation","Shape","Transform","MultipleShape","ListOfShapes",
"Duplicata","Delete","Colorify","Visibility","Command","Loop","Extrude","@6",
"@7","@8","@9","@10","@11","@12","@13","@14","@15","@16","@17","ExtrudeParameters",
"ExtrudeParameter","Transfinite","Coherence","FExpr","FExpr_Single","VExpr",
"VExpr_Single","ListOfListOfDouble","RecursiveListOfListOfDouble","ListOfDouble",
"FExpr_Multi","RecursiveListOfDouble","ColorExpr","ListOfColor","RecursiveListOfColor",
"StringExpr", NULL
};
#endif

static const short yyr1[] = {     0,
   140,   140,   141,   141,   142,   142,   142,   142,   142,   142,
   142,   142,   142,   142,   142,   142,   142,   142,   143,   143,
   144,   144,   145,   145,   145,   145,   145,   145,   146,   146,
   147,   147,   149,   150,   148,   151,   151,   153,   152,   154,
   154,   156,   155,   157,   159,   158,   160,   160,   160,   160,
   160,   161,   161,   162,   162,   162,   162,   162,   162,   162,
   162,   162,   162,   162,   162,   162,   162,   162,   162,   162,
   162,   163,   163,   163,   163,   163,   163,   163,   163,   163,
   163,   163,   163,   163,   163,   163,   163,   163,   163,   163,
   163,   163,   163,   163,   163,   163,   163,   163,   164,   164,
   164,   164,   165,   165,   165,   166,   166,   166,   166,   166,
   166,   167,   167,   167,   167,   168,   168,   168,   168,   169,
   170,   170,   170,   170,   171,   171,   171,   171,   171,   171,
   171,   171,   171,   171,   172,   172,   172,   172,   172,   172,
   172,   172,   172,   172,   173,   173,   173,   174,   173,   175,
   173,   176,   173,   173,   173,   173,   173,   173,   173,   173,
   173,   173,   177,   173,   178,   173,   179,   173,   180,   173,
   181,   173,   182,   173,   183,   173,   184,   173,   185,   173,
   186,   186,   187,   187,   187,   188,   188,   188,   188,   188,
   188,   188,   188,   188,   189,   189,   190,   190,   190,   190,
   190,   190,   190,   190,   190,   190,   190,   190,   190,   190,
   190,   190,   190,   190,   190,   190,   190,   190,   190,   190,
   190,   190,   190,   190,   190,   190,   190,   190,   190,   190,
   190,   190,   190,   190,   190,   190,   190,   190,   190,   190,
   190,   190,   190,   190,   190,   190,   190,   190,   190,   190,
   190,   190,   190,   190,   190,   190,   190,   190,   191,   191,
   191,   191,   191,   191,   191,   191,   191,   191,   191,   191,
   191,   191,   191,   191,   191,   192,   192,   192,   192,   192,
   193,   193,   193,   193,   194,   194,   194,   195,   195,   196,
   196,   196,   196,   197,   197,   197,   197,   197,   197,   197,
   197,   197,   197,   198,   198,   198,   198,   199,   199,   199,
   199,   200,   200,   201,   201,   202,   202,   202,   202,   202,
   202,   202,   202,   202
};

static const short yyr2[] = {     0,
     1,     2,     0,     2,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     5,     7,
     6,     8,     0,     2,     2,     2,     2,     2,     1,     3,
     1,     3,     0,     0,    10,     1,     3,     0,    13,     1,
     3,     0,    15,     8,     0,     6,     1,     1,     1,     1,
     1,     1,     1,     4,     7,     9,     6,     3,     6,     6,
     9,     6,     9,     5,     8,     8,    11,     6,     9,     9,
     9,     7,     8,    12,     6,     7,     7,     7,     9,     7,
     9,    17,     7,     7,    11,     8,    12,     8,     8,     8,
    12,    22,    20,     8,     8,     8,     7,     8,     5,    11,
     5,     9,     1,     1,     1,     0,     2,     6,     6,     6,
     6,     4,     6,     6,     6,     4,     6,     3,     4,     5,
     3,     3,     4,     4,     3,     7,     7,     3,     7,     3,
     2,     2,    15,     2,     6,     8,     8,    10,     1,     2,
     1,     3,     4,     1,     5,    11,    13,     0,     7,     0,
    13,     0,    15,     8,     8,     8,    12,    12,    12,    14,
    14,    14,     0,    12,     0,    12,     0,    12,     0,    16,
     0,    16,     0,    16,     0,    18,     0,    18,     0,    18,
     1,     2,     9,     7,     2,     6,     9,     9,     8,     9,
     8,     8,     6,     4,     2,     2,     1,     3,     2,     2,
     2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     5,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     6,     4,     4,     4,
     4,     4,     4,     6,     6,     6,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     6,     4,     4,
     4,     4,     4,     4,     6,     6,     6,     4,     1,     1,
     1,     1,     1,     1,     1,     1,     4,     4,     2,     5,
     3,     6,     4,     7,     6,     1,     2,     2,     3,     3,
    11,     9,     7,     7,     0,     3,     3,     1,     3,     1,
     1,     3,     4,     3,     5,     4,     1,     1,     1,     3,
     4,     6,     7,     1,     1,     3,     3,     9,     7,     1,
     5,     3,     6,     1,     3,     1,     1,     6,     4,     4,
     4,     6,     6,     9
};

static const short yydefact[] = {     0,
     0,     1,     2,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   139,     0,   144,     0,   141,     0,     0,     0,
     0,     0,     4,     6,     5,     7,     8,     9,    10,    11,
    12,    13,    18,    17,    14,    15,    16,   259,   266,   316,
    47,   260,   261,   262,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   317,
     0,   263,   264,   265,    48,    49,    50,    51,     0,     0,
     0,    52,    53,     0,     0,     0,     0,     0,     0,     0,
   197,     0,     0,   132,     0,   134,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   276,     0,     0,     0,     0,     0,
     0,     0,     0,   106,     0,     0,   106,   195,   196,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   310,     0,
     0,     0,     0,     0,   131,     0,   140,     0,   316,   106,
     0,   106,     0,     0,     0,     0,   269,     0,    23,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   266,   200,   199,   201,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    58,
   128,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   125,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   266,     0,     0,
     0,   297,   298,   299,   290,     0,   291,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   278,   277,     0,     0,     0,     0,   106,   106,     0,
     0,     0,     0,     0,     0,     0,     0,   106,     0,     0,
     0,     0,   118,     0,     0,     0,     0,     0,     0,   130,
     0,     0,     0,     0,     0,     0,     0,   106,     0,     0,
     0,   142,     0,     0,   121,     0,   122,     0,     0,   271,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   198,     0,     0,   304,   305,     0,     0,    47,     0,
     0,     0,     0,     0,    54,     0,   215,   214,   212,   213,
   208,   210,   209,   211,   203,   202,   204,   205,   206,   207,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   266,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   280,   279,   105,     0,   104,   103,
     0,     0,     0,     0,     0,     0,     0,   148,     0,     0,
     0,     0,     0,   112,   107,   194,     0,   119,     0,   116,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   143,     0,   123,   124,     0,   267,
   273,    23,    33,     0,     0,     0,    45,     0,    24,    25,
    26,    27,    28,   217,   238,   218,   239,   219,   240,   220,
   241,   221,   242,   222,   243,   223,   244,   224,   245,   225,
   246,   237,   258,   226,   247,     0,     0,   228,   249,   229,
   250,   230,   251,   231,   252,   232,   253,   233,   254,     0,
     0,     0,     0,     0,     0,     0,     0,   321,     0,     0,
   319,   320,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    64,     0,     0,     0,     0,   268,     0,    19,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   300,     0,     0,     0,     0,   292,   294,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    99,   101,     0,     0,     0,     0,
     0,   145,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   120,     0,     0,     0,     0,     0,   270,     0,     0,
     0,     0,     0,     0,     0,    21,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   267,
    57,   306,   307,     0,     0,     0,     0,     0,    59,    60,
    62,     0,     0,   314,     0,    68,   216,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   296,   301,
     0,   293,     0,    75,     0,     0,     0,     0,   186,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   181,
   113,     0,     0,     0,     0,   193,   117,     0,     0,   114,
   115,     0,     0,     0,   285,     0,   311,     0,     0,     0,
   135,     0,   127,   272,   126,     0,     0,     0,     0,     0,
   288,     0,   227,   248,   234,   255,   235,   256,   236,   257,
     0,   323,   322,   318,   275,     0,    47,     0,     0,     0,
     0,    55,     0,     0,     0,   312,    20,     0,    72,    78,
     0,    80,     0,     0,    76,     0,    77,    97,     0,     0,
   295,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   129,     0,     0,     0,     0,   106,
     0,   163,     0,   165,     0,   167,     0,     0,   185,     0,
   149,   182,     0,     0,     0,     0,     0,     0,    83,    84,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   274,
    22,     0,    29,     0,     0,     0,     0,     0,    31,     0,
     0,     0,     0,    65,     0,     0,    66,     0,   315,     0,
     0,     0,    86,    94,   302,     0,     0,   191,    89,    90,
     0,     0,     0,   189,   192,    96,    73,    88,    95,    98,
     0,     0,     0,   284,     0,   283,     0,     0,   154,     0,
     0,   155,     0,     0,   156,     0,     0,     0,     0,   108,
   109,   110,   111,     0,     0,   285,     0,     0,     0,     0,
     0,   309,     0,   137,   136,     0,    34,     0,     0,     0,
   289,     0,     0,     0,     0,    56,    61,    63,     0,    69,
     0,     0,    79,    81,   303,     0,   188,   187,   190,    70,
    71,   106,     0,   102,     0,     0,     0,     0,     0,     0,
   106,     0,     0,     0,     0,     0,   287,   286,     0,     0,
     0,     0,     0,     0,    30,     0,     0,     0,    32,    46,
   324,     0,   313,     0,     0,     0,     0,   282,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   150,     0,     0,
     0,     0,     0,     0,     0,   308,   138,     0,     0,     0,
     0,     0,    67,     0,     0,   100,     0,   169,     0,     0,
   171,     0,     0,   173,     0,     0,   146,     0,   106,     0,
     0,     0,     0,     0,     0,    85,     0,     0,    38,     0,
    44,     0,     0,   281,   157,     0,     0,   164,   158,     0,
     0,   166,   159,     0,     0,   168,     0,   152,     0,   184,
    74,    87,     0,     0,    91,     0,     0,     0,     0,     0,
     0,   175,     0,   177,     0,   179,   151,   147,     0,     0,
     0,     0,    35,     0,    42,     0,     0,     0,   160,     0,
     0,   161,     0,     0,   162,     0,     0,   183,     0,     0,
     0,    36,     0,   133,     0,     0,     0,     0,     0,     0,
     0,   153,     0,     0,     0,     0,     0,     0,   170,     0,
   172,     0,   174,     0,     0,     0,    37,    39,     0,    40,
    82,     0,     0,     0,     0,     0,     0,     0,   176,   178,
   180,     0,     0,    41,    43,     0,     0,     0,    93,     0,
    92,     0,     0,     0
};

static const short yydefgoto[] = {  1172,
     2,    53,    54,    55,   362,   872,   878,   529,   671,   994,
  1121,   530,  1087,  1149,   531,  1123,   532,   533,   675,   118,
   197,    56,   495,   292,   478,   479,   293,    60,    61,    62,
    63,    64,   294,   643,  1048,  1099,   920,   923,   926,  1066,
  1070,  1074,  1110,  1113,  1116,   749,   750,    66,    67,   295,
   121,   312,   155,   864,   780,   781,   297,   417,   181,   597,
   705,   122
};

static const short yypact[] = {  2302,
    33,  2647,-32768,  1685,   -86,     3,    42,   -52,   -44,   -41,
   -46,    55,   -37,   -30,    60,    -3,   101,   111,   133,   461,
   140,   605,   113,   145,   -18,   -18,   156,   292,     6,   253,
     7,   303,   309,    27,   337,   411,   418,   280,   301,   -31,
     9,    11,-32768,   313,-32768,   451,-32768,   436,   456,   422,
    17,    26,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    32,    12,
-32768,-32768,-32768,-32768,   149,   257,   271,   319,   335,   357,
   370,   388,   392,   396,   400,   472,   486,   493,   533,   534,
   552,   553,   556,   565,   585,   385,   446,   450,   473,-32768,
   480,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  1898,  1898,
  1898,-32768,-32768,  1898,  1310,    28,   554,  1898,   559,   840,
-32768,   568,   604,-32768,  1898,-32768,  1898,  1898,  1898,   485,
  1898,   498,  1898,  1898,  1180,  1898,   492,   509,   520,  1180,
   537,   538,   541,   562,   566,   570,   584,   722,   -18,   -18,
   -18,  1898,  1898,    16,-32768,   218,   -18,   609,   610,   633,
  1525,   288,   639,-32768,  1180,    19,-32768,-32768,-32768,  1180,
  1180,   655,   657,   737,  1898,  1898,   -58,  1898,   641,  1898,
   653,   701,  1898,  1898,-32768,   795,-32768,   680,-32768,-32768,
   806,-32768,   807,   682,  1898,   813,-32768,   -18,-32768,  1898,
  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,
  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,
  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,
  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,
  1898,   437,   460,   460,   460,   815,   119,   688,   688,   688,
  4740,   814,  1734,  2070,   268,   689,   819,   694,   910,-32768,
-32768,  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,  1898,
  1898,  1898,  1898,  1898,  1898,  1898,-32768,     2,  2487,  4763,
  4786,  4809,  1898,  4832,  1898,  4855,  4878,   479,   690,  1555,
  1734,-32768,-32768,-32768,  2015,   822,-32768,  4901,  1898,  1898,
  1898,   823,  1898,  1898,  1898,  1898,  1898,  1898,  1898,   699,
   -65,-32768,-32768,  3220,  3242,   -18,   -18,   596,   596,   -22,
  1898,  1898,  1898,  1525,  1525,  1898,   136,-32768,  1898,  2165,
   363,   827,-32768,  1898,  2363,   828,   829,  1898,  1898,-32768,
  4924,  4947,   751,  1898,  4970,   750,  3264,-32768,   702,  2030,
  4993,-32768,  1898,  2384,-32768,  2429,-32768,  1898,  3990,   434,
   299,    -1,  5016,  4015,  5039,  4040,  5062,  4065,  5085,  4090,
  5108,  4115,  5131,  4140,  5154,  4165,  5177,  4190,  5200,  4215,
  5223,  4240,  5246,  4265,  3286,  3308,  5269,  4290,  5292,  4315,
  5315,  4340,  5338,  4365,  5361,  4390,  5384,  4415,  3330,  3352,
  3374,  3396,  3418,  3440,   589,    38,   704,   707,   710,   706,
  1898,-32768,  1180,  1928,  2015,-32768,    -6,   244,   460,  1898,
   838,   844,    13,   715,-32768,  2045,   590,   470,   515,   515,
   558,   558,   558,   558,   243,   243,   688,   688,   688,   688,
   845,  1734,  1898,   848,   849,   850,  5407,   851,  5430,   852,
   853,  1352,  1898,   528,  1734,   586,  1898,  1898,   854,  2692,
  5453,  5476,  1898,  2716,  2740,  5499,  5522,  5545,  5568,  5591,
   717,   -18,  1898,  1898,-32768,-32768,-32768,   724,  2708,-32768,
   725,  1898,  3462,  3484,  3506,  2376,   -18,  2474,  4440,   -96,
   -47,   -43,   -94,-32768,-32768,-32768,  1898,-32768,  4465,-32768,
   728,   729,  4490,  4515,   862,   865,   742,  5614,   867,   740,
  1898,  2495,  1898,  1898,-32768,  5637,-32768,-32768,  4540,   308,
-32768,-32768,-32768,   745,   746,   741,-32768,   872,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,  1898,  1898,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  1898,
  1898,  1898,  1898,  1898,  1898,  1898,   876,-32768,  1734,   460,
-32768,-32768,  1898,  4565,   875,  1734,   748,    30,  1898,   878,
   879,   966,-32768,   881,   756,     9,   884,-32768,  1898,-32768,
   116,  3528,   -18,  1180,  1180,   885,  1180,   893,  1180,  1180,
-32768,  1734,  2764,  1488,   591,-32768,  2162,   993,   753,   903,
   905,   906,   427,   907,   911,   912,   913,   914,   915,   916,
   921,   342,  3550,  3572,-32768,-32768,  2788,   -18,   -18,   -18,
   355,-32768,    -9,   920,  1734,  1734,  1734,  1734,  1047,   922,
  1898,  1898,   923,   924,  1180,  1180,  1898,   925,  1180,   927,
  3594,-32768,  2177,   785,   926,   928,   931,-32768,   930,     4,
   796,  1898,  1898,  1180,   800,-32768,  5660,  4590,  5683,  4615,
  5706,  4640,  5729,  4665,  4690,   808,   174,   809,  5752,   407,
-32768,  2015,-32768,    86,   278,   810,   935,  1147,-32768,-32768,
-32768,     9,  1898,-32768,   595,-32768,  1026,   937,  1898,    41,
    34,    37,  1180,   940,  1180,   941,   942,   601,-32768,-32768,
  1734,-32768,  1898,-32768,  1898,  1180,  1180,  1180,-32768,   496,
  1180,  1180,  1180,  1180,  1180,  1180,  1180,   614,  1898,  1898,
  1898,   817,   171,   365,   378,  1525,   959,   830,   -35,-32768,
-32768,   602,   619,   620,   623,-32768,-32768,  3616,  3638,-32768,
-32768,   960,   961,  5775,   -73,   882,-32768,  1898,  1898,  1898,
-32768,   836,-32768,   434,-32768,   970,  1898,  3660,  3682,   624,
-32768,  1898,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   855,-32768,-32768,-32768,-32768,  1180,   460,  1898,   973,   979,
    13,-32768,   978,  4715,     9,-32768,-32768,  3704,-32768,-32768,
   -18,-32768,   -18,   981,-32768,   982,-32768,-32768,   857,   630,
  1026,  3726,   983,   988,   989,  1898,  1898,   723,   990,   991,
   992,   996,   998,   999,-32768,  1863,  2812,  5798,  2112,   596,
   -18,  1000,   -18,  1002,   -18,  1003,  2836,   391,-32768,  1180,
-32768,-32768,  1004,  1006,  1010,  1011,  1898,  1898,-32768,-32768,
  1012,  1180,  1180,   898,  1180,  2199,   686,  5821,  1898,-32768,
-32768,   194,  1026,  1898,  1898,  1180,   880,   631,  1026,  1032,
  1031,  1033,  1275,-32768,  1035,  1037,-32768,   909,-32768,  1898,
    61,    64,-32768,-32768,-32768,   917,  1898,-32768,-32768,-32768,
  1955,  1970,  1039,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  1985,  1040,   919,-32768,  1898,-32768,   908,   393,-32768,   929,
   439,-32768,   932,   443,-32768,   933,   936,  1898,   918,-32768,
-32768,-32768,-32768,  3748,  3770,   -73,   262,   638,   943,   964,
  1898,-32768,  1898,-32768,-32768,  3792,-32768,  1898,  3814,  3836,
-32768,  1180,  1898,  1043,   934,-32768,-32768,-32768,     9,-32768,
   963,  3858,-32768,-32768,-32768,  3880,-32768,-32768,-32768,-32768,
-32768,   596,  2655,-32768,  1525,    -9,  1525,    -9,  1525,    -9,
-32768,  2860,  1180,  1898,  1898,   967,-32768,-32768,  1180,  1898,
  2884,  2908,  1180,   953,  1026,  1898,  1898,   642,  1026,-32768,
-32768,  1044,-32768,  1898,  1054,   954,  1898,-32768,  2932,   476,
   -27,  2956,   478,     1,  2980,   481,    24,  2540,   956,   643,
  3004,  3028,   957,   938,  2000,-32768,-32768,   958,  1898,  5844,
  3902,  1055,-32768,  3924,   955,-32768,  3052,  1056,  1898,  1057,
  1058,  1898,  1059,  1063,  1898,  1092,-32768,    -9,-32768,  1180,
  1093,  1094,  1095,  1180,  1180,-32768,  1102,   646,-32768,  1898,
-32768,  1898,  1113,-32768,-32768,   984,  3076,-32768,-32768,   986,
  3100,-32768,-32768,   987,  3124,-32768,   100,  2585,   995,-32768,
-32768,-32768,   994,  1015,-32768,  1114,  1034,  5867,  3148,  1036,
    -9,  1120,    -9,  1121,    -9,  1122,-32768,-32768,    -9,  1123,
  1180,   976,-32768,   460,-32768,  1126,  1136,   177,-32768,  1038,
   216,-32768,  1041,   220,-32768,  1042,   239,-32768,  1046,  1049,
   647,-32768,  1075,-32768,  1076,  1168,    -9,  1169,    -9,  1172,
    -9,-32768,  1097,  1898,   460,  1176,   460,  1208,-32768,   259,
-32768,   289,-32768,   295,  1079,  3946,-32768,-32768,   650,-32768,
-32768,  1213,  1216,  1217,  1898,  1898,   460,  1218,-32768,-32768,
-32768,  3968,  3172,-32768,-32768,  1898,  1219,  3196,-32768,  1220,
-32768,  1227,  1228,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,   708,-32768,   200,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -249,
     0,-32768,  1229,     5,  -318,  -162,    10,-32768,-32768,-32768,
-32768,-32768,  1230,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,  -702,  -653,-32768,-32768,    -4,
-32768,   375,-32768,   297,  -844,    18,  -165,  -265,  -567,   433,
-32768,    -2
};


#define	YYLAST		5999


static const short yytable[] = {   120,
   481,   330,   523,   119,   335,   420,    58,   523,   124,   163,
   166,    59,   179,   177,   182,   198,   595,   937,   938,   130,
   130,   189,   332,   132,   333,   456,   343,   354,   704,   356,
   189,   255,   747,   695,   127,   194,   134,   748,     3,   810,
   747,   645,   812,   648,   123,   748,   809,   126,   191,   193,
    96,    97,    98,    99,   316,   317,   100,   862,   747,    96,
    97,    98,    99,   748,   863,   100,   963,   170,   747,   964,
   171,   472,   344,   748,   524,   525,   526,   527,   127,   524,
   525,   526,   527,   131,   131,   811,   128,   416,   813,   129,
   646,   747,    71,   133,   647,   852,   748,   316,   317,   178,
   134,   150,   151,   851,   248,   249,   250,   998,   135,   251,
   254,  1040,   152,   259,   482,   256,   257,   696,   697,   153,
   279,   132,   280,   281,   282,   416,   284,   136,   286,   287,
   586,   298,   587,   441,   803,   316,   317,   528,   442,  1043,
   125,   183,   776,   164,   167,   137,   180,   314,   315,   199,
   596,   334,   296,   318,   190,   138,   315,   302,   112,   113,
   316,   317,  1046,   192,   195,   488,   196,   747,   589,   578,
   341,   342,   748,   345,   579,   347,   601,   139,   350,   351,
   316,   317,   331,   316,   317,   512,   143,   336,   337,   615,
   359,   105,   106,   107,   108,   363,   364,   365,   366,   367,
   368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
   378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
   388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
   398,   399,   400,   401,   402,   403,   404,   889,  1097,   406,
   407,   408,   409,   148,   747,   112,   113,   708,   415,   748,
    71,   411,   586,   196,   421,   316,   317,   426,   427,   428,
   429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
   439,   440,   487,  1011,   419,  1014,   416,  1017,   447,   200,
   449,   201,   149,   747,   797,   249,   415,   747,   748,   416,
   316,   317,   748,   157,   460,   461,   462,   165,   464,   465,
   466,   467,   468,   469,   470,   793,   747,   841,   168,   842,
   586,   748,   189,   687,   169,  1126,   483,   484,   485,   248,
   249,   486,   477,   477,   489,   947,   747,   480,   480,   499,
   948,   748,   158,   503,   504,   159,   160,   316,   317,   508,
   172,    96,    97,    98,    99,  1077,   718,   100,   516,   105,
   106,   107,   108,   519,  1128,   319,   747,   852,  1130,   521,
   852,   748,   747,   852,   273,   274,   275,   748,   496,   497,
   112,   113,   276,   105,   106,   107,   108,  1132,   588,   752,
   753,   754,   755,   105,   106,   107,   108,   202,  1108,   203,
  1111,  1002,  1114,   987,   112,   113,  1117,  1152,   876,   154,
   156,   204,   162,   205,   112,   113,   584,   316,   317,   249,
   175,   150,   151,   416,   173,   592,   591,   590,   316,   317,
   693,   174,   152,   852,  1140,   328,  1142,  1153,  1144,   161,
   585,   176,   729,  1154,   112,   113,   522,   415,   602,   186,
   405,   189,   667,   184,   796,   798,   416,   584,   613,   206,
   415,   207,   617,   618,   852,   820,   185,   852,   623,   187,
   852,   316,   317,   852,   189,   208,   188,   209,   633,   634,
    96,    97,    98,    99,   316,   317,   100,   637,   739,   416,
   416,   416,   416,   730,   316,   317,   852,   210,   852,   211,
   852,   746,   649,    96,    97,    98,    99,   316,   317,   100,
   212,   843,   213,   844,   140,   141,   661,   142,   663,   664,
   316,   317,   316,   317,   845,   242,   846,   669,   214,   668,
   215,   917,   216,   311,   217,   313,   218,   928,   219,   975,
   220,   320,   221,   112,   113,   327,   262,   263,   264,   265,
   266,   667,   267,   268,   269,   270,   271,   272,   273,   274,
   275,   677,   678,   826,   827,   416,   276,   258,   316,   317,
   112,   113,   316,   317,   260,   679,   680,   681,   682,   683,
   684,   685,   361,   277,   415,   977,   243,   688,   689,   979,
   244,   692,   265,   266,   698,   267,   268,   269,   270,   271,
   272,   273,   274,   275,   707,   316,   317,   316,   317,   276,
   316,   317,   222,   245,   223,   112,   113,   415,   278,   584,
   246,   452,  1039,   196,  1042,   283,   224,  1045,   225,   835,
   836,   711,   712,   226,   714,   227,   716,   717,   285,   299,
   267,   268,   269,   270,   271,   272,   273,   274,   275,   300,
   415,   415,   415,   415,   276,   144,   758,   759,   145,   146,
   301,   147,   764,  1006,   112,   113,    24,    25,    26,    27,
   614,    29,   196,   228,   230,   229,   231,   778,   779,    35,
    36,   305,   762,   763,   303,   304,   766,   271,   272,   273,
   274,   275,   232,   234,   233,   235,   236,   276,   237,   668,
   475,   476,   306,   943,   799,   238,   307,   239,   804,   313,
   308,   264,   265,   266,   808,   267,   268,   269,   270,   271,
   272,   273,   274,   275,   309,   240,   415,   241,   821,   276,
   822,   576,   586,   577,   616,   310,   903,   586,   904,   722,
   814,   805,   816,   806,   837,   838,   839,   586,   586,   819,
   853,   847,   340,   823,   824,   825,   321,   322,   828,   829,
   830,   831,   832,   833,   834,   586,   586,   854,   855,   586,
   876,   856,   877,   866,   867,   868,   586,   953,   896,   954,
   323,   329,   873,   870,   876,   346,   988,   879,   876,  1050,
  1032,  1051,   953,  1135,  1086,  1136,  1157,   338,  1158,   339,
   348,   349,   770,   883,   882,   262,   263,   264,   265,   266,
   352,   267,   268,   269,   270,   271,   272,   273,   274,   275,
   353,   355,   357,   881,   358,   276,   360,   276,  1018,   410,
   413,   901,   902,   422,   944,   423,   424,   453,   458,   463,
   471,   911,   498,   912,   501,   502,   507,   510,   581,   513,
   580,   582,   583,   593,   477,   261,   632,   594,   598,   480,
   600,   631,   934,   935,   603,   604,   605,   607,   609,   610,
   619,   641,   635,   636,   946,   651,   652,   929,   655,   949,
   950,   656,   657,   659,   660,   672,   673,   676,   674,   686,
   691,   694,   940,   699,   700,   962,  1078,   702,   703,   706,
   725,   713,   966,   951,   262,   263,   264,   265,   266,   715,
   267,   268,   269,   270,   271,   272,   273,   274,   275,   726,
   973,   727,   728,   731,   276,   425,   771,   732,   733,   734,
   735,   736,   737,   982,   738,   751,   777,   757,   760,   761,
   767,   765,   772,   773,   774,   775,   991,   782,   992,   792,
   794,   801,   807,   995,   800,   815,   817,   818,   999,   262,
   263,   264,   265,   266,   840,   267,   268,   269,   270,   271,
   272,   273,   274,   275,   849,   859,   860,   850,   865,   276,
  1009,   701,  1012,   869,  1015,   871,   477,   710,   884,  1021,
  1022,   480,   885,   887,   939,  1025,   893,   894,   898,   880,
   895,  1030,  1031,   899,   900,   905,   906,   907,   724,  1034,
  1020,   908,  1037,   909,   910,   919,  1024,   922,   925,   930,
  1028,   931,   743,   744,   745,   932,   933,   952,   936,   262,
   263,   264,   265,   266,   879,   267,   268,   269,   270,   271,
   272,   273,   274,   275,  1067,   955,   956,  1071,   957,   276,
  1075,   959,   960,   961,   969,   971,   974,   990,  1000,  1033,
   965,  1003,   756,  1023,   983,  1088,   972,  1089,  1035,  1120,
  1061,  1065,  1068,  1069,  1072,  1001,   976,  1079,  1073,   978,
   980,  1083,  1084,   981,  1055,   262,   263,   264,   265,   266,
   989,   267,   268,   269,   270,   271,   272,   273,   274,   275,
  1029,  1063,  1036,  1049,  1054,   276,  1057,  1076,  1080,  1081,
  1082,  1122,   262,   263,   264,   265,   266,  1085,   267,   268,
   269,   270,   271,   272,   273,   274,   275,  1090,  1119,  1103,
   848,  1091,   276,  1093,  1095,  1109,  1112,  1115,  1118,  1146,
  1101,  1124,  1147,  1100,  1150,   262,   263,   264,   265,   266,
  1125,   267,   268,   269,   270,   271,   272,   273,   274,   275,
  1162,  1163,   802,  1102,  1164,   276,   262,   263,   264,   265,
   266,  1168,   267,   268,   269,   270,   271,   272,   273,   274,
   275,  1104,  1107,  1139,  1141,  1127,   276,  1143,  1129,  1131,
  1145,  1148,    68,   288,  1133,   891,  1134,   892,    72,    73,
    74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
    84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
    94,    95,  1137,  1151,  1138,   918,  1155,   921,  1159,   924,
   289,  1160,  1161,  1165,  1169,  1171,  1173,  1174,  1058,   670,
    57,    65,   986,   886,     0,     0,     0,     0,     0,     0,
    24,    25,    26,    27,    28,    29,     0,     0,     0,     0,
     0,     0,     0,    35,    36,     0,   262,   263,   264,   265,
   266,     0,   267,   268,   269,   270,   271,   272,   273,   274,
   275,     0,     0,     0,     0,     0,   276,     0,     0,     0,
   958,   101,   102,   103,   104,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   109,
   290,     0,     0,     0,     0,   111,     0,     0,     0,     0,
   114,     0,    68,   247,     0,   117,     0,   291,    72,    73,
    74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
    84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
    94,    95,     0,     0,     0,     0,     0,     0,     0,  1010,
     0,  1013,     0,  1016,    68,   247,     0,     0,     0,     0,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    95,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,     0,     0,
     0,   101,   102,   103,   104,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   109,
   110,     0,     0,     0,     0,   111,     0,     0,     0,     0,
   114,     0,     0,   252,     0,   117,     0,   253,     0,     0,
     0,     0,     0,   101,   102,   103,   104,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   109,   110,     0,     0,     0,     0,   111,     0,     0,
     0,     0,   114,     0,     0,   611,     0,   117,     0,   612,
    68,   247,     0,     0,     0,     0,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
     0,     0,     0,     0,     0,     0,     0,    68,   247,     0,
     0,     0,     0,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,    68,   454,     0,
     0,     0,     0,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,     0,     0,   101,
   102,   103,   104,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   109,   110,     0,
     0,     0,     0,   111,     0,     0,     0,     0,   114,     0,
     0,   720,     0,   117,     0,   721,   101,   102,   103,   104,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   324,   325,     0,     0,     0,     0,
   111,     0,     0,     0,     0,   326,   101,   102,   103,   104,
   117,     0,   153,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   109,   110,     0,     0,     0,     0,
   111,     0,     0,     0,     0,   114,     0,    68,    69,    70,
   117,    71,   455,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,     0,    96,    97,
    98,    99,     0,     0,   100,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    68,   288,     0,     0,
     0,     0,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,     0,     0,     0,     0,
     0,     0,     0,     0,   289,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   101,   102,   103,   104,
   105,   106,   107,   108,    24,    25,    26,    27,    28,    29,
     0,     0,     0,     0,   109,   110,     0,    35,    36,     0,
   111,   112,   113,     0,     0,   114,     0,   115,     0,   116,
   117,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   101,   102,   103,   104,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   109,   414,     0,     0,     0,     0,   111,
     0,     0,     0,     0,   114,    68,   247,   189,     0,   117,
     0,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
    91,    92,    93,    94,    95,     0,    96,    97,    98,    99,
    68,   247,   100,     0,     0,     0,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    68,   454,     0,     0,     0,     0,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
   967,     0,     0,     0,   101,   102,   103,   104,     0,     0,
     0,     0,     0,     0,     0,   968,     0,     0,     0,     0,
     0,     0,   109,   110,     0,     0,     0,     0,   111,     0,
   970,     0,     0,   114,     0,     0,     0,     0,   117,   101,
   102,   103,   104,     0,     0,  1056,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   109,   110,     0,
     0,     0,   457,   111,     0,     0,     0,     0,   114,   101,
   102,   103,   104,   117,     0,     0,     0,   514,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   109,   110,     0,
     0,     0,   599,   111,     0,     0,     0,     0,   114,     0,
     0,     0,     0,   117,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,   262,
   263,   264,   265,   266,   276,   267,   268,   269,   270,   271,
   272,   273,   274,   275,   262,   263,   264,   265,   266,   276,
   267,   268,   269,   270,   271,   272,   273,   274,   275,   262,
   263,   264,   265,   266,   276,   267,   268,   269,   270,   271,
   272,   273,   274,   275,   262,   263,   264,   265,   266,   276,
   267,   268,   269,   270,   271,   272,   273,   274,   275,   262,
   263,   264,   265,   266,   276,   267,   268,   269,   270,   271,
   272,   273,   274,   275,   262,   263,   264,   265,   266,   276,
   267,   268,   269,   270,   271,   272,   273,   274,   275,   723,
     0,     0,     0,     0,   276,     0,     0,     0,     0,   262,
   263,   264,   265,   266,   769,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   418,     0,   490,     9,    10,   491,   492,
    13,   493,    15,     0,    16,     0,    18,    19,     0,    21,
    22,   262,   263,   264,   265,   266,     0,   267,   268,   269,
   270,   271,   272,   273,   274,   275,    34,     0,     0,     0,
     0,   276,     0,     0,     0,    38,    39,    40,   915,     0,
   916,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    50,     0,     0,     0,     0,     0,     0,
     0,   262,   263,   264,   265,   266,     0,   267,   268,   269,
   270,   271,   272,   273,   274,   275,   262,   263,   264,   265,
   266,   276,   267,   268,   269,   270,   271,   272,   273,   274,
   275,    -3,     1,   494,     0,    -3,   276,     0,   262,   263,
   264,   265,   266,     0,   267,   268,   269,   270,   271,   272,
   273,   274,   275,     0,     0,     0,     0,     0,   276,     0,
     0,     0,     0,     0,    -3,   941,     0,   942,     0,    -3,
    -3,     0,    -3,    -3,    -3,    -3,    -3,    -3,    -3,    -3,
     0,    -3,    -3,    -3,    -3,    -3,    -3,    -3,     0,     0,
     0,    -3,    -3,    -3,    -3,    -3,    -3,    -3,     0,    -3,
    -3,    -3,    -3,    -3,     0,    -3,    -3,     0,     0,     0,
     0,    -3,    -3,    -3,    -3,     0,     0,     0,     0,    -3,
     0,    -3,     0,    -3,    -3,    -3,    -3,    -3,    -3,    -3,
    -3,    -3,    -3,   490,     9,    10,   491,   492,    13,   493,
    15,     0,    16,     0,    18,    19,     0,    21,    22,     0,
     0,     0,     0,     0,   490,     9,    10,   491,   492,    13,
   493,    15,     0,    16,    34,    18,    19,     0,    21,    22,
     0,     0,     0,    38,    39,    40,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    34,     0,     0,     0,     0,
     0,    50,     0,     0,    38,    39,    40,     0,     0,   490,
     9,    10,   491,   492,    13,   493,    15,     0,    16,     0,
    18,    19,    50,    21,    22,   262,   263,   264,   265,   266,
     0,   267,   268,   269,   270,   271,   272,   273,   274,   275,
    34,   500,     0,     0,     0,   276,     0,   412,     0,    38,
    39,    40,   473,     0,   490,     9,    10,   491,   492,    13,
   493,    15,   517,    16,     0,    18,    19,    50,    21,    22,
     0,     0,     0,     0,     0,   490,     9,    10,   491,   492,
    13,   493,    15,     0,    16,    34,    18,    19,     0,    21,
    22,     0,     0,     0,    38,    39,    40,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    34,   518,     0,     0,
     0,     0,    50,     0,     0,    38,    39,    40,     0,     0,
   490,     9,    10,   491,   492,    13,   493,    15,     0,    16,
     0,    18,    19,    50,    21,    22,   262,   263,   264,   265,
   266,     0,   267,   268,   269,   270,   271,   272,   273,   274,
   275,    34,   642,     0,     0,     0,   276,     0,     0,     0,
    38,    39,    40,   443,     0,   490,     9,    10,   491,   492,
    13,   493,    15,   662,    16,     0,    18,    19,    50,    21,
    22,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     4,     0,     0,     0,     0,     0,    34,     0,     0,     0,
     0,     0,     0,     0,     0,    38,    39,    40,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,  1047,     5,
     0,     0,     0,    50,     6,     7,     0,     8,     9,    10,
    11,    12,    13,    14,    15,     0,    16,    17,    18,    19,
    20,    21,    22,     0,     0,     0,    23,    24,    25,    26,
    27,    28,    29,     0,    30,    31,    32,    33,    34,     0,
    35,    36,     0,  1098,     0,     0,    37,    38,    39,    40,
     0,     0,     0,     0,    41,     0,    42,     0,    43,    44,
    45,    46,    47,    48,    49,    50,    51,    52,   490,     9,
    10,   491,   492,    13,   493,    15,     0,    16,     0,    18,
    19,     0,    21,    22,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,    34,
     0,     0,     0,     0,   276,     0,     0,     0,    38,    39,
    40,  1007,     0,  1008,     0,     0,     0,     0,     0,     0,
     0,   262,   263,   264,   265,   266,    50,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,     0,     0,   262,   263,   264,   265,   266,
   620,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,     0,     0,   262,
   263,   264,   265,   266,   624,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   262,   263,   264,   265,   266,   625,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,     0,     0,   262,   263,   264,
   265,   266,   719,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,     0,
     0,   262,   263,   264,   265,   266,   742,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,     0,     0,   262,   263,   264,   265,   266,
   913,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,     0,     0,   262,
   263,   264,   265,   266,   927,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   262,   263,   264,   265,   266,  1019,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,     0,     0,   262,   263,   264,
   265,   266,  1026,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,     0,
     0,   262,   263,   264,   265,   266,  1027,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,     0,     0,   262,   263,   264,   265,   266,
  1038,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,     0,     0,   262,
   263,   264,   265,   266,  1041,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   262,   263,   264,   265,   266,  1044,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,     0,     0,   262,   263,   264,
   265,   266,  1052,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,     0,
     0,   262,   263,   264,   265,   266,  1053,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,     0,     0,   262,   263,   264,   265,   266,
  1064,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,     0,     0,   262,
   263,   264,   265,   266,  1092,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   262,   263,   264,   265,   266,  1094,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,     0,     0,   262,   263,   264,
   265,   266,  1096,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,     0,
     0,   262,   263,   264,   265,   266,  1106,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,     0,     0,   262,   263,   264,   265,   266,
  1167,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,     0,     0,   262,
   263,   264,   265,   266,  1170,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,   262,   263,   264,   265,   266,   473,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,   262,   263,   264,   265,   266,   474,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,   262,   263,   264,   265,   266,
   511,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,   262,   263,   264,
   265,   266,   556,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,   262,
   263,   264,   265,   266,   557,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,   262,   263,   264,   265,   266,   570,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,   262,   263,   264,   265,   266,   571,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,   262,   263,   264,   265,   266,
   572,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,   262,   263,   264,
   265,   266,   573,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,   262,
   263,   264,   265,   266,   574,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,   262,   263,   264,   265,   266,   575,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,   262,   263,   264,   265,   266,   638,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,   262,   263,   264,   265,   266,
   639,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,   262,   263,   264,
   265,   266,   640,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,   262,
   263,   264,   265,   266,   709,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,   262,   263,   264,   265,   266,   740,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,   262,   263,   264,   265,   266,   741,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,   262,   263,   264,   265,   266,
   768,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,   262,   263,   264,
   265,   266,   857,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,   262,
   263,   264,   265,   266,   858,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,   262,   263,   264,   265,   266,   874,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,   262,   263,   264,   265,   266,   875,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,   262,   263,   264,   265,   266,
   890,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,   262,   263,   264,
   265,   266,   897,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,   262,
   263,   264,   265,   266,   984,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,   262,   263,   264,   265,   266,   985,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,   262,   263,   264,   265,   266,   993,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,   262,   263,   264,   265,   266,
   996,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,   262,   263,   264,
   265,   266,   997,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,   262,
   263,   264,   265,   266,  1004,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,   262,   263,   264,   265,   266,  1005,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,   262,   263,   264,   265,   266,  1060,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,   262,   263,   264,   265,   266,
  1062,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,   262,   263,   264,
   265,   266,  1156,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,   262,
   263,   264,   265,   266,  1166,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   520,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   535,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   537,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   539,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   541,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   543,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   545,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   547,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   549,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   551,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   553,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   555,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   559,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   561,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   563,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   565,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   567,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   569,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   644,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   650,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   653,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   654,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   666,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   690,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   784,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   786,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   788,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   790,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,     0,     0,   791,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,     0,     0,   888,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,   412,   262,   263,   264,   265,   266,     0,   267,   268,
   269,   270,   271,   272,   273,   274,   275,     0,     0,     0,
     0,     0,   276,     0,   444,   262,   263,   264,   265,   266,
     0,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,   445,   262,   263,
   264,   265,   266,     0,   267,   268,   269,   270,   271,   272,
   273,   274,   275,     0,     0,     0,     0,     0,   276,     0,
   446,   262,   263,   264,   265,   266,     0,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,   448,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,   450,   262,   263,   264,
   265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,   451,
   262,   263,   264,   265,   266,     0,   267,   268,   269,   270,
   271,   272,   273,   274,   275,     0,     0,     0,     0,     0,
   276,     0,   459,   262,   263,   264,   265,   266,     0,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,   505,   262,   263,   264,   265,
   266,     0,   267,   268,   269,   270,   271,   272,   273,   274,
   275,     0,     0,     0,     0,     0,   276,     0,   506,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,   509,   262,   263,   264,   265,   266,     0,   267,   268,
   269,   270,   271,   272,   273,   274,   275,     0,     0,     0,
     0,     0,   276,     0,   515,   262,   263,   264,   265,   266,
     0,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,   534,   262,   263,
   264,   265,   266,     0,   267,   268,   269,   270,   271,   272,
   273,   274,   275,     0,     0,     0,     0,     0,   276,     0,
   536,   262,   263,   264,   265,   266,     0,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,   538,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,   540,   262,   263,   264,
   265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,   542,
   262,   263,   264,   265,   266,     0,   267,   268,   269,   270,
   271,   272,   273,   274,   275,     0,     0,     0,     0,     0,
   276,     0,   544,   262,   263,   264,   265,   266,     0,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,   546,   262,   263,   264,   265,
   266,     0,   267,   268,   269,   270,   271,   272,   273,   274,
   275,     0,     0,     0,     0,     0,   276,     0,   548,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,   550,   262,   263,   264,   265,   266,     0,   267,   268,
   269,   270,   271,   272,   273,   274,   275,     0,     0,     0,
     0,     0,   276,     0,   552,   262,   263,   264,   265,   266,
     0,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,   554,   262,   263,
   264,   265,   266,     0,   267,   268,   269,   270,   271,   272,
   273,   274,   275,     0,     0,     0,     0,     0,   276,     0,
   558,   262,   263,   264,   265,   266,     0,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,   560,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,   562,   262,   263,   264,
   265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,   564,
   262,   263,   264,   265,   266,     0,   267,   268,   269,   270,
   271,   272,   273,   274,   275,     0,     0,     0,     0,     0,
   276,     0,   566,   262,   263,   264,   265,   266,     0,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,   568,   262,   263,   264,   265,
   266,     0,   267,   268,   269,   270,   271,   272,   273,   274,
   275,     0,     0,     0,     0,     0,   276,     0,   606,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,   608,   262,   263,   264,   265,   266,     0,   267,   268,
   269,   270,   271,   272,   273,   274,   275,     0,     0,     0,
     0,     0,   276,     0,   621,   262,   263,   264,   265,   266,
     0,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,   622,   262,   263,
   264,   265,   266,     0,   267,   268,   269,   270,   271,   272,
   273,   274,   275,     0,     0,     0,     0,     0,   276,     0,
   626,   262,   263,   264,   265,   266,     0,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,   627,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,   628,   262,   263,   264,
   265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,   629,
   262,   263,   264,   265,   266,     0,   267,   268,   269,   270,
   271,   272,   273,   274,   275,     0,     0,     0,     0,     0,
   276,     0,   630,   262,   263,   264,   265,   266,     0,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,   658,   262,   263,   264,   265,
   266,     0,   267,   268,   269,   270,   271,   272,   273,   274,
   275,     0,     0,     0,     0,     0,   276,     0,   665,   262,
   263,   264,   265,   266,     0,   267,   268,   269,   270,   271,
   272,   273,   274,   275,     0,     0,     0,     0,     0,   276,
     0,   783,   262,   263,   264,   265,   266,     0,   267,   268,
   269,   270,   271,   272,   273,   274,   275,     0,     0,     0,
     0,     0,   276,     0,   785,   262,   263,   264,   265,   266,
     0,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     0,     0,     0,     0,     0,   276,     0,   787,   262,   263,
   264,   265,   266,     0,   267,   268,   269,   270,   271,   272,
   273,   274,   275,     0,     0,     0,     0,     0,   276,     0,
   789,   262,   263,   264,   265,   266,     0,   267,   268,   269,
   270,   271,   272,   273,   274,   275,     0,     0,     0,     0,
     0,   276,     0,   795,   262,   263,   264,   265,   266,     0,
   267,   268,   269,   270,   271,   272,   273,   274,   275,     0,
     0,     0,     0,     0,   276,     0,   861,   262,   263,   264,
   265,   266,     0,   267,   268,   269,   270,   271,   272,   273,
   274,   275,     0,     0,     0,     0,     0,   276,     0,   914,
   262,   263,   264,   265,   266,     0,   267,   268,   269,   270,
   271,   272,   273,   274,   275,     0,     0,     0,     0,     0,
   276,     0,   945,   262,   263,   264,   265,   266,     0,   267,
   268,   269,   270,   271,   272,   273,   274,   275,     0,     0,
     0,     0,     0,   276,     0,  1059,   262,   263,   264,   265,
   266,     0,   267,   268,   269,   270,   271,   272,   273,   274,
   275,     0,     0,     0,     0,     0,   276,     0,  1105
};

static const short yycheck[] = {     4,
   319,   164,     4,     4,   167,   255,     2,     4,     6,     4,
     4,     2,     4,    45,     4,     4,     4,   862,   863,    67,
    67,     5,     4,    67,     6,   291,    85,   190,   596,   192,
     5,     4,    68,     4,   131,     4,   131,    73,     6,     6,
    68,   138,     6,   138,   131,    73,     6,     6,    51,    52,
    34,    35,    36,    37,   120,   121,    40,   131,    68,    34,
    35,    36,    37,    73,   138,    40,     6,    41,    68,     6,
    44,   137,   131,    73,    76,    77,    78,    79,   131,    76,
    77,    78,    79,   131,   131,    52,   131,   253,    52,   131,
   138,    68,     7,   131,   138,   749,    73,   120,   121,   131,
   131,   120,   121,   139,   109,   110,   111,   952,    49,   114,
   115,   139,   131,   118,   137,    88,    89,    88,    89,   138,
   125,    67,   127,   128,   129,   291,   131,   131,   133,   134,
   137,   136,   139,   132,   702,   120,   121,   139,   137,   139,
   138,   131,   139,   138,   138,    45,   138,   152,   153,   138,
   138,   133,   135,   138,   138,    45,   161,   140,   127,   128,
   120,   121,   139,   138,   133,   328,   135,    68,   418,   132,
   175,   176,    73,   178,   137,   180,   442,    45,   183,   184,
   120,   121,   165,   120,   121,   348,    47,   170,   171,   455,
   195,   106,   107,   108,   109,   200,   201,   202,   203,   204,
   205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
   215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
   225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
   235,   236,   237,   238,   239,   240,   241,   805,   139,   242,
   243,   244,   245,   131,    68,   127,   128,   132,   253,    73,
     7,   133,   137,   135,   255,   120,   121,   262,   263,   264,
   265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
   275,   276,   137,   976,     7,   978,   442,   980,   283,   131,
   285,   133,   138,    68,     7,   290,   291,    68,    73,   455,
   120,   121,    73,   138,   299,   300,   301,    45,   303,   304,
   305,   306,   307,   308,   309,   132,    68,   137,     6,   139,
   137,    73,     5,   579,     6,   139,   321,   322,   323,   324,
   325,   326,   318,   319,   329,   132,    68,   318,   319,   334,
   137,    73,    41,   338,   339,    44,    45,   120,   121,   344,
     4,    34,    35,    36,    37,  1048,   612,    40,   353,   106,
   107,   108,   109,   358,   139,   138,    68,  1011,   139,   360,
  1014,    73,    68,  1017,   122,   123,   124,    73,     6,     7,
   127,   128,   130,   106,   107,   108,   109,   139,   135,   645,
   646,   647,   648,   106,   107,   108,   109,   131,  1091,   133,
  1093,   959,  1095,   132,   127,   128,  1099,   139,   137,    25,
    26,   131,    28,   133,   127,   128,   411,   120,   121,   414,
   131,   120,   121,   579,     4,   420,   419,   418,   120,   121,
   586,     4,   131,  1077,  1127,   138,  1129,   139,  1131,   138,
   413,   131,     6,   139,   127,   128,   138,   442,   443,     4,
     4,     5,   135,   131,   694,   695,   612,   452,   453,   131,
   455,   133,   457,   458,  1108,   721,     6,  1111,   463,     4,
  1114,   120,   121,  1117,     5,   131,    45,   133,   473,   474,
    34,    35,    36,    37,   120,   121,    40,   482,   137,   645,
   646,   647,   648,    57,   120,   121,  1140,   131,  1142,   133,
  1144,   137,   497,    34,    35,    36,    37,   120,   121,    40,
   131,   137,   133,   139,    44,    45,   511,    47,   513,   514,
   120,   121,   120,   121,   137,   131,   139,   520,   131,   520,
   133,   840,   131,   149,   133,   151,   131,   137,   133,   137,
   131,   157,   133,   127,   128,   161,   110,   111,   112,   113,
   114,   135,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   556,   557,    58,    59,   721,   130,     4,   120,   121,
   127,   128,   120,   121,     6,   570,   571,   572,   573,   574,
   575,   576,   198,     6,   579,   137,   131,   580,   583,   137,
   131,   586,   113,   114,   589,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   599,   120,   121,   120,   121,   130,
   120,   121,   131,   131,   133,   127,   128,   612,     5,   614,
   131,   133,   137,   135,   137,   131,   131,   137,   133,     6,
     7,   604,   605,   131,   607,   133,   609,   610,   131,   138,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   131,
   645,   646,   647,   648,   130,    41,   651,   652,    44,    45,
   131,    47,   657,   972,   127,   128,    61,    62,    63,    64,
   133,    66,   135,   131,   131,   133,   133,   672,   673,    74,
    75,   131,   655,   656,   138,   138,   659,   120,   121,   122,
   123,   124,   131,   131,   133,   133,   131,   130,   133,   690,
   316,   317,   131,     8,   695,   131,   131,   133,   703,   325,
   131,   112,   113,   114,   709,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   131,   131,   721,   133,   723,   130,
   725,   133,   137,   135,   139,     4,     4,   137,     6,   139,
   713,   137,   715,   139,   739,   740,   741,   137,   137,   139,
   139,   746,     6,   726,   727,   728,   138,   138,   731,   732,
   733,   734,   735,   736,   737,   137,   137,   139,   139,   137,
   137,   139,   139,   768,   769,   770,   137,   137,   139,   139,
   138,   133,   777,   774,   137,   135,   139,   782,   137,   137,
   139,   139,   137,   137,   139,   139,   137,   133,   139,   133,
   138,    91,     8,   798,   797,   110,   111,   112,   113,   114,
     6,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   131,     6,     6,   796,   133,   130,     4,   130,   981,     5,
     7,   826,   827,   135,   139,     7,   133,   138,     7,     7,
   132,   836,     6,   836,     7,     7,    86,    88,   132,   138,
   137,   132,   137,     6,   840,     6,   472,     4,   134,   840,
     6,   135,   857,   858,     7,     7,     7,     7,     7,     7,
     7,   487,   139,   139,   869,   138,   138,   850,     7,   874,
   875,     7,   131,     7,   135,   131,   131,     6,   138,     4,
     6,   134,   865,     6,     6,   890,  1049,     7,   133,     6,
   138,     7,   897,   876,   110,   111,   112,   113,   114,     7,
   116,   117,   118,   119,   120,   121,   122,   123,   124,     7,
   915,     7,     7,     7,   130,     6,   132,     7,     7,     7,
     7,     7,     7,   928,     4,     6,   131,     6,     6,     6,
     4,     7,     7,     6,     4,     6,   941,   138,   943,   132,
   132,     7,     6,   948,   135,     6,     6,     6,   953,   110,
   111,   112,   113,   114,   138,   116,   117,   118,   119,   120,
   121,   122,   123,   124,     6,     6,     6,   138,    87,   130,
   975,     6,   977,   138,   979,     6,   972,   603,     6,   984,
   985,   972,     4,     6,    87,   990,     6,     6,     6,   135,
   134,   996,   997,     6,     6,     6,     6,     6,     6,  1004,
   983,     6,  1007,     6,     6,     6,   989,     6,     6,     6,
   993,     6,   638,   639,   640,     6,     6,   138,     7,   110,
   111,   112,   113,   114,  1029,   116,   117,   118,   119,   120,
   121,   122,   123,   124,  1039,     4,     6,  1042,     6,   130,
  1045,     7,     6,   135,     6,     6,   139,    84,     6,     6,
   134,    89,     6,    87,   137,  1060,   138,  1062,     5,    84,
     6,     6,     6,     6,     6,   132,   138,  1050,     6,   138,
   138,  1054,  1055,   138,   137,   110,   111,   112,   113,   114,
   138,   116,   117,   118,   119,   120,   121,   122,   123,   124,
   138,   137,   139,   138,   138,   130,   139,     6,     6,     6,
     6,  1104,   110,   111,   112,   113,   114,     6,   116,   117,
   118,   119,   120,   121,   122,   123,   124,     5,  1101,     6,
   746,   138,   130,   138,   138,     6,     6,     6,     6,  1134,
   137,     6,  1135,   139,  1137,   110,   111,   112,   113,   114,
     5,   116,   117,   118,   119,   120,   121,   122,   123,   124,
  1155,  1156,     6,   139,  1157,   130,   110,   111,   112,   113,
   114,  1166,   116,   117,   118,   119,   120,   121,   122,   123,
   124,   138,   137,     6,     6,   138,   130,     6,   138,   138,
    84,     6,     3,     4,   139,   811,   138,   813,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
    31,    32,   138,     6,   139,   841,   138,   843,     6,   845,
    41,     6,     6,     6,     6,     6,     0,     0,  1029,   522,
     2,     2,   936,   801,    -1,    -1,    -1,    -1,    -1,    -1,
    61,    62,    63,    64,    65,    66,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    74,    75,    -1,   110,   111,   112,   113,
   114,    -1,   116,   117,   118,   119,   120,   121,   122,   123,
   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
     6,   102,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
   121,    -1,    -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,
   131,    -1,     3,     4,    -1,   136,    -1,   138,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   975,
    -1,   977,    -1,   979,     3,     4,    -1,    -1,    -1,    -1,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
    29,    30,    31,    32,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
    -1,   102,   103,   104,   105,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
   121,    -1,    -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,
   131,    -1,    -1,   134,    -1,   136,    -1,   138,    -1,    -1,
    -1,    -1,    -1,   102,   103,   104,   105,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   120,   121,    -1,    -1,    -1,    -1,   126,    -1,    -1,
    -1,    -1,   131,    -1,    -1,   134,    -1,   136,    -1,   138,
     3,     4,    -1,    -1,    -1,    -1,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,    -1,
    -1,    -1,    -1,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,     3,     4,    -1,
    -1,    -1,    -1,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    -1,    -1,   102,
   103,   104,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,   121,    -1,
    -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,   131,    -1,
    -1,   134,    -1,   136,    -1,   138,   102,   103,   104,   105,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   120,   121,    -1,    -1,    -1,    -1,
   126,    -1,    -1,    -1,    -1,   131,   102,   103,   104,   105,
   136,    -1,   138,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   120,   121,    -1,    -1,    -1,    -1,
   126,    -1,    -1,    -1,    -1,   131,    -1,     3,     4,     5,
   136,     7,   138,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    -1,    34,    35,
    36,    37,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,    -1,    -1,
    -1,    -1,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
   106,   107,   108,   109,    61,    62,    63,    64,    65,    66,
    -1,    -1,    -1,    -1,   120,   121,    -1,    74,    75,    -1,
   126,   127,   128,    -1,    -1,   131,    -1,   133,    -1,   135,
   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   120,   121,    -1,    -1,    -1,    -1,   126,
    -1,    -1,    -1,    -1,   131,     3,     4,     5,    -1,   136,
    -1,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    -1,    34,    35,    36,    37,
     3,     4,    40,    -1,    -1,    -1,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
     3,     4,    -1,    -1,    -1,    -1,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
     6,    -1,    -1,    -1,   102,   103,   104,   105,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,     6,    -1,    -1,    -1,    -1,
    -1,    -1,   120,   121,    -1,    -1,    -1,    -1,   126,    -1,
     6,    -1,    -1,   131,    -1,    -1,    -1,    -1,   136,   102,
   103,   104,   105,    -1,    -1,     6,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,   121,    -1,
    -1,    -1,     8,   126,    -1,    -1,    -1,    -1,   131,   102,
   103,   104,   105,   136,    -1,    -1,    -1,     8,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,   121,    -1,
    -1,    -1,     8,   126,    -1,    -1,    -1,    -1,   131,    -1,
    -1,    -1,    -1,   136,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   110,
   111,   112,   113,   114,   130,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   110,   111,   112,   113,   114,   130,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   110,
   111,   112,   113,   114,   130,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   110,   111,   112,   113,   114,   130,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   110,
   111,   112,   113,   114,   130,   116,   117,   118,   119,   120,
   121,   122,   123,   124,   110,   111,   112,   113,   114,   130,
   116,   117,   118,   119,   120,   121,   122,   123,   124,     8,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,   110,
   111,   112,   113,   114,     8,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,    -1,    41,    42,    43,    44,    45,
    46,    47,    48,    -1,    50,    -1,    52,    53,    -1,    55,
    56,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    72,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,    81,    82,    83,   137,    -1,
   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
   119,   120,   121,   122,   123,   124,   110,   111,   112,   113,
   114,   130,   116,   117,   118,   119,   120,   121,   122,   123,
   124,     0,     1,   139,    -1,     4,   130,    -1,   110,   111,
   112,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,
    -1,    -1,    -1,    -1,    33,   137,    -1,   139,    -1,    38,
    39,    -1,    41,    42,    43,    44,    45,    46,    47,    48,
    -1,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
    -1,    60,    61,    62,    63,    64,    65,    66,    -1,    68,
    69,    70,    71,    72,    -1,    74,    75,    -1,    -1,    -1,
    -1,    80,    81,    82,    83,    -1,    -1,    -1,    -1,    88,
    -1,    90,    -1,    92,    93,    94,    95,    96,    97,    98,
    99,   100,   101,    41,    42,    43,    44,    45,    46,    47,
    48,    -1,    50,    -1,    52,    53,    -1,    55,    56,    -1,
    -1,    -1,    -1,    -1,    41,    42,    43,    44,    45,    46,
    47,    48,    -1,    50,    72,    52,    53,    -1,    55,    56,
    -1,    -1,    -1,    81,    82,    83,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    72,    -1,    -1,    -1,    -1,
    -1,    99,    -1,    -1,    81,    82,    83,    -1,    -1,    41,
    42,    43,    44,    45,    46,    47,    48,    -1,    50,    -1,
    52,    53,    99,    55,    56,   110,   111,   112,   113,   114,
    -1,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    72,   139,    -1,    -1,    -1,   130,    -1,   132,    -1,    81,
    82,    83,   137,    -1,    41,    42,    43,    44,    45,    46,
    47,    48,   139,    50,    -1,    52,    53,    99,    55,    56,
    -1,    -1,    -1,    -1,    -1,    41,    42,    43,    44,    45,
    46,    47,    48,    -1,    50,    72,    52,    53,    -1,    55,
    56,    -1,    -1,    -1,    81,    82,    83,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    72,   139,    -1,    -1,
    -1,    -1,    99,    -1,    -1,    81,    82,    83,    -1,    -1,
    41,    42,    43,    44,    45,    46,    47,    48,    -1,    50,
    -1,    52,    53,    99,    55,    56,   110,   111,   112,   113,
   114,    -1,   116,   117,   118,   119,   120,   121,   122,   123,
   124,    72,   139,    -1,    -1,    -1,   130,    -1,    -1,    -1,
    81,    82,    83,   137,    -1,    41,    42,    43,    44,    45,
    46,    47,    48,   139,    50,    -1,    52,    53,    99,    55,
    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     4,    -1,    -1,    -1,    -1,    -1,    72,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    81,    82,    83,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   139,    33,
    -1,    -1,    -1,    99,    38,    39,    -1,    41,    42,    43,
    44,    45,    46,    47,    48,    -1,    50,    51,    52,    53,
    54,    55,    56,    -1,    -1,    -1,    60,    61,    62,    63,
    64,    65,    66,    -1,    68,    69,    70,    71,    72,    -1,
    74,    75,    -1,   139,    -1,    -1,    80,    81,    82,    83,
    -1,    -1,    -1,    -1,    88,    -1,    90,    -1,    92,    93,
    94,    95,    96,    97,    98,    99,   100,   101,    41,    42,
    43,    44,    45,    46,    47,    48,    -1,    50,    -1,    52,
    53,    -1,    55,    56,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    72,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    81,    82,
    83,   137,    -1,   139,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   110,   111,   112,   113,   114,    99,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,   110,   111,   112,   113,   114,
   139,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   110,
   111,   112,   113,   114,   139,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   110,   111,   112,   113,   114,   139,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,   110,   111,   112,
   113,   114,   139,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,   110,   111,   112,   113,   114,   139,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,   110,   111,   112,   113,   114,
   139,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   110,
   111,   112,   113,   114,   139,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   110,   111,   112,   113,   114,   139,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,   110,   111,   112,
   113,   114,   139,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,   110,   111,   112,   113,   114,   139,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,   110,   111,   112,   113,   114,
   139,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   110,
   111,   112,   113,   114,   139,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   110,   111,   112,   113,   114,   139,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,   110,   111,   112,
   113,   114,   139,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,   110,   111,   112,   113,   114,   139,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,   110,   111,   112,   113,   114,
   139,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   110,
   111,   112,   113,   114,   139,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   110,   111,   112,   113,   114,   139,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,    -1,    -1,   110,   111,   112,
   113,   114,   139,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,
    -1,   110,   111,   112,   113,   114,   139,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,    -1,    -1,   110,   111,   112,   113,   114,
   139,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   110,
   111,   112,   113,   114,   139,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,   110,   111,   112,   113,   114,   137,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,   110,   111,   112,   113,   114,   137,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,   110,   111,   112,   113,   114,
   137,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,   111,   112,
   113,   114,   137,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,
   111,   112,   113,   114,   137,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,   110,   111,   112,   113,   114,   137,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,   110,   111,   112,   113,   114,   137,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,   110,   111,   112,   113,   114,
   137,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,   111,   112,
   113,   114,   137,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,
   111,   112,   113,   114,   137,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,   110,   111,   112,   113,   114,   137,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,   110,   111,   112,   113,   114,   137,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,   110,   111,   112,   113,   114,
   137,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,   111,   112,
   113,   114,   137,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,
   111,   112,   113,   114,   137,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,   110,   111,   112,   113,   114,   137,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,   110,   111,   112,   113,   114,   137,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,   110,   111,   112,   113,   114,
   137,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,   111,   112,
   113,   114,   137,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,
   111,   112,   113,   114,   137,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,   110,   111,   112,   113,   114,   137,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,   110,   111,   112,   113,   114,   137,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,   110,   111,   112,   113,   114,
   137,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,   111,   112,
   113,   114,   137,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,
   111,   112,   113,   114,   137,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,   110,   111,   112,   113,   114,   137,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,   110,   111,   112,   113,   114,   137,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,   110,   111,   112,   113,   114,
   137,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,   111,   112,
   113,   114,   137,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,
   111,   112,   113,   114,   137,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,   110,   111,   112,   113,   114,   137,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,   110,   111,   112,   113,   114,   137,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,   110,   111,   112,   113,   114,
   137,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,   111,   112,
   113,   114,   137,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   110,
   111,   112,   113,   114,   137,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,    -1,    -1,   134,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,   134,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,   132,   110,   111,   112,   113,   114,    -1,   116,   117,
   118,   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,
    -1,    -1,   130,    -1,   132,   110,   111,   112,   113,   114,
    -1,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,   110,   111,
   112,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,
   132,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,   132,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,   132,   110,   111,   112,
   113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,
   110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,
   130,    -1,   132,   110,   111,   112,   113,   114,    -1,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,   132,   110,   111,   112,   113,
   114,    -1,   116,   117,   118,   119,   120,   121,   122,   123,
   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,   132,   110,   111,   112,   113,   114,    -1,   116,   117,
   118,   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,
    -1,    -1,   130,    -1,   132,   110,   111,   112,   113,   114,
    -1,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,   110,   111,
   112,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,
   132,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,   132,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,   132,   110,   111,   112,
   113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,
   110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,
   130,    -1,   132,   110,   111,   112,   113,   114,    -1,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,   132,   110,   111,   112,   113,
   114,    -1,   116,   117,   118,   119,   120,   121,   122,   123,
   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,   132,   110,   111,   112,   113,   114,    -1,   116,   117,
   118,   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,
    -1,    -1,   130,    -1,   132,   110,   111,   112,   113,   114,
    -1,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,   110,   111,
   112,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,
   132,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,   132,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,   132,   110,   111,   112,
   113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,
   110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,
   130,    -1,   132,   110,   111,   112,   113,   114,    -1,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,   132,   110,   111,   112,   113,
   114,    -1,   116,   117,   118,   119,   120,   121,   122,   123,
   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,   132,   110,   111,   112,   113,   114,    -1,   116,   117,
   118,   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,
    -1,    -1,   130,    -1,   132,   110,   111,   112,   113,   114,
    -1,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,   110,   111,
   112,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,
   132,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,   132,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,   132,   110,   111,   112,
   113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,
   110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,
   130,    -1,   132,   110,   111,   112,   113,   114,    -1,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,   132,   110,   111,   112,   113,
   114,    -1,   116,   117,   118,   119,   120,   121,   122,   123,
   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,   110,
   111,   112,   113,   114,    -1,   116,   117,   118,   119,   120,
   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,
    -1,   132,   110,   111,   112,   113,   114,    -1,   116,   117,
   118,   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,
    -1,    -1,   130,    -1,   132,   110,   111,   112,   113,   114,
    -1,   116,   117,   118,   119,   120,   121,   122,   123,   124,
    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,   110,   111,
   112,   113,   114,    -1,   116,   117,   118,   119,   120,   121,
   122,   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,
   132,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
   119,   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,
    -1,   130,    -1,   132,   110,   111,   112,   113,   114,    -1,
   116,   117,   118,   119,   120,   121,   122,   123,   124,    -1,
    -1,    -1,    -1,    -1,   130,    -1,   132,   110,   111,   112,
   113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
   123,   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   132,
   110,   111,   112,   113,   114,    -1,   116,   117,   118,   119,
   120,   121,   122,   123,   124,    -1,    -1,    -1,    -1,    -1,
   130,    -1,   132,   110,   111,   112,   113,   114,    -1,   116,
   117,   118,   119,   120,   121,   122,   123,   124,    -1,    -1,
    -1,    -1,    -1,   130,    -1,   132,   110,   111,   112,   113,
   114,    -1,   116,   117,   118,   119,   120,   121,   122,   123,
   124,    -1,    -1,    -1,    -1,    -1,   130,    -1,   132
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 145 "Gmsh.y"
{ yyerrok; return 1; ;
    break;}
case 5:
#line 156 "Gmsh.y"
{ return 1; ;
    break;}
case 6:
#line 157 "Gmsh.y"
{ return 1; ;
    break;}
case 7:
#line 158 "Gmsh.y"
{ return 1; ;
    break;}
case 8:
#line 159 "Gmsh.y"
{ return 1; ;
    break;}
case 9:
#line 160 "Gmsh.y"
{ List_Delete(yyvsp[0].l); return 1; ;
    break;}
case 10:
#line 161 "Gmsh.y"
{ List_Delete(yyvsp[0].l); return 1; ;
    break;}
case 11:
#line 162 "Gmsh.y"
{ return 1; ;
    break;}
case 12:
#line 163 "Gmsh.y"
{ return 1; ;
    break;}
case 13:
#line 164 "Gmsh.y"
{ return 1; ;
    break;}
case 14:
#line 165 "Gmsh.y"
{ List_Delete(yyvsp[0].l); return 1; ;
    break;}
case 15:
#line 166 "Gmsh.y"
{ return 1; ;
    break;}
case 16:
#line 167 "Gmsh.y"
{ return 1; ;
    break;}
case 17:
#line 168 "Gmsh.y"
{ return 1; ;
    break;}
case 18:
#line 169 "Gmsh.y"
{ return 1; ;
    break;}
case 19:
#line 174 "Gmsh.y"
{
      Msg(DIRECT, yyvsp[-2].c);
      Free(yyvsp[-2].c);
    ;
    break;}
case 20:
#line 179 "Gmsh.y"
{
      char tmpstring[1024];
      int i = PrintListOfDouble(yyvsp[-4].c, yyvsp[-2].l, tmpstring);
      if(i < 0) 
	yymsg(GERROR, "Too few arguments in Printf");
      else if(i > 0)
	yymsg(GERROR, "%d extra argument%s in Printf", i, (i>1)?"s":"");
      else
	Msg(DIRECT, tmpstring);
      Free(yyvsp[-4].c);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 21:
#line 197 "Gmsh.y"
{ 
      if(!strcmp(yyvsp[-5].c, "View") && !CheckViewErrorFlags(View)){
	EndView(View, 0, yyname, yyvsp[-4].c);
      }
      Free(yyvsp[-5].c); Free(yyvsp[-4].c);
    ;
    break;}
case 22:
#line 204 "Gmsh.y"
{
      if(!strcmp(yyvsp[-7].c, "View") && !CheckViewErrorFlags(View)){
	EndView(View, 0, yyname, yyvsp[-6].c);
      }
      Free(yyvsp[-7].c); Free(yyvsp[-6].c); Free(yyvsp[-5].c);
    ;
    break;}
case 23:
#line 214 "Gmsh.y"
{
      View = BeginView(1); 
      for(int i = 0; i < VIEW_NB_ELEMENT_TYPES; i++){
	ViewErrorFlags[i] = 0;
      }
    ;
    break;}
case 29:
#line 229 "Gmsh.y"
{ ViewCoord[ViewCoordIdx] = yyvsp[0].d; ViewCoordIdx++; ;
    break;}
case 30:
#line 231 "Gmsh.y"
{ ViewCoord[ViewCoordIdx] = yyvsp[0].d; ViewCoordIdx++; ;
    break;}
case 31:
#line 236 "Gmsh.y"
{ if(ViewValueList) List_Add(ViewValueList, &yyvsp[0].d); ;
    break;}
case 32:
#line 238 "Gmsh.y"
{ if(ViewValueList) List_Add(ViewValueList, &yyvsp[0].d); ;
    break;}
case 33:
#line 243 "Gmsh.y"
{
      if(!strcmp(yyvsp[0].c, "SP")){
	ViewElementIdx = 0; ViewNumNodes = 1; ViewNumComp = 1;
	ViewValueList = View->SP; ViewNumList = &View->NbSP;
      }
      else if(!strcmp(yyvsp[0].c, "VP")){
	ViewElementIdx = 1; ViewNumNodes = 1; ViewNumComp = 3;
	ViewValueList = View->VP; ViewNumList = &View->NbVP;
      }
      else if(!strcmp(yyvsp[0].c, "TP")){
	ViewElementIdx = 2; ViewNumNodes = 1; ViewNumComp = 9;
	ViewValueList = View->TP; ViewNumList = &View->NbTP;
      }
      else if(!strcmp(yyvsp[0].c, "SL")){
	ViewElementIdx = 3; ViewNumNodes = 2; ViewNumComp = 1;
	ViewValueList = View->SL; ViewNumList = &View->NbSL;
      }
      else if(!strcmp(yyvsp[0].c, "VL")){
	ViewElementIdx = 4; ViewNumNodes = 2; ViewNumComp = 3;
	ViewValueList = View->VL; ViewNumList = &View->NbVL;
      }
      else if(!strcmp(yyvsp[0].c, "TL")){
	ViewElementIdx = 5; ViewNumNodes = 2; ViewNumComp = 9;
	ViewValueList = View->TL; ViewNumList = &View->NbTL;
      }
      else if(!strcmp(yyvsp[0].c, "ST")){
	ViewElementIdx = 6; ViewNumNodes = 3; ViewNumComp = 1;
	ViewValueList = View->ST; ViewNumList = &View->NbST;
      }
      else if(!strcmp(yyvsp[0].c, "VT")){
	ViewElementIdx = 7; ViewNumNodes = 3; ViewNumComp = 3;
	ViewValueList = View->VT; ViewNumList = &View->NbVT;
      }
      else if(!strcmp(yyvsp[0].c, "TT")){
	ViewElementIdx = 8; ViewNumNodes = 3; ViewNumComp = 9;
	ViewValueList = View->TT; ViewNumList = &View->NbTT;
      }
      else if(!strcmp(yyvsp[0].c, "SQ")){
	ViewElementIdx = 9; ViewNumNodes = 4; ViewNumComp = 1;
	ViewValueList = View->SQ; ViewNumList = &View->NbSQ;
      }
      else if(!strcmp(yyvsp[0].c, "VQ")){
	ViewElementIdx = 10; ViewNumNodes = 4; ViewNumComp = 3;
	ViewValueList = View->VQ; ViewNumList = &View->NbVQ;
      }
      else if(!strcmp(yyvsp[0].c, "TQ")){
	ViewElementIdx = 11; ViewNumNodes = 4; ViewNumComp = 9;
	ViewValueList = View->TQ; ViewNumList = &View->NbTQ;
      }
      else if(!strcmp(yyvsp[0].c, "SS")){
	ViewElementIdx = 12; ViewNumNodes = 4; ViewNumComp = 1;
	ViewValueList = View->SS; ViewNumList = &View->NbSS;
      }
      else if(!strcmp(yyvsp[0].c, "VS")){
	ViewElementIdx = 13; ViewNumNodes = 4; ViewNumComp = 3;
	ViewValueList = View->VS; ViewNumList = &View->NbVS;
      }
      else if(!strcmp(yyvsp[0].c, "TS")){
	ViewElementIdx = 14; ViewNumNodes = 4; ViewNumComp = 9;
	ViewValueList = View->TS; ViewNumList = &View->NbTS;
      }
      else if(!strcmp(yyvsp[0].c, "SH")){
	ViewElementIdx = 15; ViewNumNodes = 8; ViewNumComp = 1;
	ViewValueList = View->SH; ViewNumList = &View->NbSH;
      }
      else if(!strcmp(yyvsp[0].c, "VH")){
	ViewElementIdx = 16; ViewNumNodes = 8; ViewNumComp = 3;
	ViewValueList = View->VH; ViewNumList = &View->NbVH;
      }
      else if(!strcmp(yyvsp[0].c, "TH")){
	ViewElementIdx = 17; ViewNumNodes = 8; ViewNumComp = 9;
	ViewValueList = View->TH; ViewNumList = &View->NbTH;
      }
      else if(!strcmp(yyvsp[0].c, "SI")){
	ViewElementIdx = 18; ViewNumNodes = 6; ViewNumComp = 1;
	ViewValueList = View->SI; ViewNumList = &View->NbSI;
      }
      else if(!strcmp(yyvsp[0].c, "VI")){
	ViewElementIdx = 19; ViewNumNodes = 6; ViewNumComp = 3;
	ViewValueList = View->VI; ViewNumList = &View->NbVI;
      }
      else if(!strcmp(yyvsp[0].c, "TI")){
	ViewElementIdx = 20; ViewNumNodes = 6; ViewNumComp = 9;
	ViewValueList = View->TI; ViewNumList = &View->NbTI;
      }
      else if(!strcmp(yyvsp[0].c, "SY")){
	ViewElementIdx = 21; ViewNumNodes = 5; ViewNumComp = 1;
	ViewValueList = View->SY; ViewNumList = &View->NbSY;
      }
      else if(!strcmp(yyvsp[0].c, "VY")){
	ViewElementIdx = 22; ViewNumNodes = 5; ViewNumComp = 3;
	ViewValueList = View->VY; ViewNumList = &View->NbVY;
      }
      else if(!strcmp(yyvsp[0].c, "TY")){
	ViewElementIdx = 23; ViewNumNodes = 5; ViewNumComp = 9;
	ViewValueList = View->TY; ViewNumList = &View->NbTY;
      }
      else if(!strcmp(yyvsp[0].c, "SL2")){
	ViewElementIdx = 3; ViewNumNodes = 3; ViewNumComp = 1;
	ViewValueList = View->SL2; ViewNumList = &View->NbSL2;
      }
      else if(!strcmp(yyvsp[0].c, "VL2")){
	ViewElementIdx = 4; ViewNumNodes = 3; ViewNumComp = 3;
	ViewValueList = View->VL2; ViewNumList = &View->NbVL2;
      }
      else if(!strcmp(yyvsp[0].c, "TL2")){
	ViewElementIdx = 5; ViewNumNodes = 3; ViewNumComp = 9;
	ViewValueList = View->TL2; ViewNumList = &View->NbTL2;
      }
      else if(!strcmp(yyvsp[0].c, "ST2")){
	ViewElementIdx = 6; ViewNumNodes = 6; ViewNumComp = 1;
	ViewValueList = View->ST2; ViewNumList = &View->NbST2;
      }
      else if(!strcmp(yyvsp[0].c, "VT2")){
	ViewElementIdx = 7; ViewNumNodes = 6; ViewNumComp = 3;
	ViewValueList = View->VT2; ViewNumList = &View->NbVT2;
      }
      else if(!strcmp(yyvsp[0].c, "TT2")){
	ViewElementIdx = 8; ViewNumNodes = 6; ViewNumComp = 9;
	ViewValueList = View->TT2; ViewNumList = &View->NbTT2;
      }
      else if(!strcmp(yyvsp[0].c, "SQ2")){
	ViewElementIdx = 9; ViewNumNodes = 9; ViewNumComp = 1;
	ViewValueList = View->SQ2; ViewNumList = &View->NbSQ2;
      }
      else if(!strcmp(yyvsp[0].c, "VQ2")){
	ViewElementIdx = 10; ViewNumNodes = 9; ViewNumComp = 3;
	ViewValueList = View->VQ2; ViewNumList = &View->NbVQ2;
      }
      else if(!strcmp(yyvsp[0].c, "TQ2")){
	ViewElementIdx = 11; ViewNumNodes = 9; ViewNumComp = 9;
	ViewValueList = View->TQ2; ViewNumList = &View->NbTQ2;
      }
      else if(!strcmp(yyvsp[0].c, "SS2")){
	ViewElementIdx = 12; ViewNumNodes = 10; ViewNumComp = 1;
	ViewValueList = View->SS2; ViewNumList = &View->NbSS2;
      }
      else if(!strcmp(yyvsp[0].c, "VS2")){
	ViewElementIdx = 13; ViewNumNodes = 10; ViewNumComp = 3;
	ViewValueList = View->VS2; ViewNumList = &View->NbVS2;
      }
      else if(!strcmp(yyvsp[0].c, "TS2")){
	ViewElementIdx = 14; ViewNumNodes = 10; ViewNumComp = 9;
	ViewValueList = View->TS2; ViewNumList = &View->NbTS2;
      }
      else if(!strcmp(yyvsp[0].c, "SH2")){
	ViewElementIdx = 15; ViewNumNodes = 27; ViewNumComp = 1;
	ViewValueList = View->SH2; ViewNumList = &View->NbSH2;
      }
      else if(!strcmp(yyvsp[0].c, "VH2")){
	ViewElementIdx = 16; ViewNumNodes = 27; ViewNumComp = 3;
	ViewValueList = View->VH2; ViewNumList = &View->NbVH2;
      }
      else if(!strcmp(yyvsp[0].c, "TH2")){
	ViewElementIdx = 17; ViewNumNodes = 27; ViewNumComp = 9;
	ViewValueList = View->TH2; ViewNumList = &View->NbTH2;
      }
      else if(!strcmp(yyvsp[0].c, "SI2")){
	ViewElementIdx = 18; ViewNumNodes = 18; ViewNumComp = 1;
	ViewValueList = View->SI2; ViewNumList = &View->NbSI2;
      }
      else if(!strcmp(yyvsp[0].c, "VI2")){
	ViewElementIdx = 19; ViewNumNodes = 18; ViewNumComp = 3;
	ViewValueList = View->VI2; ViewNumList = &View->NbVI2;
      }
      else if(!strcmp(yyvsp[0].c, "TI2")){
	ViewElementIdx = 20; ViewNumNodes = 18; ViewNumComp = 9;
	ViewValueList = View->TI2; ViewNumList = &View->NbTI2;
      }
      else if(!strcmp(yyvsp[0].c, "SY2")){
	ViewElementIdx = 21; ViewNumNodes = 14; ViewNumComp = 1;
	ViewValueList = View->SY2; ViewNumList = &View->NbSY2;
      }
      else if(!strcmp(yyvsp[0].c, "VY2")){
	ViewElementIdx = 22; ViewNumNodes = 14; ViewNumComp = 3;
	ViewValueList = View->VY2; ViewNumList = &View->NbVY2;
      }
      else if(!strcmp(yyvsp[0].c, "TY2")){
	ViewElementIdx = 23; ViewNumNodes = 14; ViewNumComp = 9;
	ViewValueList = View->TY2; ViewNumList = &View->NbTY2;
      }
      else{
	yymsg(GERROR, "Unknown element type '%s'", yyvsp[0].c);	
	ViewElementIdx = -1; ViewNumNodes = 0; ViewNumComp = 0;
	ViewValueList = NULL; ViewNumList = NULL;
      }
      Free(yyvsp[0].c);
      ViewCoordIdx = 0;
    ;
    break;}
case 34:
#line 433 "Gmsh.y"
{
      if(ViewValueList){
	if(ViewCoordIdx != 3 * ViewNumNodes){
	  yymsg(GERROR, "Wrong number of node coordinates (%d != %d)", 
		ViewCoordIdx, 3 * ViewNumNodes);
	  double d = 0;
	  for(int i = 0; i < 3 * ViewNumNodes; i++)
	    List_Add(ViewValueList, &d);
	}
	else{
	  for(int i = 0; i < 3; i++)
	    for(int j = 0; j < ViewNumNodes; j++)
	      List_Add(ViewValueList, &ViewCoord[3*j+i]);
	}
	ViewNumListTmp = List_Nbr(ViewValueList);
      }
    ;
    break;}
case 35:
#line 451 "Gmsh.y"
{
      if(ViewValueList){  
	if((List_Nbr(ViewValueList) - ViewNumListTmp) % (ViewNumComp * ViewNumNodes)) 
	  ViewErrorFlags[ViewElementIdx]++;
	(*ViewNumList)++;
      }
    ;
    break;}
case 36:
#line 462 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T2C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 37:
#line 467 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T2C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 38:
#line 475 "Gmsh.y"
{ 
      List_Add(View->T2D, &yyvsp[-5].d); List_Add(View->T2D, &yyvsp[-3].d);
      List_Add(View->T2D, &yyvsp[-1].d); 
      double d = List_Nbr(View->T2C);
      List_Add(View->T2D, &d); 
    ;
    break;}
case 39:
#line 482 "Gmsh.y"
{
      View->NbT2++;
    ;
    break;}
case 40:
#line 489 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T3C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 41:
#line 494 "Gmsh.y"
{ 
      for(int i = 0; i < (int)strlen(yyvsp[0].c)+1; i++) List_Add(View->T3C, &yyvsp[0].c[i]); 
      Free(yyvsp[0].c);
    ;
    break;}
case 42:
#line 502 "Gmsh.y"
{ 
      List_Add(View->T3D, &yyvsp[-7].d); List_Add(View->T3D, &yyvsp[-5].d);
      List_Add(View->T3D, &yyvsp[-3].d); List_Add(View->T3D, &yyvsp[-1].d); 
      double d = List_Nbr(View->T3C);
      List_Add(View->T3D, &d); 
    ;
    break;}
case 43:
#line 509 "Gmsh.y"
{
      View->NbT3++;
    ;
    break;}
case 44:
#line 517 "Gmsh.y"
{
      View->adaptive = new Adaptive_Post_View(View, yyvsp[-5].l, yyvsp[-2].l);
    ;
    break;}
case 45:
#line 524 "Gmsh.y"
{
      ViewValueList = View->Time;
    ;
    break;}
case 46:
#line 528 "Gmsh.y"
{
    ;
    break;}
case 47:
#line 535 "Gmsh.y"
{ yyval.i = 0; ;
    break;}
case 48:
#line 536 "Gmsh.y"
{ yyval.i = 1; ;
    break;}
case 49:
#line 537 "Gmsh.y"
{ yyval.i = 2; ;
    break;}
case 50:
#line 538 "Gmsh.y"
{ yyval.i = 3; ;
    break;}
case 51:
#line 539 "Gmsh.y"
{ yyval.i = 4; ;
    break;}
case 52:
#line 543 "Gmsh.y"
{ yyval.i = 1; ;
    break;}
case 53:
#line 544 "Gmsh.y"
{ yyval.i = -1; ;
    break;}
case 54:
#line 552 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-3].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	if(!yyvsp[-2].i){
	  TheSymbol.val = List_Create(1, 1, sizeof(double));
	  List_Put(TheSymbol.val, 0, &yyvsp[-1].d);
	  Tree_Add(Symbol_T, &TheSymbol);
	}
	else{
	  yymsg(GERROR, "Unknown variable '%s'", yyvsp[-3].c);
	  Free(yyvsp[-3].c);
	}
      }
      else{
	double *pd = (double*)List_Pointer_Fast(pSymbol->val, 0); 
	switch(yyvsp[-2].i){
	case 0 : *pd = yyvsp[-1].d; break;
	case 1 : *pd += yyvsp[-1].d; break;
	case 2 : *pd -= yyvsp[-1].d; break;
	case 3 : *pd *= yyvsp[-1].d; break;
	case 4 : 
	  if(yyvsp[-1].d) *pd /= yyvsp[-1].d; 
	  else yymsg(GERROR, "Division by zero in '%s /= %g'", yyvsp[-3].c, yyvsp[-1].d);
	  break;
	}
	Free(yyvsp[-3].c);
      }
    ;
    break;}
case 55:
#line 583 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-6].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	if(!yyvsp[-2].i){
	  TheSymbol.val = List_Create(5, 5, sizeof(double));
	  List_Put(TheSymbol.val, (int)yyvsp[-4].d, &yyvsp[-1].d);
	  Tree_Add(Symbol_T, &TheSymbol);
	}
	else{
	  yymsg(GERROR, "Unknown variable '%s'", yyvsp[-6].c);
	  Free(yyvsp[-6].c);
	}
      }
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-4].d))){
	  switch(yyvsp[-2].i){
	  case 0 : *pd = yyvsp[-1].d; break;
	  case 1 : *pd += yyvsp[-1].d; break;
	  case 2 : *pd -= yyvsp[-1].d; break;
	  case 3 : *pd *= yyvsp[-1].d; break;
	  case 4 : 
	    if(yyvsp[-1].d) *pd /= yyvsp[-1].d; 
	    else yymsg(GERROR, "Division by zero in '%s[%d] /= %g'", yyvsp[-6].c, (int)yyvsp[-4].d, yyvsp[-1].d);
	    break;
	  }
	}
	else{
	  if(!yyvsp[-2].i)
	    List_Put(pSymbol->val, (int)yyvsp[-4].d, &yyvsp[-1].d);
	  else
	    yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-6].c, (int)yyvsp[-4].d);
	}
	Free(yyvsp[-6].c);
      }
    ;
    break;}
case 56:
#line 622 "Gmsh.y"
{
      if(List_Nbr(yyvsp[-5].l) != List_Nbr(yyvsp[-1].l)){
	yymsg(GERROR, "Incompatible array dimensions in affectation");
	Free(yyvsp[-8].c);
      }
      else{
	Symbol TheSymbol;
	TheSymbol.Name = yyvsp[-8].c;
	Symbol *pSymbol;
	if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	  if(!yyvsp[-2].i){
	    TheSymbol.val = List_Create(5, 5, sizeof(double));
	    for(int i = 0; i < List_Nbr(yyvsp[-5].l); i++){
	      List_Put(TheSymbol.val, (int)(*(double*)List_Pointer(yyvsp[-5].l, i)),
		       (double*)List_Pointer(yyvsp[-1].l, i));
	    }
	    Tree_Add(Symbol_T, &TheSymbol);
	  }
	  else{
	    yymsg(GERROR, "Unknown variable '%s'", yyvsp[-8].c);
	    Free(yyvsp[-8].c);
	  }
	}
	else{
	  for(int i = 0; i < List_Nbr(yyvsp[-5].l); i++){
	    int j = (int)(*(double*)List_Pointer(yyvsp[-5].l, i));
	    double d = *(double*)List_Pointer(yyvsp[-1].l, i);
	    double *pd;
	    if((pd = (double*)List_Pointer_Test(pSymbol->val, j))){
	      switch(yyvsp[-2].i){
	      case 0 : *pd = d; break;
	      case 1 : *pd += d; break;
	      case 2 : *pd -= d; break;
	      case 3 : *pd *= d; break;
	      case 4 : 
		if(yyvsp[-1].l) *pd /= d; 
		else yymsg(GERROR, "Division by zero in '%s[%d] /= %g'", yyvsp[-8].c, j, d);
		break;
	      }
	    }
	    else{
	      if(!yyvsp[-2].i)
		List_Put(pSymbol->val, j, &d);
	      else
		yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-8].c, j);	  
	    }
	  }
	  Free(yyvsp[-8].c);
	}
      }
      List_Delete(yyvsp[-5].l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 57:
#line 676 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(5, 5, sizeof(double));
	List_Copy(yyvsp[-1].l, TheSymbol.val);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	List_Reset(pSymbol->val);
	List_Copy(yyvsp[-1].l, pSymbol->val);
	Free(yyvsp[-5].c);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 58:
#line 693 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol)))
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c); 
      else
	*(double*)List_Pointer_Fast(pSymbol->val, 0) += yyvsp[-1].i;
      Free(yyvsp[-2].c);
    ;
    break;}
case 59:
#line 704 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol)))
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-5].c); 
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-3].d)))
	  *pd += yyvsp[-1].i;
	else
	  yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-5].c, (int)yyvsp[-3].d);
      }
      Free(yyvsp[-5].c);
    ;
    break;}
case 60:
#line 723 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-5].c)))
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-5].c);
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-3].c, pStrCat)))
	  yymsg(GERROR, "Unknown string option '%s.%s'", yyvsp[-5].c, yyvsp[-3].c);
	else
	  pStrOpt(0, GMSH_SET|GMSH_GUI, yyvsp[-1].c);
      }
      Free(yyvsp[-5].c); Free(yyvsp[-3].c); //FIXME: somtimes leak $5
    ;
    break;}
case 61:
#line 737 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-8].c)))
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-8].c);
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-3].c, pStrCat)))
	  yymsg(GERROR, "Unknown string option '%s[%d].%s'", yyvsp[-8].c, (int)yyvsp[-6].d, yyvsp[-3].c);
	else
	  pStrOpt((int)yyvsp[-6].d, GMSH_SET|GMSH_GUI, yyvsp[-1].c);
      }
      Free(yyvsp[-8].c); Free(yyvsp[-3].c); //FIXME: somtimes leak $8
    ;
    break;}
case 62:
#line 754 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-5].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-5].c);
      else{
	if(!(pNumOpt = (double (*) (int, int, double))Get_NumberOption(yyvsp[-3].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-5].c, yyvsp[-3].c);
	else{
	  double d = 0;
	  switch(yyvsp[-2].i){
	  case 0 : d = yyvsp[-1].d; break;
	  case 1 : d = pNumOpt(0, GMSH_GET, 0) + yyvsp[-1].d; break;
	  case 2 : d = pNumOpt(0, GMSH_GET, 0) - yyvsp[-1].d; break;
	  case 3 : d = pNumOpt(0, GMSH_GET, 0) * yyvsp[-1].d; break;
	  case 4 : 
	    if(yyvsp[-1].d) d = pNumOpt(0, GMSH_GET, 0) / yyvsp[-1].d; 
	    else yymsg(GERROR, "Division by zero in '%s.%s /= %g'", yyvsp[-5].c, yyvsp[-3].c, yyvsp[-1].d);
	    break;
	  }
	  pNumOpt(0, GMSH_SET|GMSH_GUI, d);
	}
      }
      Free(yyvsp[-5].c); Free(yyvsp[-3].c);
    ;
    break;}
case 63:
#line 780 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-8].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-8].c);
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-3].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-8].c, (int)yyvsp[-6].d, yyvsp[-3].c);
	else{
	  double d = 0;
	  switch(yyvsp[-2].i){
	  case 0 : d = yyvsp[-1].d; break;
	  case 1 : d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) + yyvsp[-1].d; break;
	  case 2 : d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) - yyvsp[-1].d; break;
	  case 3 : d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) * yyvsp[-1].d; break;
	  case 4 : 
	    if(yyvsp[-1].d) d = pNumOpt((int)yyvsp[-6].d, GMSH_GET, 0) / yyvsp[-1].d;
	    else yymsg(GERROR, "Division by zero in '%s[%d].%s /= %g'", 
		       yyvsp[-8].c, (int)yyvsp[-6].d, yyvsp[-3].c, yyvsp[-1].d);
	    break;
	  }
	  pNumOpt((int)yyvsp[-6].d, GMSH_SET|GMSH_GUI, d);
	}
      }
      Free(yyvsp[-8].c); Free(yyvsp[-3].c);
    ;
    break;}
case 64:
#line 807 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-4].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-4].c);
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-2].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-4].c, yyvsp[-2].c);
	else
	  pNumOpt(0, GMSH_SET|GMSH_GUI, pNumOpt(0, GMSH_GET, 0)+yyvsp[-1].i);
      }
      Free(yyvsp[-4].c); Free(yyvsp[-2].c);
    ;
    break;}
case 65:
#line 821 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-7].c)))
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-7].c);
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-2].c, pNumCat)))
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-7].c, (int)yyvsp[-5].d, yyvsp[-2].c);
	else
	  pNumOpt((int)yyvsp[-5].d, GMSH_SET|GMSH_GUI, pNumOpt((int)yyvsp[-5].d, GMSH_GET, 0)+yyvsp[-1].i);
      }
      Free(yyvsp[-7].c); Free(yyvsp[-2].c);
    ;
    break;}
case 66:
#line 838 "Gmsh.y"
{
      unsigned int (*pColOpt)(int num, int action, unsigned int value);
      StringXColor *pColCat;
      if(!(pColCat = Get_ColorOptionCategory(yyvsp[-7].c)))
	yymsg(GERROR, "Unknown color option class '%s'", yyvsp[-7].c);
      else{
	if(!(pColOpt =  (unsigned int (*) (int, int, unsigned int))Get_ColorOption(yyvsp[-3].c, pColCat)))
	  yymsg(GERROR, "Unknown color option '%s.Color.%s'", yyvsp[-7].c, yyvsp[-3].c);
	else
	  pColOpt(0, GMSH_SET|GMSH_GUI, yyvsp[-1].u);
      }
      Free(yyvsp[-7].c); Free(yyvsp[-3].c);
    ;
    break;}
case 67:
#line 852 "Gmsh.y"
{
      unsigned int (*pColOpt)(int num, int action, unsigned int value);
      StringXColor *pColCat;
      if(!(pColCat = Get_ColorOptionCategory(yyvsp[-10].c)))
	yymsg(GERROR, "Unknown color option class '%s'", yyvsp[-10].c);
      else{
	if(!(pColOpt =  (unsigned int (*) (int, int, unsigned int))Get_ColorOption(yyvsp[-3].c, pColCat)))
	  yymsg(GERROR, "Unknown color option '%s[%d].Color.%s'", yyvsp[-10].c, (int)yyvsp[-8].d, yyvsp[-3].c);
	else
	  pColOpt((int)yyvsp[-8].d, GMSH_SET|GMSH_GUI, yyvsp[-1].u);
      }
      Free(yyvsp[-10].c); Free(yyvsp[-3].c);
    ;
    break;}
case 68:
#line 869 "Gmsh.y"
{
      GmshColorTable *ct = Get_ColorTable(0);
      if(!ct)
	yymsg(GERROR, "View[%d] does not exist", 0);
      else{
	ct->size = List_Nbr(yyvsp[-1].l);
	if(ct->size > COLORTABLE_NBMAX_COLOR)
	  yymsg(GERROR, "Too many (%d>%d) colors in View[%d].ColorTable", 
		ct->size, COLORTABLE_NBMAX_COLOR, 0);
	else
	  for(int i = 0; i < ct->size; i++) List_Read(yyvsp[-1].l, i, &ct->table[i]);
	if(ct->size == 1){
	  ct->size = 2;
	  ct->table[1] = ct->table[0];
	}
      }
      Free(yyvsp[-5].c);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 69:
#line 889 "Gmsh.y"
{
      GmshColorTable *ct = Get_ColorTable((int)yyvsp[-6].d);
      if(!ct)
	yymsg(GERROR, "View[%d] does not exist", (int)yyvsp[-6].d);
      else{
	ct->size = List_Nbr(yyvsp[-1].l);
	if(ct->size > COLORTABLE_NBMAX_COLOR)
	  yymsg(GERROR, "Too many (%d>%d) colors in View[%d].ColorTable", 
		   ct->size, COLORTABLE_NBMAX_COLOR, (int)yyvsp[-6].d);
	else
	  for(int i = 0; i < ct->size; i++) List_Read(yyvsp[-1].l, i, &ct->table[i]);
	if(ct->size == 1){
	  ct->size = 2;
	  ct->table[1] = ct->table[0];
	}
      }
      Free(yyvsp[-8].c);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 70:
#line 912 "Gmsh.y"
{
      try {
	GMSH_PluginManager::instance()->setPluginOption(yyvsp[-6].c, yyvsp[-3].c, yyvsp[-1].d); 
      }
      catch (...) {
	yymsg(GERROR, "Unknown option '%s' or plugin '%s'", yyvsp[-3].c, yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-3].c);
    ;
    break;}
case 71:
#line 922 "Gmsh.y"
{
      try {
	GMSH_PluginManager::instance()->setPluginOption(yyvsp[-6].c, yyvsp[-3].c, yyvsp[-1].c); 
      }
      catch (...) {
	yymsg(GERROR, "Unknown option '%s' or plugin '%s'", yyvsp[-3].c, yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-3].c); // FIXME: sometimes leak $8
    ;
    break;}
case 72:
#line 941 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindPoint(num, THEM)){
	yymsg(GERROR, "Point %d already exists", num);
      }
      else{
	Vertex *v = Create_Vertex(num, CTX.geom.scaling_factor * yyvsp[-1].v[0],
				  CTX.geom.scaling_factor * yyvsp[-1].v[1],
				  CTX.geom.scaling_factor * yyvsp[-1].v[2],
				  CTX.geom.scaling_factor * yyvsp[-1].v[3], 1.0);
	Tree_Add(THEM->Points, &v);
      }
      yyval.s.Type = MSH_POINT;
      yyval.s.Num = num;
    ;
    break;}
case 73:
#line 957 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_POINT, THEM)){
	yymsg(GERROR, "Physical point %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_POINT, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_POINT;
      yyval.s.Num = num;
    ;
    break;}
case 74:
#line 973 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-9].l); i++){
	double p;
      	List_Read(yyvsp[-9].l, i, &p);
        Vertex *v = FindPoint((int)p, THEM);
        if(!v)
	  yymsg(WARNING, "Unknown point %d", (int)p);
	else{
	  Attractor *a = Create_Attractor(List_Nbr(THEM->Metric->Attractors)+1,
					  yyvsp[-6].d, yyvsp[-4].d, yyvsp[-2].d, v, NULL, NULL);
	  List_Add(THEM->Metric->Attractors, &a);
        }
      }
      List_Delete(yyvsp[-9].l);
      // dummy values
      yyval.s.Type = 0;
      yyval.s.Num = 0;
    ;
    break;}
case 75:
#line 992 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	Vertex *v = FindPoint((int)d, THEM);
	if(!v)
	  yymsg(WARNING, "Unknown point %d", (int)d);
	else
	  v->lc = yyvsp[-1].d;
      }
      List_Delete(yyvsp[-3].l);
      // dummy values
      yyval.s.Type = 0;
      yyval.s.Num = 0;
    ;
    break;}
case 76:
#line 1011 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num, THEM)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_LINE, 1, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(THEM, c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_LINE;
      yyval.s.Num = num;
    ;
    break;}
case 77:
#line 1029 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num, THEM)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_SPLN, 3, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(THEM, c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_SPLN;
      yyval.s.Num = num;
    ;
    break;}
case 78:
#line 1047 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num, THEM)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_CIRC, 2, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(THEM, c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_CIRC;
      yyval.s.Num = num;
    ;
    break;}
case 79:
#line 1065 "Gmsh.y"
{
      int num = (int)yyvsp[-6].d;
      if(FindCurve(num, THEM)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-3].l);
	Curve *c = Create_Curve(num, MSH_SEGM_CIRC, 2, temp, NULL,
				-1, -1, 0., 1.);
	c->Circle.n[0] = yyvsp[-1].v[0];
	c->Circle.n[1] = yyvsp[-1].v[1];
	c->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(c);
	Tree_Add(THEM->Curves, &c);
	Curve *rc = CreateReversedCurve(THEM, c);
	rc->Circle.n[0] = yyvsp[-1].v[0];
	rc->Circle.n[1] = yyvsp[-1].v[1];
	rc->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(rc);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-3].l);
      yyval.s.Type = MSH_SEGM_CIRC;
      yyval.s.Num = num;
    ;
    break;}
case 80:
#line 1091 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindCurve(num, THEM)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	Curve *c = Create_Curve(num, MSH_SEGM_ELLI, 2, temp, NULL,
				-1, -1, 0., 1.);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(THEM, c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_ELLI;
      yyval.s.Num = num;
    ;
    break;}
case 81:
#line 1109 "Gmsh.y"
{
      int num = (int)yyvsp[-6].d;
      if(FindCurve(num, THEM)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-3].l);
	Curve *c = Create_Curve(num, MSH_SEGM_ELLI, 2, temp, NULL,
				-1, -1, 0., 1.);
	c->Circle.n[0] = yyvsp[-1].v[0];
	c->Circle.n[1] = yyvsp[-1].v[1];
	c->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(c);
	Tree_Add(THEM->Curves, &c);
	Curve *rc = CreateReversedCurve(THEM, c);
	rc->Circle.n[0] = yyvsp[-1].v[0];
	rc->Circle.n[1] = yyvsp[-1].v[1];
	rc->Circle.n[2] = yyvsp[-1].v[2];
	End_Curve(c);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-3].l);
      yyval.s.Type = MSH_SEGM_ELLI;
      yyval.s.Num = num;
    ;
    break;}
case 82:
#line 1136 "Gmsh.y"
{
      int num = (int)yyvsp[-14].d;
      if(FindCurve(num, THEM)){
	yymsg(GERROR, "Curve %d already exists", num);
      }
      else{
	Curve *c = Create_Curve(num, MSH_SEGM_PARAMETRIC, 2, NULL, NULL,
				-1, -1, yyvsp[-10].d, yyvsp[-8].d);
	strcpy(c->functu, yyvsp[-6].c);
	strcpy(c->functv, yyvsp[-4].c);
	strcpy(c->functw, yyvsp[-2].c);
	Tree_Add(THEM->Curves, &c);
	CreateReversedCurve(THEM, c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-4].c); Free(yyvsp[-2].c);
      yyval.s.Type = MSH_SEGM_PARAMETRIC;
      yyval.s.Num = num;
    ;
    break;}
case 83:
#line 1155 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(List_Nbr(yyvsp[-1].l) < 4){
	yymsg(GERROR, "Too few control points for BSpline %d (%d < 4)", num,
	      List_Nbr(yyvsp[-1].l));
      }
      else{
	if(FindCurve(num, THEM)){
	  yymsg(GERROR, "Curve %d already exists", num);
	}
	else{
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	  Curve *c = Create_Curve(num, MSH_SEGM_BSPLN, 2, temp, NULL,
				  -1, -1, 0., 1.);
	  Tree_Add(THEM->Curves, &c);
	  CreateReversedCurve(THEM, c);
	  List_Delete(temp);
	}
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_BSPLN;
      yyval.s.Num = num;
    ;
    break;}
case 84:
#line 1179 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(List_Nbr(yyvsp[-1].l) < 4){
	yymsg(GERROR, "Too few control points for Bezier curve %d (%d < 4)", num,
	      List_Nbr(yyvsp[-1].l));
      }
      else{
	if(FindCurve(num, THEM)){
	  yymsg(GERROR, "Curve %d already exists", num);
	}
	else{
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	  Curve *c = Create_Curve(num, MSH_SEGM_BEZIER, 2, temp, NULL,
				  -1, -1, 0., 1.);
	  Tree_Add(THEM->Curves, &c);
	  CreateReversedCurve(THEM, c);
	  List_Delete(temp);
	}
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_BEZIER;
      yyval.s.Num = num;
    ;
    break;}
case 85:
#line 1203 "Gmsh.y"
{
      int num = (int)yyvsp[-8].d;
      if(List_Nbr(yyvsp[-5].l) + (int)yyvsp[-1].d + 1 != List_Nbr(yyvsp[-3].l)){
	yymsg(GERROR, "Wrong definition of Nurbs Curve %d: "
	      "got %d knots, need N + D + 1 = %d + %d + 1 = %d",
	      (int)yyvsp[-8].d, List_Nbr(yyvsp[-3].l), List_Nbr(yyvsp[-5].l), (int)yyvsp[-1].d, List_Nbr(yyvsp[-5].l) + (int)yyvsp[-1].d + 1);
      }
      else{
	if(FindCurve(num, THEM)){
	  yymsg(GERROR, "Curve %d already exists", num);
	}
	else{
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-5].l);
	  Curve *c = Create_Curve(num, MSH_SEGM_NURBS, (int)yyvsp[-1].d, temp, yyvsp[-3].l,
				  -1, -1, 0., 1.);
	  Tree_Add(THEM->Curves, &c);
	  CreateReversedCurve(THEM, c);
	  List_Delete(temp);
	}
      }
      List_Delete(yyvsp[-5].l);
      List_Delete(yyvsp[-3].l);
      yyval.s.Type = MSH_SEGM_NURBS;
      yyval.s.Num = num;
    ;
    break;}
case 86:
#line 1229 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindEdgeLoop(num, THEM)){
	yymsg(GERROR, "Line loop %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	sortEdgesInLoop(num, temp);
	EdgeLoop *l = Create_EdgeLoop(num, temp);
	Tree_Add(THEM->EdgeLoops, &l);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SEGM_LOOP;
      yyval.s.Num = num;
    ;
    break;}
case 87:
#line 1246 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-9].l); i++){
	double p;
      	List_Read(yyvsp[-9].l, i, &p);
	Curve *c = FindCurve((int)p, THEM);
        if(!c)
	  yymsg(WARNING, "Unknown curve %d", (int)p);
	else{
	  Attractor *a = Create_Attractor(List_Nbr(THEM->Metric->Attractors)+1,
					  yyvsp[-6].d, yyvsp[-4].d, yyvsp[-2].d, NULL, c, NULL);
	  List_Add(THEM->Metric->Attractors, &a);
        }
      }
      // dummy values
      yyval.s.Type = 0;
      yyval.s.Num = 0;
    ;
    break;}
case 88:
#line 1264 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_LINE, THEM)){
	yymsg(GERROR, "Physical line %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_LINE, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_LINE;
      yyval.s.Num = num;
    ;
    break;}
case 89:
#line 1283 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindSurface(num, THEM)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	Surface *s = Create_Surface(num, MSH_SURF_PLAN);
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	setSurfaceGeneratrices(s, temp);
	List_Delete(temp);
	s->Support = s;
	End_Surface(s);
	Tree_Add(THEM->Surfaces, &s);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SURF_PLAN;
      yyval.s.Num = num;
    ;
    break;}
case 90:
#line 1302 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d, type = 0;
      if(FindSurface(num, THEM)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	double d;
	List_Read(yyvsp[-1].l, 0, &d);
	EdgeLoop *el = FindEdgeLoop((int)fabs(d), THEM);
	if(!el){
	  yymsg(GERROR, "Unknown line loop %d", (int)d);
	}
	else{
	  int j = List_Nbr(el->Curves);
	  if(j == 4){
	    type = MSH_SURF_REGL;
	  }
	  else if(j == 3){
	    type = MSH_SURF_TRIC;
	  }
	  else{
	    yymsg(GERROR, "Wrong definition of Ruled Surface %d: "
		  "%d borders instead of 3 or 4", num, j);
	    type = MSH_SURF_PLAN;
	  }
	  Surface *s = Create_Surface(num, type);
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	  setSurfaceGeneratrices(s, temp);
	  List_Delete(temp);
	  s->Support = s;
	  End_Surface(s);
	  Tree_Add(THEM->Surfaces, &s);
	}
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = type;
      yyval.s.Num = num;
    ;
    break;}
case 91:
#line 1341 "Gmsh.y"
{
      int num = (int)yyvsp[-8].d;
      Surface *support = FindSurface((int)yyvsp[-4].d, THEM);
      if(!support){
	yymsg(GERROR, "Unknown support surface %d", (int)yyvsp[-4].d);
      }
      else{
	if(FindSurface(num, THEM)){
	  yymsg(GERROR, "Surface %d already exists", num);
	}
	else{
	  Surface *s = Create_Surface(num, MSH_SURF_TRIMMED);
	  List_T *temp = ListOfDouble2ListOfInt(yyvsp[-2].l);
	  setSurfaceGeneratrices(s, temp);
	  List_Delete(temp);
	  s->Support = support;
	  End_Surface(s);
	  Tree_Add(THEM->Surfaces, &s);
	}
      }
      List_Delete(yyvsp[-2].l);
      yyval.s.Type = MSH_SURF_TRIMMED;
      yyval.s.Num = num;
    ;
    break;}
case 92:
#line 1368 "Gmsh.y"
{
      int num = (int)yyvsp[-16].d;
      if(FindSurface(num, THEM)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	CreateNurbsSurface(num, (int)yyvsp[-4].d, (int)yyvsp[-2].d, yyvsp[-13].l, yyvsp[-10].l, yyvsp[-8].l);
      }
      for(int i = 0; i < List_Nbr(yyvsp[-13].l); i++)
	List_Delete((List_T*)List_Pointer(yyvsp[-13].l, i));
      List_Delete(yyvsp[-13].l);
      List_Delete(yyvsp[-10].l);
      List_Delete(yyvsp[-8].l);
      yyval.s.Type = MSH_SURF_NURBS;
      yyval.s.Num = num;
    ;
    break;}
case 93:
#line 1387 "Gmsh.y"
{
      int num = (int)yyvsp[-16].d;
      if(FindSurface(num, THEM)){
	yymsg(GERROR, "Surface %d already exists", num);
      }
      else{
	CreateNurbsSurfaceSupport(num, (int)yyvsp[-4].d, (int)yyvsp[-2].d, yyvsp[-13].l, yyvsp[-10].l, yyvsp[-8].l);
      }
      for(int i = 0; i < List_Nbr(yyvsp[-13].l); i++)
	List_Delete((List_T*)List_Pointer(yyvsp[-13].l, i));
      List_Delete(yyvsp[-13].l);
      List_Delete(yyvsp[-10].l);
      List_Delete(yyvsp[-8].l);
      yyval.s.Type = MSH_SURF_NURBS;
      yyval.s.Num = num;
    ;
    break;}
case 94:
#line 1404 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindSurfaceLoop(num, THEM)){
	yymsg(GERROR, "Surface loop %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	SurfaceLoop *l = Create_SurfaceLoop(num, temp);
	Tree_Add(THEM->SurfaceLoops, &l);
	List_Delete(temp);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_SURF_LOOP;
      yyval.s.Num = num;
    ;
    break;}
case 95:
#line 1420 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_SURFACE, THEM)){
	yymsg(GERROR, "Physical surface %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_SURFACE, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_SURFACE;
      yyval.s.Num = num;
    ;
    break;}
case 96:
#line 1440 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindVolume(num, THEM)){
	yymsg(GERROR, "Volume %d already exists", num);
      }
      else{
	Volume *v = Create_Volume(num, MSH_VOLUME);
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	setVolumeSurfaces(v, temp);
	List_Delete(temp);
	Tree_Add(THEM->Volumes, &v);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_VOLUME;
      yyval.s.Num = num;
    ;
    break;}
case 97:
#line 1457 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindVolume(num, THEM)){
	yymsg(GERROR, "Volume %d already exists", num);
      }
      else{
	Volume *v = Create_Volume(num, MSH_VOLUME);
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	setVolumeSurfaces(v, temp);
	List_Delete(temp);
	Tree_Add(THEM->Volumes, &v);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_VOLUME;
      yyval.s.Num = num;
    ;
    break;}
case 98:
#line 1474 "Gmsh.y"
{
      int num = (int)yyvsp[-4].d;
      if(FindPhysicalGroup(num, MSH_PHYSICAL_VOLUME, THEM)){
	yymsg(GERROR, "Physical volume %d already exists", num);
      }
      else{
	List_T *temp = ListOfDouble2ListOfInt(yyvsp[-1].l);
	PhysicalGroup *p = Create_PhysicalGroup(num, MSH_PHYSICAL_VOLUME, temp);
	List_Delete(temp);
	List_Add(THEM->PhysicalGroups, &p);
      }
      List_Delete(yyvsp[-1].l);
      yyval.s.Type = MSH_PHYSICAL_VOLUME;
      yyval.s.Num = num;
    ;
    break;}
case 99:
#line 1495 "Gmsh.y"
{
      TranslateShapes(yyvsp[-3].v[0], yyvsp[-3].v[1], yyvsp[-3].v[2], yyvsp[-1].l, 1);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 100:
#line 1500 "Gmsh.y"
{
      RotateShapes(yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d, yyvsp[-1].l, 1);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 101:
#line 1505 "Gmsh.y"
{
      SymmetryShapes(yyvsp[-3].v[0], yyvsp[-3].v[1], yyvsp[-3].v[2], yyvsp[-3].v[3], yyvsp[-1].l, 1);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 102:
#line 1510 "Gmsh.y"
{
      DilatShapes(yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d, yyvsp[-1].l, 1);
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 103:
#line 1517 "Gmsh.y"
{ yyval.l = yyvsp[0].l; ;
    break;}
case 104:
#line 1518 "Gmsh.y"
{ yyval.l = yyvsp[0].l; ;
    break;}
case 105:
#line 1519 "Gmsh.y"
{ yyval.l = yyvsp[0].l; ;
    break;}
case 106:
#line 1524 "Gmsh.y"
{
      yyval.l = List_Create(3, 3, sizeof(Shape));
    ;
    break;}
case 107:
#line 1528 "Gmsh.y"
{
      List_Add(yyval.l, &yyvsp[0].s);
    ;
    break;}
case 108:
#line 1532 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Vertex *v = FindPoint(TheShape.Num, THEM);
	if(!v)
	  yymsg(WARNING, "Unknown point %d", TheShape.Num);
	else{
	  TheShape.Type = MSH_POINT;
	  List_Add(yyval.l, &TheShape);
	}
      }
    ;
    break;}
case 109:
#line 1548 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Curve *c = FindCurve(TheShape.Num, THEM);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", TheShape.Num);
	else{
	  TheShape.Type = c->Typ;
	  List_Add(yyval.l, &TheShape);
	}
      }
    ;
    break;}
case 110:
#line 1564 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Surface *s = FindSurface(TheShape.Num, THEM);
	if(!s)
	  yymsg(WARNING, "Unknown surface %d", TheShape.Num);
	else{
	  TheShape.Type = s->Typ;
	  List_Add(yyval.l, &TheShape);
	}
      }
    ;
    break;}
case 111:
#line 1580 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	double d;
	List_Read(yyvsp[-2].l, i, &d);
	Shape TheShape;
	TheShape.Num = (int)d;
	Volume *v = FindVolume(TheShape.Num, THEM);
	if(!v)
	  yymsg(WARNING, "Unknown volume %d", TheShape.Num);
	else{
	  TheShape.Type = v->Typ;
	  List_Add(yyval.l, &TheShape);
	}
      }
    ;
    break;}
case 112:
#line 1601 "Gmsh.y"
{
      yyval.l = List_Create(3, 3, sizeof(Shape));
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	int j;
	CopyShape(TheShape.Type, TheShape.Num, &j);
	TheShape.Num = j;
	List_Add(yyval.l, &TheShape);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 113:
#line 1615 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")) AliasView((int)yyvsp[-2].d, 0);
      Free(yyvsp[-4].c);
      yyval.l = NULL;
    ;
    break;}
case 114:
#line 1621 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")) AliasView((int)yyvsp[-2].d, 0);
      Free(yyvsp[-4].c);
      yyval.l = NULL;
    ;
    break;}
case 115:
#line 1627 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")) AliasView((int)yyvsp[-2].d, 1);
      Free(yyvsp[-4].c);
      yyval.l = NULL;
    ;
    break;}
case 116:
#line 1639 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	DeleteShape(TheShape.Type, TheShape.Num);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 117:
#line 1648 "Gmsh.y"
{
      if(!strcmp(yyvsp[-4].c, "View")){
	RemoveViewByIndex((int)yyvsp[-2].d);
      }
      else{
	yymsg(GERROR, "Unknown command 'Delete %s'", yyvsp[-4].c);
      }
      Free(yyvsp[-4].c);
    ;
    break;}
case 118:
#line 1658 "Gmsh.y"
{
      if(!strcmp(yyvsp[-1].c, "Meshes") || !strcmp(yyvsp[-1].c, "All")){
	Init_Mesh(THEM);
      }
      else if(!strcmp(yyvsp[-1].c, "Physicals")){
	List_Action(THEM->PhysicalGroups, Free_PhysicalGroup);
	List_Reset(THEM->PhysicalGroups);
      }
      else{
	yymsg(GERROR, "Unknown command 'Delete %s'", yyvsp[-1].c);
      }
      Free(yyvsp[-1].c);
    ;
    break;}
case 119:
#line 1672 "Gmsh.y"
{
      if(!strcmp(yyvsp[-2].c, "Empty") && !strcmp(yyvsp[-1].c, "Views")){
	for(int i = List_Nbr(CTX.post.list) - 1; i >= 0; i--){
	  Post_View *v = *(Post_View **) List_Pointer(CTX.post.list, i);
	  if(v->empty())
	    RemoveViewByIndex(i);
	}
      }
      else{
	yymsg(GERROR, "Unknown command 'Delete %s %s'", yyvsp[-2].c, yyvsp[-1].c);
      }
      Free(yyvsp[-2].c); Free(yyvsp[-1].c);
    ;
    break;}
case 120:
#line 1691 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	ColorShape(TheShape.Type, TheShape.Num, yyvsp[-3].u);
      }
      List_Delete(yyvsp[-1].l);      
    ;
    break;}
case 121:
#line 1705 "Gmsh.y"
{
      int m = (CTX.visibility_mode == 2) ? VIS_MESH : 
	((CTX.visibility_mode == 1) ? VIS_GEOM : VIS_GEOM|VIS_MESH);
      for(int i = 2; i < 6; i++)
	SetVisibilityByNumber(yyvsp[-1].c, i, m);
      Free(yyvsp[-1].c);
    ;
    break;}
case 122:
#line 1713 "Gmsh.y"
{
      for(int i = 2; i < 6; i++)
	SetVisibilityByNumber(yyvsp[-1].c, i, 0);
      Free(yyvsp[-1].c);
    ;
    break;}
case 123:
#line 1719 "Gmsh.y"
{
      int m = (CTX.visibility_mode == 2) ? VIS_MESH :
	((CTX.visibility_mode == 1) ? VIS_GEOM : VIS_GEOM|VIS_MESH);
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	VisibilityShape(TheShape.Type, TheShape.Num, m);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 124:
#line 1730 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	Shape TheShape;
	List_Read(yyvsp[-1].l, i, &TheShape);
	VisibilityShape(TheShape.Type, TheShape.Num, 0);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 125:
#line 1744 "Gmsh.y"
{
      if(!strcmp(yyvsp[-2].c, "Include")){
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	// Warning: we *don't* close included files (to allow user
	// functions in these files). If you need to include many many
	// files and don't have functions in the files, use "Merge"
	// instead: some OSes limit the number of files a process can
	// open simultaneously. The right solution would be of course
	// to modify FunctionManager to reopen the files instead of
	// using the FILE pointer, but hey, I'm lazy...
	ParseFile(tmpstring, 0, 0, 1);
      }
      else if(!strcmp(yyvsp[-2].c, "Print")){
#if defined(HAVE_FLTK)
	if(!CTX.batch){
	  char tmpstring[1024];
	  FixRelativePath(yyvsp[-1].c, tmpstring);
	  CreateOutputFile(tmpstring, CTX.print.format);
	}
#endif
      }
      else if(!strcmp(yyvsp[-2].c, "Save")){
#if defined(HAVE_FLTK)
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	CreateOutputFile(tmpstring, CTX.mesh.format);
#endif
      }
      else if(!strcmp(yyvsp[-2].c, "Merge") || !strcmp(yyvsp[-2].c, "MergeWithBoundingBox")){
	// MergeWithBoundingBox is deprecated
	char tmpstring[1024];
	FixRelativePath(yyvsp[-1].c, tmpstring);
	MergeProblem(tmpstring, 1);
      }
      else if(!strcmp(yyvsp[-2].c, "System")){
	SystemCall(yyvsp[-1].c);
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-2].c);
      }
      Free(yyvsp[-2].c); Free(yyvsp[-1].c);
    ;
    break;}
case 126:
#line 1788 "Gmsh.y"
{
      if(!strcmp(yyvsp[-6].c, "Save") && !strcmp(yyvsp[-5].c, "View")){
	Post_View **vv = (Post_View **)List_Pointer_Test(CTX.post.list, (int)yyvsp[-3].d);
	if(vv){
	  char tmpstring[1024];
	  FixRelativePath(yyvsp[-1].c, tmpstring);
	  WriteView(*vv, tmpstring, CTX.post.file_format, 0);
	}
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-5].c); Free(yyvsp[-1].c);
    ;
    break;}
case 127:
#line 1803 "Gmsh.y"
{
      if(!strcmp(yyvsp[-6].c, "Background") && !strcmp(yyvsp[-5].c, "Mesh")  && !strcmp(yyvsp[-4].c, "View")){
	Post_View **vv = (Post_View **)List_Pointer_Test(CTX.post.list, (int)yyvsp[-2].d);
	if(vv) BGMWithView(*vv);
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-6].c);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-5].c); Free(yyvsp[-4].c);
    ;
    break;}
case 128:
#line 1814 "Gmsh.y"
{
      if(!strcmp(yyvsp[-2].c, "Sleep")){
	long sleep_time = GetTime();
	while(1){
	  if(GetTime() - sleep_time > (long)(yyvsp[-1].d*1.e6)) break;
	}
      }
      else if(!strcmp(yyvsp[-2].c, "Remesh")){
	ReMesh(THEM);
      }
      else if(!strcmp(yyvsp[-2].c, "Mesh")){
	yymsg(GERROR, "Mesh directives are not (yet) allowed in scripts");
      }
      else{
	yymsg(GERROR, "Unknown command '%s'", yyvsp[-2].c);
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 129:
#line 1833 "Gmsh.y"
{
       try {
	 GMSH_PluginManager::instance()->action(yyvsp[-4].c, yyvsp[-1].c, 0);
       }
       catch(...) {
	 yymsg(GERROR, "Unknown action '%s' or plugin '%s'", yyvsp[-1].c, yyvsp[-4].c);
       }
       Free(yyvsp[-4].c); Free(yyvsp[-1].c);
     ;
    break;}
case 130:
#line 1843 "Gmsh.y"
{
      if(!strcmp(yyvsp[-1].c, "ElementsFromAllViews"))
	CombineViews(0, 1, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "ElementsFromVisibleViews"))
	CombineViews(0, 0, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "ElementsByViewName"))
	CombineViews(0, 2, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeStepsFromAllViews"))
	CombineViews(1, 1, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeStepsFromVisibleViews"))
	CombineViews(1, 0, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeStepsByViewName"))
	CombineViews(1, 2, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "Views"))
	CombineViews(0, 1, CTX.post.combine_remove_orig);
      else if(!strcmp(yyvsp[-1].c, "TimeSteps"))
	CombineViews(1, 2, CTX.post.combine_remove_orig);
      else
	yymsg(GERROR, "Unknown 'Combine' command");
      Free(yyvsp[-1].c);
    ;
    break;}
case 131:
#line 1865 "Gmsh.y"
{
      exit(0);
    ;
    break;}
case 132:
#line 1869 "Gmsh.y"
{
      CTX.forced_bbox = 0;
      SetBoundingBox();
    ;
    break;}
case 133:
#line 1874 "Gmsh.y"
{
      CTX.forced_bbox = 1;
      SetBoundingBox(yyvsp[-12].d, yyvsp[-10].d, yyvsp[-8].d, yyvsp[-6].d, yyvsp[-4].d, yyvsp[-2].d);
    ;
    break;}
case 134:
#line 1879 "Gmsh.y"
{
#if defined(HAVE_FLTK)
      if(!CTX.batch) // we're in interactive mode
	Draw();
#endif
    ;
    break;}
case 135:
#line 1892 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-1].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = 1.0;
      LoopControlVariablesNameTab[ImbricatedLoop] = NULL;
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if(yyvsp[-3].d > yyvsp[-1].d) skip_until("For", "EndFor");
    ;
    break;}
case 136:
#line 1907 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-5].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = yyvsp[-1].d;
      LoopControlVariablesNameTab[ImbricatedLoop] = NULL;
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if((yyvsp[-1].d > 0. && yyvsp[-5].d > yyvsp[-3].d) || (yyvsp[-1].d < 0. && yyvsp[-5].d < yyvsp[-3].d))
	skip_until("For", "EndFor");
    ;
    break;}
case 137:
#line 1923 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-1].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = 1.0;
      LoopControlVariablesNameTab[ImbricatedLoop] = yyvsp[-6].c;
      Symbol TheSymbol;      
      TheSymbol.Name = yyvsp[-6].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(1, 1, sizeof(double));
	List_Put(TheSymbol.val, 0, &yyvsp[-3].d);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	List_Write(pSymbol->val, 0, &yyvsp[-3].d);
      }
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if(yyvsp[-3].d > yyvsp[-1].d) skip_until("For", "EndFor");
    ;
    break;}
case 138:
#line 1949 "Gmsh.y"
{
      LoopControlVariablesTab[ImbricatedLoop][0] = yyvsp[-5].d;
      LoopControlVariablesTab[ImbricatedLoop][1] = yyvsp[-3].d;
      LoopControlVariablesTab[ImbricatedLoop][2] = yyvsp[-1].d;
      LoopControlVariablesNameTab[ImbricatedLoop] = yyvsp[-8].c;
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-8].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))){
	TheSymbol.val = List_Create(1, 1, sizeof(double));
	List_Put(TheSymbol.val, 0, &yyvsp[-5].d);
	Tree_Add(Symbol_T, &TheSymbol);
      }
      else{
	List_Write(pSymbol->val, 0, &yyvsp[-5].d);
      }
      fgetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop]);
      yylinenoImbricatedLoopsTab[ImbricatedLoop] = yylineno;
      ImbricatedLoop++;
      if(ImbricatedLoop > MAX_RECUR_LOOPS-1){
	yymsg(GERROR, "Reached maximum number of imbricated loops");
	ImbricatedLoop = MAX_RECUR_LOOPS-1;
      }
      if((yyvsp[-1].d > 0. && yyvsp[-5].d > yyvsp[-3].d) || (yyvsp[-1].d < 0. && yyvsp[-5].d < yyvsp[-3].d))
	skip_until("For", "EndFor");
    ;
    break;}
case 139:
#line 1976 "Gmsh.y"
{
      if(ImbricatedLoop <= 0){
	yymsg(GERROR, "Invalid For/EndFor loop");
	ImbricatedLoop = 0;
      }
      else{
	double x0 = LoopControlVariablesTab[ImbricatedLoop-1][0];
	double x1 = LoopControlVariablesTab[ImbricatedLoop-1][1];
	double step = LoopControlVariablesTab[ImbricatedLoop-1][2];
	int do_next = (step > 0.) ? (x0+step <= x1) : (x0+step >= x1);
	if(do_next){
	  LoopControlVariablesTab[ImbricatedLoop-1][0] +=
	    LoopControlVariablesTab[ImbricatedLoop-1][2];
	  if(LoopControlVariablesNameTab[ImbricatedLoop-1]){
	    Symbol TheSymbol;
	    TheSymbol.Name = LoopControlVariablesNameTab[ImbricatedLoop-1];
	    Symbol *pSymbol;
	    if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol)))
	      yymsg(GERROR, "Unknown loop variable");
	    else
	      *(double*)List_Pointer_Fast(pSymbol->val, 0) += 
		LoopControlVariablesTab[ImbricatedLoop-1][2];
	  }
	  fsetpos(yyin, &yyposImbricatedLoopsTab[ImbricatedLoop-1]);
	  yylineno = yylinenoImbricatedLoopsTab[ImbricatedLoop-1];
	}
	else{
	  ImbricatedLoop--;
	}
      }
    ;
    break;}
case 140:
#line 2008 "Gmsh.y"
{
      if(!FunctionManager::Instance()->createFunction(yyvsp[0].c, yyin, yyname, yylineno))
	yymsg(GERROR, "Redefinition of function %s", yyvsp[0].c);
      skip_until(NULL, "Return");
      //FIXME: wee leak $2
    ;
    break;}
case 141:
#line 2015 "Gmsh.y"
{
      if(!FunctionManager::Instance()->leaveFunction(&yyin, yyname, yylineno))
	yymsg(GERROR, "Error while exiting function");
    ;
    break;}
case 142:
#line 2020 "Gmsh.y"
{
      if(!FunctionManager::Instance()->enterFunction(yyvsp[-1].c, &yyin, yyname, yylineno))
	yymsg(GERROR, "Unknown function %s", yyvsp[-1].c);
      //FIXME: wee leak $2
    ;
    break;}
case 143:
#line 2026 "Gmsh.y"
{
      if(!yyvsp[-1].d) skip_until("If", "EndIf");
    ;
    break;}
case 144:
#line 2030 "Gmsh.y"
{
    ;
    break;}
case 145:
#line 2039 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE, yyvsp[-1].l, 
		    yyvsp[-3].v[0], yyvsp[-3].v[1], yyvsp[-3].v[2], 0., 0., 0., 0., 0., 0., 0.,
		    NULL, yyval.l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 146:
#line 2047 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(ROTATE, yyvsp[-1].l, 
		    0., 0., 0., yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d,
		    NULL, yyval.l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 147:
#line 2055 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE_ROTATE, yyvsp[-1].l, 
		    yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].d,
		    NULL, yyval.l);
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 148:
#line 2063 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 149:
#line 2068 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE, yyvsp[-3].l, 
		    yyvsp[-5].v[0], yyvsp[-5].v[1], yyvsp[-5].v[2], 0., 0., 0., 0., 0., 0., 0.,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 150:
#line 2076 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 151:
#line 2081 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(ROTATE, yyvsp[-3].l, 
		    0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 152:
#line 2089 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 153:
#line 2094 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShapes(TRANSLATE_ROTATE, yyvsp[-3].l, 
		    yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		    &extr, yyval.l);
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 154:
#line 2104 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_POINT, (int)yyvsp[-4].d, 
		   yyvsp[-2].v[0], yyvsp[-2].v[1], yyvsp[-2].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   NULL, yyval.l);
    ;
    break;}
case 155:
#line 2111 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SEGM_LINE, (int)yyvsp[-4].d, 
		   yyvsp[-2].v[0], yyvsp[-2].v[1], yyvsp[-2].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   NULL, yyval.l);
    ;
    break;}
case 156:
#line 2118 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SURF_PLAN, (int)yyvsp[-4].d, 
		   yyvsp[-2].v[0], yyvsp[-2].v[1], yyvsp[-2].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   NULL, yyval.l);
    ;
    break;}
case 157:
#line 2125 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_POINT, (int)yyvsp[-8].d, 
		   0., 0., 0., yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 158:
#line 2132 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SEGM_LINE, (int)yyvsp[-8].d, 
		   0., 0., 0., yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 159:
#line 2139 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SURF_PLAN, (int)yyvsp[-8].d, 
		   0., 0., 0., yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 160:
#line 2146 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_POINT, (int)yyvsp[-10].d, 
		   yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 161:
#line 2153 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SEGM_LINE, (int)yyvsp[-10].d, 
		   yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 162:
#line 2160 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SURF_PLAN, (int)yyvsp[-10].d, 
		   yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], yyvsp[-4].v[0], yyvsp[-4].v[1], yyvsp[-4].v[2], yyvsp[-2].d,
		   NULL, yyval.l);
    ;
    break;}
case 163:
#line 2167 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 164:
#line 2172 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_POINT, (int)yyvsp[-8].d, 
		   yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   &extr, yyval.l);
    ;
    break;}
case 165:
#line 2179 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 166:
#line 2184 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SEGM_LINE, (int)yyvsp[-8].d, 
		   yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   &extr, yyval.l);
    ;
    break;}
case 167:
#line 2191 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 168:
#line 2196 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE, MSH_SURF_PLAN, (int)yyvsp[-8].d, 
		   yyvsp[-6].v[0], yyvsp[-6].v[1], yyvsp[-6].v[2], 0., 0., 0., 0., 0., 0., 0.,
		   &extr, yyval.l);
    ;
    break;}
case 169:
#line 2203 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 170:
#line 2208 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_POINT, (int)yyvsp[-12].d, 
		   0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 171:
#line 2215 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 172:
#line 2220 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SEGM_LINE, (int)yyvsp[-12].d, 
		   0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 173:
#line 2227 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 174:
#line 2232 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(ROTATE, MSH_SURF_PLAN, (int)yyvsp[-12].d, 
		   0., 0., 0., yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 175:
#line 2239 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 176:
#line 2244 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_POINT, (int)yyvsp[-14].d, 
		   yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 177:
#line 2251 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 178:
#line 2256 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SEGM_LINE, (int)yyvsp[-14].d, 
		   yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 179:
#line 2263 "Gmsh.y"
{
      extr.mesh.ExtrudeMesh = false;
      extr.mesh.Recombine = false;
    ;
    break;}
case 180:
#line 2268 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(Shape));
      ExtrudeShape(TRANSLATE_ROTATE, MSH_SURF_PLAN, (int)yyvsp[-14].d, 
		   yyvsp[-12].v[0], yyvsp[-12].v[1], yyvsp[-12].v[2], yyvsp[-10].v[0], yyvsp[-10].v[1], yyvsp[-10].v[2], yyvsp[-8].v[0], yyvsp[-8].v[1], yyvsp[-8].v[2], yyvsp[-6].d,
		   &extr, yyval.l);
    ;
    break;}
case 181:
#line 2279 "Gmsh.y"
{
    ;
    break;}
case 182:
#line 2282 "Gmsh.y"
{
    ;
    break;}
case 183:
#line 2288 "Gmsh.y"
{
      double d;
      extr.mesh.ExtrudeMesh = true;
      extr.mesh.NbLayer = List_Nbr(yyvsp[-6].l);
      if(List_Nbr(yyvsp[-6].l) == List_Nbr(yyvsp[-4].l) && List_Nbr(yyvsp[-6].l) == List_Nbr(yyvsp[-2].l)){
	extr.mesh.NbElmLayer = (int*)Malloc(extr.mesh.NbLayer*sizeof(int));
	extr.mesh.ZonLayer = (int*)Malloc(extr.mesh.NbLayer*sizeof(int));
	extr.mesh.hLayer = (double*)Malloc(extr.mesh.NbLayer*sizeof(double));
	for(int i = 0; i < List_Nbr(yyvsp[-6].l); i++){
	  List_Read(yyvsp[-6].l, i, &d);
	  extr.mesh.NbElmLayer[i] = (d>0)?(int)d:1;
	  List_Read(yyvsp[-4].l, i, &d);
	  extr.mesh.ZonLayer[i] = (int)d;
	  List_Read(yyvsp[-2].l, i, &d);
	  extr.mesh.hLayer[i] = d;
	}
      }
      else{
	yymsg(GERROR, "Wrong layer definition {%d, %d, %d}", 
	      List_Nbr(yyvsp[-6].l), List_Nbr(yyvsp[-4].l), List_Nbr(yyvsp[-2].l));
      }
      List_Delete(yyvsp[-6].l);
      List_Delete(yyvsp[-4].l);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 184:
#line 2314 "Gmsh.y"
{
      double d;
      extr.mesh.ExtrudeMesh = true;
      extr.mesh.NbLayer = List_Nbr(yyvsp[-4].l);
      if(List_Nbr(yyvsp[-4].l) == List_Nbr(yyvsp[-2].l)){
	extr.mesh.NbElmLayer = (int*)Malloc(extr.mesh.NbLayer*sizeof(int));
	extr.mesh.ZonLayer = (int*)Malloc(extr.mesh.NbLayer*sizeof(int));
	extr.mesh.hLayer = (double*)Malloc(extr.mesh.NbLayer*sizeof(double));
	for(int i = 0; i < List_Nbr(yyvsp[-4].l); i++){
	  List_Read(yyvsp[-4].l, i, &d);
	  extr.mesh.NbElmLayer[i] = (d>0)?(int)d:1;
	  extr.mesh.ZonLayer[i] = 0;
	  List_Read(yyvsp[-2].l, i, &d);
	  extr.mesh.hLayer[i] = d;
	}
      }
      else{
	yymsg(GERROR, "Wrong layer definition {%d, %d}", 
	      List_Nbr(yyvsp[-4].l), List_Nbr(yyvsp[-2].l));
      }
      List_Delete(yyvsp[-4].l);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 185:
#line 2338 "Gmsh.y"
{
      extr.mesh.Recombine = true;
    ;
    break;}
case 186:
#line 2347 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	int j = (int)fabs(d);
        Curve *c = FindCurve(j, THEM);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", j);
	else{
	  c->Method = TRANSFINI;
	  c->ipar[0] = (yyvsp[-1].d>2)?(int)yyvsp[-1].d:2;
	  c->ipar[1] = sign(d);
	  c->dpar[0] = 1.0;
	}
      }
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 187:
#line 2365 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-6].l); i++){
	double d;
	List_Read(yyvsp[-6].l, i, &d);
	int j = (int)fabs(d);
        Curve *c = FindCurve(j, THEM);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", j);
	else{
	  c->Method = TRANSFINI;
	  c->ipar[0] = (yyvsp[-4].d>2)?(int)yyvsp[-4].d:2;
	  c->ipar[1] = sign(d); /* Progresion : code 1 ou -1 */
	  c->dpar[0] = fabs(yyvsp[-1].d);
	}
      }
      List_Delete(yyvsp[-6].l);
    ;
    break;}
case 188:
#line 2383 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-6].l); i++){
	double d;
	List_Read(yyvsp[-6].l, i, &d);
	int j = (int)fabs(d);
        Curve *c = FindCurve(j, THEM);
	if(!c)
	  yymsg(WARNING, "Unknown curve %d", j);
	else{
	  c->Method = TRANSFINI;
	  c->ipar[0] = (yyvsp[-4].d>2)?(int)yyvsp[-4].d:2;
	  c->ipar[1] = 2*sign(d); /* Bump : code 2 ou -2 */
	  c->dpar[0] = fabs(yyvsp[-1].d);
	}
      }
      List_Delete(yyvsp[-6].l);
    ;
    break;}
case 189:
#line 2401 "Gmsh.y"
{
      Surface *s = FindSurface((int)yyvsp[-4].d, THEM);
      if(!s)
	yymsg(WARNING, "Unknown surface %d", (int)yyvsp[-4].d);
      else{
	s->Method = TRANSFINI;
	s->Recombine_Dir = 1;
	int k = List_Nbr(yyvsp[-1].l);
	if(k != 3 && k != 4){
	  yymsg(GERROR, "Wrong definition of Transfinite Surface %d: "
		"%d points instead of 3 or 4" , (int)yyvsp[-4].d, k);
	}
	else{
	  List_Reset(s->TrsfPoints);
	  for(int i = 0; i < k; i++){
	    double d;
	    List_Read(yyvsp[-1].l, i, &d);
	    int j = (int)fabs(d);
	    Vertex *v = FindPoint(j, THEM);
	    if(!v)
	      yymsg(WARNING, "Unknown point %d", j);
	    else
	      List_Add(s->TrsfPoints, &v);
	  }
	}
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 190:
#line 2430 "Gmsh.y"
{
      Surface *s = FindSurface((int)yyvsp[-5].d, THEM);
      if(!s)
	yymsg(WARNING, "Unknown surface %d", (int)yyvsp[-5].d);
      else{
	s->Method = TRANSFINI;
	int k = List_Nbr(yyvsp[-2].l);
	if(k != 3 && k != 4){
	  yymsg(GERROR, "Wrong definition of Transfinite Surface %d: "
		"%d points instead of 3 or 4" , (int)yyvsp[-5].d, k);
	}
	else{
	  List_Reset(s->TrsfPoints);
	  if (!strcmp(yyvsp[-1].c, "Right"))
	    s->Recombine_Dir = 1;
	  else if (!strcmp(yyvsp[-1].c, "Left"))
	    s->Recombine_Dir = -1;
	  else
	    s->Recombine_Dir = 0;
	  for(int i = 0; i < k; i++){
	    double d;
	    List_Read(yyvsp[-2].l, i, &d);
	    int j = (int)fabs(d);
	    Vertex *v = FindPoint(j, THEM);
	    if(!v)
	      yymsg(WARNING, "Unknown point %d", j);
	    else
	      List_Add(s->TrsfPoints, &v);
	  }
	}
      }
      List_Delete(yyvsp[-2].l);
      Free(yyvsp[-1].c);
    ;
    break;}
case 191:
#line 2465 "Gmsh.y"
{
      Surface *s = FindSurface((int)yyvsp[-4].d, THEM);
      if(!s)
	yymsg(WARNING, "Unknown surface %d", (int)yyvsp[-4].d);
      else{
        s->Method = ELLIPTIC;
        int k = List_Nbr(yyvsp[-1].l);
        if(k != 4)
	  yymsg(GERROR, "Wrong definition of Elliptic Surface %d: "
		"%d points instead of 4" , (int)yyvsp[-4].d, k);
        else{
	  List_Reset(s->TrsfPoints);
	  for(int i = 0; i < k; i++){
	    double d;
	    List_Read(yyvsp[-1].l, i, &d);
	    int j = (int)fabs(d);
	    Vertex *v = FindPoint(j, THEM);
	    if(!v)
	      yymsg(WARNING, "Unknown point %d", j);
	    else
	      List_Add(s->TrsfPoints, &v);
	  }
	}
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 192:
#line 2492 "Gmsh.y"
{
      Volume *v = FindVolume((int)yyvsp[-4].d, THEM);
      if(!v)
	yymsg(WARNING, "Unknown volume %d", (int)yyvsp[-4].d);
      else{
	v->Method = TRANSFINI;
	int k = List_Nbr(yyvsp[-1].l);
	if(k != 6 && k != 8)
	  yymsg(GERROR, "Wrong definition of Transfinite Volume %d: "
		"%d points instead of 6 or 8" , (int)yyvsp[-4].d, k);
	else{
	  List_Reset(v->TrsfPoints);
	  for(int i = 0; i < k; i++){
	    double d;
	    List_Read(yyvsp[-1].l, i, &d);
	    int j = (int)fabs(d);
	    Vertex *vert = FindPoint(j, THEM);
	    if(!vert)
	      yymsg(WARNING, "Unknown point %d", j);
	    else
	      List_Add(v->TrsfPoints, &vert);
	  }
	}
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 193:
#line 2519 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-3].l); i++){
	double d;
	List_Read(yyvsp[-3].l, i, &d);
	int j = (int)d;
	Surface *s = FindSurface(j, THEM);
	if(s){
	  s->Recombine = 1;
	  s->RecombineAngle = (yyvsp[-1].d > 0 && yyvsp[-1].d < 90) ? yyvsp[-1].d : 90;
	}
      }
      List_Delete(yyvsp[-3].l);
    ;
    break;}
case 194:
#line 2533 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[-1].l); i++){
	double d;
	List_Read(yyvsp[-1].l, i, &d);
	int j = (int)d;
        Surface *s = FindSurface(j, THEM);
	if(s){
	  s->Recombine = 1;
        }
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 195:
#line 2552 "Gmsh.y"
{ 
      ReplaceAllDuplicates(THEM);
    ;
    break;}
case 196:
#line 2556 "Gmsh.y"
{ 
      IntersectAllSegmentsTogether();
    ;
    break;}
case 197:
#line 2565 "Gmsh.y"
{ yyval.d = yyvsp[0].d;           ;
    break;}
case 198:
#line 2566 "Gmsh.y"
{ yyval.d = yyvsp[-1].d;           ;
    break;}
case 199:
#line 2567 "Gmsh.y"
{ yyval.d = -yyvsp[0].d;          ;
    break;}
case 200:
#line 2568 "Gmsh.y"
{ yyval.d = yyvsp[0].d;           ;
    break;}
case 201:
#line 2569 "Gmsh.y"
{ yyval.d = !yyvsp[0].d;          ;
    break;}
case 202:
#line 2570 "Gmsh.y"
{ yyval.d = yyvsp[-2].d - yyvsp[0].d;      ;
    break;}
case 203:
#line 2571 "Gmsh.y"
{ yyval.d = yyvsp[-2].d + yyvsp[0].d;      ;
    break;}
case 204:
#line 2572 "Gmsh.y"
{ yyval.d = yyvsp[-2].d * yyvsp[0].d;      ;
    break;}
case 205:
#line 2574 "Gmsh.y"
{ 
      if(!yyvsp[0].d)
	yymsg(GERROR, "Division by zero in '%g / %g'", yyvsp[-2].d, yyvsp[0].d);
      else
	yyval.d = yyvsp[-2].d / yyvsp[0].d;     
    ;
    break;}
case 206:
#line 2580 "Gmsh.y"
{ yyval.d = (int)yyvsp[-2].d % (int)yyvsp[0].d;  ;
    break;}
case 207:
#line 2581 "Gmsh.y"
{ yyval.d = pow(yyvsp[-2].d, yyvsp[0].d);  ;
    break;}
case 208:
#line 2582 "Gmsh.y"
{ yyval.d = yyvsp[-2].d < yyvsp[0].d;      ;
    break;}
case 209:
#line 2583 "Gmsh.y"
{ yyval.d = yyvsp[-2].d > yyvsp[0].d;      ;
    break;}
case 210:
#line 2584 "Gmsh.y"
{ yyval.d = yyvsp[-2].d <= yyvsp[0].d;     ;
    break;}
case 211:
#line 2585 "Gmsh.y"
{ yyval.d = yyvsp[-2].d >= yyvsp[0].d;     ;
    break;}
case 212:
#line 2586 "Gmsh.y"
{ yyval.d = yyvsp[-2].d == yyvsp[0].d;     ;
    break;}
case 213:
#line 2587 "Gmsh.y"
{ yyval.d = yyvsp[-2].d != yyvsp[0].d;     ;
    break;}
case 214:
#line 2588 "Gmsh.y"
{ yyval.d = yyvsp[-2].d && yyvsp[0].d;     ;
    break;}
case 215:
#line 2589 "Gmsh.y"
{ yyval.d = yyvsp[-2].d || yyvsp[0].d;     ;
    break;}
case 216:
#line 2590 "Gmsh.y"
{ yyval.d = yyvsp[-4].d? yyvsp[-2].d : yyvsp[0].d;  ;
    break;}
case 217:
#line 2591 "Gmsh.y"
{ yyval.d = exp(yyvsp[-1].d);      ;
    break;}
case 218:
#line 2592 "Gmsh.y"
{ yyval.d = log(yyvsp[-1].d);      ;
    break;}
case 219:
#line 2593 "Gmsh.y"
{ yyval.d = log10(yyvsp[-1].d);    ;
    break;}
case 220:
#line 2594 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-1].d);     ;
    break;}
case 221:
#line 2595 "Gmsh.y"
{ yyval.d = sin(yyvsp[-1].d);      ;
    break;}
case 222:
#line 2596 "Gmsh.y"
{ yyval.d = asin(yyvsp[-1].d);     ;
    break;}
case 223:
#line 2597 "Gmsh.y"
{ yyval.d = cos(yyvsp[-1].d);      ;
    break;}
case 224:
#line 2598 "Gmsh.y"
{ yyval.d = acos(yyvsp[-1].d);     ;
    break;}
case 225:
#line 2599 "Gmsh.y"
{ yyval.d = tan(yyvsp[-1].d);      ;
    break;}
case 226:
#line 2600 "Gmsh.y"
{ yyval.d = atan(yyvsp[-1].d);     ;
    break;}
case 227:
#line 2601 "Gmsh.y"
{ yyval.d = atan2(yyvsp[-3].d, yyvsp[-1].d);;
    break;}
case 228:
#line 2602 "Gmsh.y"
{ yyval.d = sinh(yyvsp[-1].d);     ;
    break;}
case 229:
#line 2603 "Gmsh.y"
{ yyval.d = cosh(yyvsp[-1].d);     ;
    break;}
case 230:
#line 2604 "Gmsh.y"
{ yyval.d = tanh(yyvsp[-1].d);     ;
    break;}
case 231:
#line 2605 "Gmsh.y"
{ yyval.d = fabs(yyvsp[-1].d);     ;
    break;}
case 232:
#line 2606 "Gmsh.y"
{ yyval.d = floor(yyvsp[-1].d);    ;
    break;}
case 233:
#line 2607 "Gmsh.y"
{ yyval.d = ceil(yyvsp[-1].d);     ;
    break;}
case 234:
#line 2608 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 235:
#line 2609 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 236:
#line 2610 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-3].d*yyvsp[-3].d+yyvsp[-1].d*yyvsp[-1].d); ;
    break;}
case 237:
#line 2611 "Gmsh.y"
{ yyval.d = yyvsp[-1].d*(double)rand()/(double)RAND_MAX; ;
    break;}
case 238:
#line 2613 "Gmsh.y"
{ yyval.d = exp(yyvsp[-1].d);      ;
    break;}
case 239:
#line 2614 "Gmsh.y"
{ yyval.d = log(yyvsp[-1].d);      ;
    break;}
case 240:
#line 2615 "Gmsh.y"
{ yyval.d = log10(yyvsp[-1].d);    ;
    break;}
case 241:
#line 2616 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-1].d);     ;
    break;}
case 242:
#line 2617 "Gmsh.y"
{ yyval.d = sin(yyvsp[-1].d);      ;
    break;}
case 243:
#line 2618 "Gmsh.y"
{ yyval.d = asin(yyvsp[-1].d);     ;
    break;}
case 244:
#line 2619 "Gmsh.y"
{ yyval.d = cos(yyvsp[-1].d);      ;
    break;}
case 245:
#line 2620 "Gmsh.y"
{ yyval.d = acos(yyvsp[-1].d);     ;
    break;}
case 246:
#line 2621 "Gmsh.y"
{ yyval.d = tan(yyvsp[-1].d);      ;
    break;}
case 247:
#line 2622 "Gmsh.y"
{ yyval.d = atan(yyvsp[-1].d);     ;
    break;}
case 248:
#line 2623 "Gmsh.y"
{ yyval.d = atan2(yyvsp[-3].d, yyvsp[-1].d);;
    break;}
case 249:
#line 2624 "Gmsh.y"
{ yyval.d = sinh(yyvsp[-1].d);     ;
    break;}
case 250:
#line 2625 "Gmsh.y"
{ yyval.d = cosh(yyvsp[-1].d);     ;
    break;}
case 251:
#line 2626 "Gmsh.y"
{ yyval.d = tanh(yyvsp[-1].d);     ;
    break;}
case 252:
#line 2627 "Gmsh.y"
{ yyval.d = fabs(yyvsp[-1].d);     ;
    break;}
case 253:
#line 2628 "Gmsh.y"
{ yyval.d = floor(yyvsp[-1].d);    ;
    break;}
case 254:
#line 2629 "Gmsh.y"
{ yyval.d = ceil(yyvsp[-1].d);     ;
    break;}
case 255:
#line 2630 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 256:
#line 2631 "Gmsh.y"
{ yyval.d = fmod(yyvsp[-3].d, yyvsp[-1].d); ;
    break;}
case 257:
#line 2632 "Gmsh.y"
{ yyval.d = sqrt(yyvsp[-3].d*yyvsp[-3].d+yyvsp[-1].d*yyvsp[-1].d); ;
    break;}
case 258:
#line 2633 "Gmsh.y"
{ yyval.d = yyvsp[-1].d*(double)rand()/(double)RAND_MAX; ;
    break;}
case 259:
#line 2642 "Gmsh.y"
{ yyval.d = yyvsp[0].d; ;
    break;}
case 260:
#line 2643 "Gmsh.y"
{ yyval.d = 3.141592653589793; ;
    break;}
case 261:
#line 2644 "Gmsh.y"
{ yyval.d = ParUtil::Instance()->rank(); ;
    break;}
case 262:
#line 2645 "Gmsh.y"
{ yyval.d = ParUtil::Instance()->size(); ;
    break;}
case 263:
#line 2646 "Gmsh.y"
{ yyval.d = GMSH_MAJOR_VERSION; ;
    break;}
case 264:
#line 2647 "Gmsh.y"
{ yyval.d = GMSH_MINOR_VERSION; ;
    break;}
case 265:
#line 2648 "Gmsh.y"
{ yyval.d = GMSH_PATCH_VERSION; ;
    break;}
case 266:
#line 2653 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[0].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[0].c);
	yyval.d = 0.;
      }
      else
	yyval.d = *(double*)List_Pointer_Fast(pSymbol->val, 0);
      Free(yyvsp[0].c);
    ;
    break;}
case 267:
#line 2666 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-3].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-3].c);
	yyval.d = 0.;
      }
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-1].d)))
	  yyval.d = *pd;
	else{
	  yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-3].c, (int)yyvsp[-1].d);
	  yyval.d = 0.;
	}
      }
      Free(yyvsp[-3].c);
    ;
    break;}
case 268:
#line 2686 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c);
	yyval.d = 0.;
      }
      else{
	yyval.d = List_Nbr(pSymbol->val);
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 269:
#line 2700 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-1].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-1].c);
	yyval.d = 0.;
      }
      else
	yyval.d = (*(double*)List_Pointer_Fast(pSymbol->val, 0) += yyvsp[0].i);
      Free(yyvsp[-1].c);
    ;
    break;}
case 270:
#line 2713 "Gmsh.y"
{
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-4].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-4].c);
	yyval.d = 0.;
      }
      else{
	double *pd;
	if((pd = (double*)List_Pointer_Test(pSymbol->val, (int)yyvsp[-2].d)))
	  yyval.d = (*pd += yyvsp[0].i);
	else{
	  yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-4].c, (int)yyvsp[-2].d);
	  yyval.d = 0.;
	}
      }
      Free(yyvsp[-4].c);
    ;
    break;}
case 271:
#line 2736 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-2].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-2].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[0].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-2].c, yyvsp[0].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt(0, GMSH_GET, 0);
      }
      Free(yyvsp[-2].c); Free(yyvsp[0].c);
    ;
    break;}
case 272:
#line 2754 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-5].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-5].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[0].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-5].c, (int)yyvsp[-3].d, yyvsp[0].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt((int)yyvsp[-3].d, GMSH_GET, 0);
      }
      Free(yyvsp[-5].c); Free(yyvsp[0].c);
    ;
    break;}
case 273:
#line 2772 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-3].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-3].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-1].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s.%s'", yyvsp[-3].c, yyvsp[-1].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt(0, GMSH_SET|GMSH_GUI, pNumOpt(0, GMSH_GET, 0)+yyvsp[0].i);
      }
      Free(yyvsp[-3].c); Free(yyvsp[-1].c);
    ;
    break;}
case 274:
#line 2790 "Gmsh.y"
{
      double (*pNumOpt)(int num, int action, double value);
      StringXNumber *pNumCat;
      if(!(pNumCat = Get_NumberOptionCategory(yyvsp[-6].c))){
	yymsg(GERROR, "Unknown numeric option class '%s'", yyvsp[-6].c);
	yyval.d = 0.;
      }
      else{
	if(!(pNumOpt =  (double (*) (int, int, double))Get_NumberOption(yyvsp[-1].c, pNumCat))){
	  yymsg(GERROR, "Unknown numeric option '%s[%d].%s'", yyvsp[-6].c, (int)yyvsp[-4].d, yyvsp[-1].c);
	  yyval.d = 0.;
	}
	else
	  yyval.d = pNumOpt((int)yyvsp[-4].d, GMSH_SET|GMSH_GUI, pNumOpt((int)yyvsp[-4].d, GMSH_GET, 0)+yyvsp[0].i);
      }
      Free(yyvsp[-6].c); Free(yyvsp[-1].c);
    ;
    break;}
case 275:
#line 2808 "Gmsh.y"
{ 
      yyval.d = GetValue(yyvsp[-3].c, yyvsp[-1].d);
      Free(yyvsp[-3].c);
    ;
    break;}
case 276:
#line 2816 "Gmsh.y"
{
      memcpy(yyval.v, yyvsp[0].v, 5*sizeof(double));
    ;
    break;}
case 277:
#line 2820 "Gmsh.y"
{
      for(int i = 0; i < 5; i++) yyval.v[i] = -yyvsp[0].v[i];
    ;
    break;}
case 278:
#line 2824 "Gmsh.y"
{ 
      for(int i = 0; i < 5; i++) yyval.v[i] = yyvsp[0].v[i];
    ;
    break;}
case 279:
#line 2828 "Gmsh.y"
{ 
      for(int i = 0; i < 5; i++) yyval.v[i] = yyvsp[-2].v[i] - yyvsp[0].v[i];
    ;
    break;}
case 280:
#line 2832 "Gmsh.y"
{
      for(int i = 0; i < 5; i++) yyval.v[i] = yyvsp[-2].v[i] + yyvsp[0].v[i];
    ;
    break;}
case 281:
#line 2839 "Gmsh.y"
{ 
      yyval.v[0] = yyvsp[-9].d;  yyval.v[1] = yyvsp[-7].d;  yyval.v[2] = yyvsp[-5].d;  yyval.v[3] = yyvsp[-3].d; yyval.v[4] = yyvsp[-1].d;
    ;
    break;}
case 282:
#line 2843 "Gmsh.y"
{ 
      yyval.v[0] = yyvsp[-7].d;  yyval.v[1] = yyvsp[-5].d;  yyval.v[2] = yyvsp[-3].d;  yyval.v[3] = yyvsp[-1].d; yyval.v[4] = 1.0;
    ;
    break;}
case 283:
#line 2847 "Gmsh.y"
{
      yyval.v[0] = yyvsp[-5].d;  yyval.v[1] = yyvsp[-3].d;  yyval.v[2] = yyvsp[-1].d;  yyval.v[3] = 0.0; yyval.v[4] = 1.0;
    ;
    break;}
case 284:
#line 2851 "Gmsh.y"
{
      yyval.v[0] = yyvsp[-5].d;  yyval.v[1] = yyvsp[-3].d;  yyval.v[2] = yyvsp[-1].d;  yyval.v[3] = 0.0; yyval.v[4] = 1.0;
    ;
    break;}
case 285:
#line 2858 "Gmsh.y"
{
    ;
    break;}
case 286:
#line 2861 "Gmsh.y"
{
       yyval.l = yyvsp[-1].l;
    ;
    break;}
case 287:
#line 2865 "Gmsh.y"
{
       yyval.l = yyvsp[-1].l;
    ;
    break;}
case 288:
#line 2872 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(List_T*));
      List_Add(yyval.l, &(yyvsp[0].l));
    ;
    break;}
case 289:
#line 2877 "Gmsh.y"
{
      List_Add(yyval.l, &(yyvsp[0].l));
    ;
    break;}
case 290:
#line 2885 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      List_Add(yyval.l, &(yyvsp[0].d));
    ;
    break;}
case 291:
#line 2890 "Gmsh.y"
{
      yyval.l = yyvsp[0].l;
    ;
    break;}
case 292:
#line 2894 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 293:
#line 2898 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
      double *pd;
      for(int i = 0; i < List_Nbr(yyval.l); i++){
	pd = (double*)List_Pointer(yyval.l, i);
	(*pd) = - (*pd);
      }
    ;
    break;}
case 294:
#line 2910 "Gmsh.y"
{ 
      yyval.l = List_Create(2, 1, sizeof(double)); 
      for(double d = yyvsp[-2].d; (yyvsp[-2].d < yyvsp[0].d) ? (d <= yyvsp[0].d) : (d >= yyvsp[0].d); (yyvsp[-2].d < yyvsp[0].d) ? (d += 1.) : (d -= 1.)) 
	List_Add(yyval.l, &d);
    ;
    break;}
case 295:
#line 2916 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double)); 
      if(!yyvsp[0].d || (yyvsp[-4].d < yyvsp[-2].d && yyvsp[0].d < 0) || (yyvsp[-4].d > yyvsp[-2].d && yyvsp[0].d > 0)){
        yymsg(GERROR, "Wrong increment in '%g:%g:%g'", yyvsp[-4].d, yyvsp[-2].d, yyvsp[0].d);
	List_Add(yyval.l, &(yyvsp[-4].d));
      }
      else
	for(double d = yyvsp[-4].d; (yyvsp[0].d > 0) ? (d <= yyvsp[-2].d) : (d >= yyvsp[-2].d); d += yyvsp[0].d)
	  List_Add(yyval.l, &d);
   ;
    break;}
case 296:
#line 2927 "Gmsh.y"
{
      // Returns the coordinates of a point and fills a list with it.
      // This allows to ensure e.g. that relative point positions are
      // always conserved
      Vertex *v = FindPoint((int)yyvsp[-1].d, THEM);
      yyval.l = List_Create(3, 1, sizeof(double));      
      if(!v) {
	yymsg(GERROR, "Unknown point '%d'", (int) yyvsp[-1].d);
	double d = 0.0;
	List_Add(yyval.l, &d);
	List_Add(yyval.l, &d);
	List_Add(yyval.l, &d);
      }
      else{
	List_Add(yyval.l, &v->Pos.X);
	List_Add(yyval.l, &v->Pos.Y);
	List_Add(yyval.l, &v->Pos.Z);
      }
    ;
    break;}
case 297:
#line 2947 "Gmsh.y"
{
      yyval.l = List_Create(List_Nbr(yyvsp[0].l), 1, sizeof(double));
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	Shape *s = (Shape*) List_Pointer(yyvsp[0].l, i);
	double d = s->Num;
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 298:
#line 2957 "Gmsh.y"
{
      yyval.l = List_Create(List_Nbr(yyvsp[0].l), 1, sizeof(double));
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	Shape *s = (Shape*) List_Pointer(yyvsp[0].l, i);
	double d = s->Num;
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 299:
#line 2967 "Gmsh.y"
{
      yyval.l = List_Create(List_Nbr(yyvsp[0].l), 1, sizeof(double));
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	Shape *s = (Shape*) List_Pointer(yyvsp[0].l, i);
	double d = s->Num;
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 300:
#line 2977 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c);
	double d = 0.0;
	List_Add(yyval.l, &d);
      }
      else{
	for(int i = 0; i < List_Nbr(pSymbol->val); i++)
	  List_Add(yyval.l, (double*)List_Pointer_Fast(pSymbol->val, i));
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 301:
#line 2994 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-2].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-2].c);
	double d = 0.0;
	List_Add(yyval.l, &d);
      }
      else{
	for(int i = 0; i < List_Nbr(pSymbol->val); i++){
	  double d = - *(double*)List_Pointer_Fast(pSymbol->val, i);
	  List_Add(yyval.l, &d);
	}
      }
      Free(yyvsp[-2].c);
    ;
    break;}
case 302:
#line 3013 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-5].c);
	double d = 0.0;
	List_Add(yyval.l, &d);
      }
      else{
	for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	  int j = (int)(*(double*)List_Pointer_Fast(yyvsp[-2].l, i));
	  double *pd;
	  if((pd = (double*)List_Pointer_Test(pSymbol->val, j)))
	    List_Add(yyval.l, pd);
	  else
	    yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-5].c, j);	  
	}
      }
      Free(yyvsp[-5].c);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 303:
#line 3037 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      Symbol TheSymbol;
      TheSymbol.Name = yyvsp[-5].c;
      Symbol *pSymbol;
      if(!(pSymbol = (Symbol*)Tree_PQuery(Symbol_T, &TheSymbol))) {
	yymsg(GERROR, "Unknown variable '%s'", yyvsp[-5].c);
	double d = 0.0;
	List_Add(yyval.l, &d);
      }
      else{
	for(int i = 0; i < List_Nbr(yyvsp[-2].l); i++){
	  int j = (int)(*(double*)List_Pointer_Fast(yyvsp[-2].l, i));
	  double *pd;
	  if((pd = (double*)List_Pointer_Test(pSymbol->val, j))){
	    double d = - *pd;
	    List_Add(yyval.l, &d);
	  }
	  else
	    yymsg(GERROR, "Uninitialized variable '%s[%d]'", yyvsp[-5].c, j);	  
	}
      }
      Free(yyvsp[-5].c);
      List_Delete(yyvsp[-2].l);
    ;
    break;}
case 304:
#line 3066 "Gmsh.y"
{
      yyval.l = List_Create(2, 1, sizeof(double));
      List_Add(yyval.l, &(yyvsp[0].d));
    ;
    break;}
case 305:
#line 3071 "Gmsh.y"
{
      yyval.l = yyvsp[0].l;
    ;
    break;}
case 306:
#line 3075 "Gmsh.y"
{
      List_Add(yyval.l, &(yyvsp[0].d));
    ;
    break;}
case 307:
#line 3079 "Gmsh.y"
{
      for(int i = 0; i < List_Nbr(yyvsp[0].l); i++){
	double d;
	List_Read(yyvsp[0].l, i, &d);
	List_Add(yyval.l, &d);
      }
      List_Delete(yyvsp[0].l);
    ;
    break;}
case 308:
#line 3092 "Gmsh.y"
{
      yyval.u = CTX.PACK_COLOR((int)yyvsp[-7].d, (int)yyvsp[-5].d, (int)yyvsp[-3].d, (int)yyvsp[-1].d);
    ;
    break;}
case 309:
#line 3096 "Gmsh.y"
{
      yyval.u = CTX.PACK_COLOR((int)yyvsp[-5].d, (int)yyvsp[-3].d, (int)yyvsp[-1].d, 255);
    ;
    break;}
case 310:
#line 3108 "Gmsh.y"
{
      int flag;
      yyval.u = Get_ColorForString(ColorString, -1, yyvsp[0].c, &flag);
      if(flag) yymsg(GERROR, "Unknown color '%s'", yyvsp[0].c);
      Free(yyvsp[0].c);
    ;
    break;}
case 311:
#line 3115 "Gmsh.y"
{
      unsigned int (*pColOpt)(int num, int action, unsigned int value);
      StringXColor *pColCat;
      if(!(pColCat = Get_ColorOptionCategory(yyvsp[-4].c))){
	yymsg(GERROR, "Unknown color option class '%s'", yyvsp[-4].c);
	yyval.u = 0;
      }
      else{
	if(!(pColOpt =  (unsigned int (*) (int, int, unsigned int))Get_ColorOption(yyvsp[0].c, pColCat))){
	  yymsg(GERROR, "Unknown color option '%s.Color.%s'", yyvsp[-4].c, yyvsp[0].c);
	  yyval.u = 0;
	}
	else{
	  yyval.u = pColOpt(0, GMSH_GET, 0);
	}
      }
      Free(yyvsp[-4].c); Free(yyvsp[0].c);
    ;
    break;}
case 312:
#line 3137 "Gmsh.y"
{
      yyval.l = yyvsp[-1].l;
    ;
    break;}
case 313:
#line 3141 "Gmsh.y"
{
      yyval.l = List_Create(256, 10, sizeof(unsigned int));
      GmshColorTable *ct = Get_ColorTable((int)yyvsp[-3].d);
      if(!ct)
	yymsg(GERROR, "View[%d] does not exist", (int)yyvsp[-3].d);
      else{
	for(int i = 0; i < ct->size; i++) 
	  List_Add(yyval.l, &ct->table[i]);
      }
      Free(yyvsp[-5].c);
    ;
    break;}
case 314:
#line 3156 "Gmsh.y"
{
      yyval.l = List_Create(256, 10, sizeof(unsigned int));
      List_Add(yyval.l, &(yyvsp[0].u));
    ;
    break;}
case 315:
#line 3161 "Gmsh.y"
{
      List_Add(yyval.l, &(yyvsp[0].u));
    ;
    break;}
case 316:
#line 3168 "Gmsh.y"
{
      yyval.c = yyvsp[0].c;
    ;
    break;}
case 317:
#line 3172 "Gmsh.y"
{
      yyval.c = (char *)Malloc(32*sizeof(char));
      time_t now;
      time(&now);
      strcpy(yyval.c, ctime(&now));
      yyval.c[strlen(yyval.c) - 1] = '\0';
    ;
    break;}
case 318:
#line 3180 "Gmsh.y"
{
      yyval.c = (char *)Malloc((strlen(yyvsp[-3].c)+strlen(yyvsp[-1].c)+1)*sizeof(char));
      strcpy(yyval.c, yyvsp[-3].c);
      strcat(yyval.c, yyvsp[-1].c);
      Free(yyvsp[-3].c);
      Free(yyvsp[-1].c);
    ;
    break;}
case 319:
#line 3188 "Gmsh.y"
{
      yyval.c = (char *)Malloc((strlen(yyvsp[-1].c)+1)*sizeof(char));
      int i;
      for(i = strlen(yyvsp[-1].c)-1; i >= 0; i--){
	if(yyvsp[-1].c[i] == '.'){
	  strncpy(yyval.c, yyvsp[-1].c, i);
	  yyval.c[i]='\0';
	  break;
	}
      }
      if(i <= 0) strcpy(yyval.c, yyvsp[-1].c);
      Free(yyvsp[-1].c);
    ;
    break;}
case 320:
#line 3202 "Gmsh.y"
{
      yyval.c = (char *)Malloc((strlen(yyvsp[-1].c)+1)*sizeof(char));
      int i;
      for(i = strlen(yyvsp[-1].c)-1; i >= 0; i--){
	if(yyvsp[-1].c[i] == '/' || yyvsp[-1].c[i] == '\\')
	  break;
      }
      if(i <= 0)
	strcpy(yyval.c, yyvsp[-1].c);
      else
	strcpy(yyval.c, &yyvsp[-1].c[i+1]);
      Free(yyvsp[-1].c);
    ;
    break;}
case 321:
#line 3216 "Gmsh.y"
{
      yyval.c = yyvsp[-1].c;
    ;
    break;}
case 322:
#line 3220 "Gmsh.y"
{
      char tmpstring[1024];
      int i = PrintListOfDouble(yyvsp[-3].c, yyvsp[-1].l, tmpstring);
      if(i < 0){
	yymsg(GERROR, "Too few arguments in Sprintf");
	yyval.c = yyvsp[-3].c;
      }
      else if(i > 0){
	yymsg(GERROR, "%d extra argument%s in Sprintf", i, (i>1)?"s":"");
	yyval.c = yyvsp[-3].c;
      }
      else{
	yyval.c = (char*)Malloc((strlen(tmpstring)+1)*sizeof(char));
	strcpy(yyval.c, tmpstring);
	Free(yyvsp[-3].c);
      }
      List_Delete(yyvsp[-1].l);
    ;
    break;}
case 323:
#line 3239 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-3].c))){
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-3].c);
	yyval.c = (char*)Malloc(sizeof(char));
	yyval.c[0] = '\0';
      }
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-1].c, pStrCat))){
	  yymsg(GERROR, "Unknown string option '%s.%s'", yyvsp[-3].c, yyvsp[-1].c);
	  yyval.c = (char*)Malloc(sizeof(char));
	  yyval.c[0] = '\0';
	}
	else{
	  char *str = pStrOpt(0, GMSH_GET, NULL);
	  yyval.c = (char*)Malloc((strlen(str)+1)*sizeof(char));
	  strcpy(yyval.c, str);
	}
      }
    ;
    break;}
case 324:
#line 3261 "Gmsh.y"
{ 
      char* (*pStrOpt)(int num, int action, char *value);
      StringXString *pStrCat;
      if(!(pStrCat = Get_StringOptionCategory(yyvsp[-6].c))){
	yymsg(GERROR, "Unknown string option class '%s'", yyvsp[-6].c);
	yyval.c = (char*)Malloc(sizeof(char));
	yyval.c[0] = '\0';
      }
      else{
	if(!(pStrOpt = (char *(*) (int, int, char *))Get_StringOption(yyvsp[-1].c, pStrCat))){
	  yymsg(GERROR, "Unknown string option '%s[%d].%s'", yyvsp[-6].c, (int)yyvsp[-4].d, yyvsp[-1].c);
	  yyval.c = (char*)Malloc(sizeof(char));
	  yyval.c[0] = '\0';
	}
	else{
	  char *str = pStrOpt((int)yyvsp[-4].d, GMSH_GET, NULL);
	  yyval.c = (char*)Malloc((strlen(str)+1)*sizeof(char));
	  strcpy(yyval.c, str);
	}
      }
    ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 3284 "Gmsh.y"


void DeleteSymbol(void *a, void *b){
  Symbol *s = (Symbol*)a;
  Free(s->Name);
  List_Delete(s->val);
}

int CompareSymbols (const void *a, const void *b){
  return(strcmp(((Symbol*)a)->Name, ((Symbol*)b)->Name));
}

void InitSymbols(void){
  if(Symbol_T){
    Tree_Action(Symbol_T, DeleteSymbol);
    Tree_Delete(Symbol_T);
  }
  Symbol_T = Tree_Create(sizeof(Symbol), CompareSymbols);
}

int PrintListOfDouble(char *format, List_T *list, char *buffer){
  int j, k;
  char tmp1[256], tmp2[256];

  j = 0;
  buffer[j] = '\0';

  while(j < (int)strlen(format) && format[j] != '%') j++;
  strncpy(buffer, format, j); 
  buffer[j]='\0'; 
  for(int i = 0; i < List_Nbr(list); i++){
    k = j;
    j++;
    if(j < (int)strlen(format)){
      if(format[j] == '%'){
	strcat(buffer, "%");
	j++;
      }
      while(j < (int)strlen(format) && format[j] != '%') j++;
      if(k != j){
	strncpy(tmp1, &(format[k]), j-k);
	tmp1[j-k] = '\0';
	sprintf(tmp2, tmp1, *(double*)List_Pointer(list, i)); 
	strcat(buffer, tmp2);
      }
    }
    else{
      return List_Nbr(list)-i;
    }
  }
  if(j != (int)strlen(format))
    return -1;
  return 0;
}

int CheckViewErrorFlags(Post_View *v){
  if(View->adaptive) return 0; // hope for the best :-)

  char *name[8] = { "point", "line", "triangle", "quadrangle", 
		    "tetrahedron", "hexahedron", "prism", "pyramid" };
  char *type[3] = { "scalar", "vector", "tensor" };

  if(8 * 3 != VIEW_NB_ELEMENT_TYPES){
    Msg(GERROR, "Please upgrade CheckViewErrorFlags!");
    return 0;
  }
  
  for(int i = 0; i < VIEW_NB_ELEMENT_TYPES; i++)
    if(ViewErrorFlags[i])
      Msg(GERROR, "%d %s %s%s in View[%d] contain%s a wrong number of values",
	  ViewErrorFlags[i], type[i%3], name[i/3], (ViewErrorFlags[i] > 1) ? "s" : "",
	  v->Index, (ViewErrorFlags[i] > 1) ? "" : "s");
  
  return 0;
}

void yyerror(char *s){
  Msg(GERROR, "'%s', line %d : %s (%s)", yyname, yylineno-1, s, yytext);
  yyerrorstate++;
}

void yymsg(int type, char *fmt, ...){
  va_list args;
  char tmp[1024];

  va_start (args, fmt);
  vsprintf (tmp, fmt, args);
  va_end (args);

  Msg(type, "'%s', line %d : %s", yyname, yylineno-1, tmp);

  if(type == GERROR) yyerrorstate++;
}
